/******************************************************************************
* Dieses Programm dient zum Auslesen  der Informationen in                    *
* /etc/passwd mithilfe eines cgi-faehigen web-servers und eines Web-Browsers  *
******************************************************************************/

/* Die Includes werden gemacht */
/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <support.h>
#include "util.h"

/* print_filesys() oeffnet /etc/fstab und gibt den Inhalt als HTML-Tabelle aus*/
/*---------------------------------------------------------------------------*/

void print_export(void) {
	FILE					*fstab_conv_file;	  /* file-handle fuer das konvertierte 
															fstab*/
	char					host[HOSTNAME_LEN]; /* Hier wird der mit gethostname()
	                                         ermittelte Hostname gespeichert */
	int  					dummy;              /* Wird verwendet wenn ein Funktions-
	                                         ergebnis uninteressant ist */
	char					buf[MAXLINE];		  /* Hier wird eine aus /etc/passwd
	                                         gelesene Zeile gespeichert */
	char					*buf_ptr;			  /* Pointer, der beim zerlegen von buf
	                                         benoetigt wird */
	struct structExport	*export_base=NULL;
	struct structExport  *akt;
	int					x;
	
	
	x=read_exports(&export_base);
	if (DEBUG) printf("print_exports: Ergebnis von read_exports: %d<br>\n",x);
	dummy=gethostname(host,HOSTNAME_LEN);
	/*Die HTML-Tabelle wird erstellt*/
	printf("<center><h2>Exportierte Verzeichnisse auf %s</h2>\n",host);
	printf("<table border>\n");
	
	/*Tabellen&uuml;berschriften*/
	printf("<tr>\n");
		printf("<td valign=top>\n");
			printf("<strong>Pfad</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Windows-Name des Exportes</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Exportiert f&uuml;r:</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>root-Zugriff bei nfs erlaubt?</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Zugriffsart</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Zusatzoptionen bei nfs</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Zusatzoptionen bei smb</strong>\n");
		printf("</td>\n");
	printf("</tr>\n");

	if (export_base != NULL) {
		akt = export_base;
		do {
			printf("<tr>\n");
			forwardtoback(akt->path);
			printf("<td>u:%s</td>\n",akt->path);
			backtoforward(akt->path);
			if (strlen(akt->smb_name) > 0) printf("<td>%s</td>\n",akt->smb_name);
			else printf("<td>nicht gesetzt</td>\n");
			printf("<td align=center>");
			if (akt->smb_export) printf("SMB ");
			if (akt->nfs_export) {
				if (akt->smb_export) printf(", ");
				printf("NFS"); 
			}
			printf("</td>\n");
			if (akt->nfs_root_access) printf("<td align=center>ja</td>\n");
			else printf("<td align=center>nein</td>\n");
			if (akt->read_only) printf("<td align=center>nur lesen</td>\n");
			else printf("<td align=center>lesen/schreiben</td>\n");
			if (strlen(akt->nfs_common_unknown_options)+strlen(akt->nfs_unknown_options) > 0) printf("<td align=center>(%s),%s</td>\n",akt->nfs_common_unknown_options,akt->nfs_unknown_options);
			else printf("<td align=center>keine</td>\n");
			if (strlen(akt->smb_unknown_options) > 0) printf("<td align=center>%s</td>\n",akt->smb_unknown_options);
			else printf("<td align=center>keine</td>\n");
			
			printf("</tr>\n");
			akt = akt->next;			
		} while(akt != export_base);
	}	
	
	/*Die Tabelle wird beendet*/
	printf("</table></center>\n");
}


/* In main wird die HTML-Ausgabe initialisiert und alles gesteuert */
/*---------------------------------------------------------------------------*/

int main()
{
	/*Die Menues etc, die ueberall gleich sind werden ausgegeben*/
	header(EXPORT,"Exportierte Verzeichnisse");
	
	/*Das Eingabeformular fuer neue Exporte ausgeben*/
	printf("<center>\n"
			 "<form action=\"/admin-bin/export_man.html\" method=post>\n"
			 "<table border>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Windows-Name des Exports:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"smb_name\" type=text size=12 maxlength=32>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Exportpfad relativ zu u:\\</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"path\" type=text size=32 maxlength=128>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Root-Zugriff bei nfs-Exporten erlauben.</big></strong>\n"
					"</td>\n"					
					"<td valign=top>\n"
						"<input type=checkbox name=\"nfs_root_access\" value=\"nfs_root_access\">\n"
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Laufwerk nur zum Lesen exportieren.</big></strong>\n"
					"</td>\n"					
					"<td valign=top>\n"
						"<input type=checkbox name=\"read_only\" value=\"read_only\">\n"
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
				"</tr>\n"
				"<tr>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Typ des Exportes: </big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<select name=\"type\" size=3>\n"
							"<option selected>default\n"
							"<option>nfs\n"
							"<option>smb\n"
							"<option>smb und nfs\n"
						"</select>\n"
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Aktion:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<select name=\"action\" size=3>\n"
							"<option selected>freigeben\n"
							"<option>trennen\n"
							"<option>aktualisieren\n"
						"</select>\n"
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td colspan=6>\n"
						"<ul>\n"
						"<li><strong>NFS: UNIX-kompatibler Export (auch f&uuml;r Atari), "
						"SMB: Windows-kompatibler Export</strong><br>\n"
						"<li><strong>Standardm&auml;&szlig;ig wird f&uuml;r nfs und smb exportiert.</strong><br>\n"
					   "<li><strong>Freigeben:</strong>Notwendig ist der Pfad und ggf. der Windows-Name.<br>\n"
						"<li><strong>Trennen:</strong>Nur der Pfad wird beachtet.<br>\n"
						"<li><strong>Aktualisieren:</strong> Notwendig ist der Pfad des Exportierten Verzeichnisses, ausserdem m&uuml;ssen die Flags f&uuml;r Root-Access und "
						"Nur-Lesen auf jeden Fall wunschgem&auml;&szlig gesetzt werden, auch wenn sich nichts &auml;ndert. Sonst bitte nur die zu &auml;ndernden Werte angeben.<br>\n"
						"</ul>\n"
					"</td>\n"
				"</tr>\n"
			"</table>\n"
			"<p>\n"
			"<input type=submit value=\"Aktion ausf&uuml;hren\">\n"
			"</form>\n");
   printf("<hr>\n");
	printf("</center>\n");
								
	print_export();
	
	if (DEBUG) printf("Nach der Ausgabe der Tabelle<br>\n");
	
	/*Tail gibt das bei allen Seiten gleiche Ende der HTML-Anzeige aus*/
	tail();
	
	return 0;
}
