/******************************************************************************
* Dieses Programm dient zum Auslesen  der Informationen in                    *
* /etc/passwd mithilfe eines cgi-faehigen web-servers und eines Web-Browsers  *
******************************************************************************/

/* Die Includes werden gemacht */
/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <support.h>
#include "util.h"

/* print_groups() oeffnet /etc/group und gibt den Inhalt als HTML-Tabelle aus*/
/*---------------------------------------------------------------------------*/

void print_groups(void) {
	FILE 					*group_file; 		  /* file-handle fuer /etc/passwd */
	char					host[HOSTNAME_LEN]; /* Hier wird der mit gethostname()
	                                         ermittelte Hostname gespeichert */
	int  					dummy;              /* Wird verwendet wenn ein Funktions-
	                                         ergebnis uninteressant ist */
	char					buf[MAXLINE];		  /* Hier wird eine aus /etc/passwd
	                                         gelesene Zeile gespeichert */
	char					*buf_ptr;			  /* Pointer, der beim zerlegen von buf
	                                         benoetigt wird */
	char					groupname[MAXLINE]; /* In diesem String werden User-
	                                         Infos abgelegt */
	char					gid[10];			 	  /* GroupId */
	char					members[MAXLINE];	  /* Buffer fuer Username */
	char					dummy_str[MAXLINE]; /* unwichtige Strings */
	
	if (!(group_file=fopen(GROUP_NAME,"r"))) {
		printf("<center><strong>Fehler beim oeffnen von /etc/passwd zum lesen der
		        Benutzerdaten</strong></center>\n");
		return;
	}
	dummy=gethostname(host,HOSTNAME_LEN);
	/*Die HTML-Tabelle wird erstellt*/
	printf("<center><h2>Bekannte Gruppen auf %s</h2>\n",host);
	printf("<table border>\n");
	
	/*Tabellenberschriften*/
	printf("<tr>\n");
		printf("<td valign=top>\n");
			printf("<strong>Gruppen-<br>name</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Gruppen-<br>nummer</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Benutzerliste</strong>\n");
		printf("</td>\n");
	printf("</tr>\n");
	
	/*Die Benutzer werden eingetragen*/
	
	do{

		/*Einlesen einer Zeile, entspricht einem User*/
		fgets(buf,MAXLINE,group_file);

		if (!feof(group_file)){
			/*Neue Tabellenzeile einfuegen*/
			printf("<tr>");
		
			getword(groupname,buf,':');
			getword(dummy_str,buf,':');
			getword(gid,buf,':');
			getword(members,buf,'\n');
			
			printf("<td valign=top>%s</td>",groupname);

			printf("<td valign=top>%s</td>",gid);
			
			printf("<td valign=top>");
			while (strlen(members)>0) {
				getword(buf,members,',');
				if (strlen(members) > 0) printf("%s, ",buf);
				else printf("%s",buf);
			}
			printf("</td>");
			printf("</tr>\n");
		}

	}while (!feof(group_file));
	
	/*Die Tabelle wird beendet*/
	printf("</table></center>\n");
	fclose(group_file);
}


/* In main wird die HTML-Ausgabe initialisiert und alles gesteuert */
/*---------------------------------------------------------------------------*/

int main()
{
	/*Die Menues etc, die ueberall gleich sind werden ausgegeben*/
	header(GRUPPEN,"Gruppen l&ouml;schen / hinzuf&uuml;gen / &auml;ndern");
	
	/*Das Eingabeformular fuer Benutzerdaten wird ausgegeben*/
	printf("<center>\n"
			 "<form action=\"/admin-bin/group_man.html\" method=post>\n"
			 "<table border>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Gruppen<br>name:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"groupname\" type=text size=12 maxlength=32>\n"
					"</td>\n"
					"<td align=right valign=top>\n"
						"<strong><big>GruppenNr:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"group\" type=text size=5 maxlength=5>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Benutzer eintragen:</big></strong>\n"
					"</td>\n"
					"<td valign=top colspan=3>\n"
						"<input name=\"group\" type=text size=30 maxlength=60>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Benutzer entfernen:</big></strong>\n"
					"</td>\n"
					"<td valign=top colspan=3>\n"
						"<input name=\"group\" type=text size=30 maxlength=60>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Aktion:</big></strong>\n"
					"</td>\n"
					"<td valign=top colspan=3>\n"
						"<select name=\"action\" size=3>\n"
							"<option selected>eintragen\n"
							"<option>entfernen\n"
							"<option>aktualisieren\n"
						"</select>\n"
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td colspan=4>\n"
						"<ul>"
						"<li><strong>Eintragen:</strong> Notwendig ist nur der Gruppenname,"
						" bei den anderen Feldern werden dann Standardwerte verwendet.<br>\n"
						"<li><strong>Entfernen:</strong> Es wird nur der Gruppenname beachtet.<br>\n"
						"<li><strong>Aktualisieren:</strong> Es k&ouml;nnen mehrere"
						" Benutzer gleichzeitig durch Komma getrennt (ohne Leerzeichen)"
						" angegeben werden. Dabei muss die Reihenfolge nicht der"
						" Reihenfolge in die in der Gruppe angegeben ist entsprechen."
						" Bsp: user1,user2,user3,user4<br>\n"
						"</ul>"
					"</td>\n"
				"</tr>\n"
			"</table>\n"
			"<p>\n"
			"<input type=submit value=\"Aktion ausf&uuml;hren\">\n"
			"</form>\n");
   printf("<hr>\n");
								
	/*print_groups erstellt aus /etc/group eine HTML-Tabelle
	  und zeigt die eingetragenen Gruppen an*/
	print_groups();
	
	printf("</center>\n");
	
	/*Tail gibt das bei allen Seiten gleiche Ende der HTML-Anzeige aus*/
	tail();
	
	return 0;
}
