#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "util.h"

void getword(char *word, char *line, char stop) {
    int x = 0,y;

    for(x=0;((line[x]) && (line[x] != stop));x++)
        word[x] = line[x];

    word[x] = '\0';
    if(line[x]) ++x;
    y=0;

    while(line[y++] = line[x++]);
}

char *makeword(char *line, char stop) {
    int x = 0,y;
    char *word = (char *) malloc(sizeof(char) * (strlen(line) + 1));

    for(x=0;((line[x]) && (line[x] != stop));x++)
        word[x] = line[x];

    word[x] = '\0';
    if(line[x]) ++x;
    y=0;

    while(line[y++] = line[x++]);
    return word;
}

char *fmakeword(FILE *f, char stop, int *cl) {
    int wsize;
    char *word;
    int ll;

    wsize = 102400;
    ll=0;
    word = (char *) malloc(sizeof(char) * (wsize + 1));

    while(1) {
        word[ll] = (char)fgetc(f);
        if(ll==wsize) {
            word[ll+1] = '\0';
            wsize+=102400;
            word = (char *)realloc(word,sizeof(char)*(wsize+1));
        }
        --(*cl);
        if((word[ll] == stop) || (feof(f)) || (!(*cl))) {
            if(word[ll] != stop) ll++;
            word[ll] = '\0';
            return word;
        }
        ++ll;
    }
}

char x2c(char *what) {
    register char digit;

    digit = (what[0] >= 'A' ? ((what[0] & 0xdf) - 'A')+10 : (what[0] - '0'));
    digit *= 16;
    digit += (what[1] >= 'A' ? ((what[1] & 0xdf) - 'A')+10 : (what[1] - '0'));
    return(digit);
}

void unescape_url(char *url) {
    register int x,y;

    for(x=0,y=0;url[y];++x,++y) {
        if((url[x] = url[y]) == '%') {
            url[x] = x2c(&url[y+1]);
            y+=2;
        }
    }
    url[x] = '\0';
}

void plustospace(char *str) {
    register int x;

    for(x=0;str[x];x++) if(str[x] == '+') str[x] = ' ';
}

int rind(char *s, char c) {
    register int x;
    for(x=strlen(s) - 1;x != -1; x--)
        if(s[x] == c) return x;
    return -1;
}

int getline(char *s, int n, FILE *f) {
    register int i=0;

    while(1) {
        s[i] = (char)fgetc(f);

        if(s[i] == CR)
            s[i] = fgetc(f);

        if((s[i] == 0x4) || (s[i] == LF) || (i == (n-1))) {
            s[i] = '\0';
            return (feof(f) ? 1 : 0);
        }
        ++i;
    }
}

void send_fd(FILE *f, FILE *fd)
{
    int num_chars=0;
    char c;

    while (1) {
        c = fgetc(f);
        if(feof(f))
            return;
        fputc(c,fd);
    }
}

int ind(char *s, char c) {
    register int x;

    for(x=0;s[x];x++)
        if(s[x] == c) return x;

    return -1;
}

void escape_shell_cmd(char *cmd) {
    register int x,y,l;

    l=strlen(cmd);
    for(x=0;cmd[x];x++) {
        if(ind("&;`'\"|*?~<>^()[]{}$\\",cmd[x]) != -1){
            for(y=l+1;y>x;y--)
                cmd[y] = cmd[y-1];
            l++; /* length has been increased */
            cmd[x] = '\\';
            x++; /* skip the character */
        }
    }
}



/*read_users() liest die Benutzer aus /etc/passwd ein und speichert die 
  Daten in einer verketteten Liste deren Anker "base" ist*/
/*--------------------------------------------------------------------------*/
  
int read_users(struct structUser **base) {
	FILE 					*passwd_file; 		  /* file-handle fuer /etc/passwd */
	int  					dummy;              /* Wird verwendet wenn ein Funktions-
	                                         ergebnis uninteressant ist */
	char					buf[MAXLINE];		  /* Hier wird eine aus /etc/passwd
	                                         gelesene Zeile gespeichert */
	char					*buf_ptr;			  /* Pointer, der beim zerlegen von buf
	                                         benoetigt wird */
	struct structUser	*akt;					  /* Drei Pointer fuer den Zugriff*/
	struct structUser	*prev;              /* auf die Userliste */
	struct structUser	*next;
	int					i;                  /* Eine Laufvariable fuer diverse 
														  Schleifen */
	int					j;						  /* Eine 2. Laufvariable */
	char					uid_str[10];		  /* Buffer zum zwischenspeichern der
														  uid vor der Konvertierung */
	char					gid_str[10];		  /* Buffer zum zwischenspeichern der
														  gid vor der Konvertierung */
	int					shell_len;
	
	
	if (!(passwd_file=fopen(PASSWD_NAME,"r"))) {
		return PASSWD_FAILURE;
	}

	/*Die Benutzer werden eingetragen*/
	
	do{
		/*Einlesen einer Zeile, entspricht einem User*/
		fgets(buf,MAXLINE,passwd_file);

		if (!feof(passwd_file) && (strlen(buf)!=1)){
			/*Allocieren von Speicher fuer die Userdaten*/
			akt = (struct structUser *) malloc(sizeof(struct structUser));

			getword(akt->username,buf,':');
			getword(akt->password,buf,':');
			getword(uid_str,buf,':');
			akt->uid=atoi(uid_str);
			getword(gid_str,buf,':');
			akt->gid=atoi(gid_str);
			getword(akt->gecos,buf,':');
			getword(akt->homedir,buf,':');
			getword(akt->shell,buf,'\n');
				
			/*Jetzt wird der neue User in die Liste eingehngt*/
			if (*base==NULL) {
				/* Wenn die Liste noch leer ist*/
				*base=akt;
				akt->next=akt;
				akt->prev=akt;
			} else {
				prev=(*base)->prev;
				next=*base;
				prev->next=akt;
				next->prev=akt;
				akt->prev=prev;
				akt->next=next;
			}

		}		
			
	}while (!feof(passwd_file));

	/*Zu guter Letzt wird noch das passwd-file geschlossen*/
	fclose(passwd_file);

	return 0;
}


/*--------------------------------------------------------------------------*/
/*read_groups() liest die Benutzer aus /etc/group ein und speichert die 
  Daten in einer verketteten Liste, deren Anker "base" ist.*/

int read_groups(struct structGroup **base) {
	FILE 						*group_file;	  /* file-handle fuer /etc/group */
	int  						dummy;           /* Wird verwendet wenn ein Funktions-
	                                         ergebnis uninteressant ist */
	char						buf[MAXLINE];	  /* Hier wird eine aus /etc/group
	                                         gelesene Zeile gespeichert */
	char						*buf_ptr;		  /* Pointer, der beim zerlegen von buf
	                                         benoetigt wird */
	struct structGroup	*akt;				  /* Drei Pointer fuer den Zugriff*/
	struct structGroup	*prev;           /* auf die Gruppenliste */
	struct structGroup	*next;
	int						i;               /* Eine Laufvariable fuer diverse 
														  Schleifen */
	int						j;					  /* Eine 2. Laufvariable */
	char						gid_str[10];	  /* Buffer zum zwischenspeichern der
														  gid vor der Konvertierung */
	char						dummy_str[MAXLINE]; /* Wenn ein String-Ergebnis 
														  uninteressant ist */
	int						users_len;
	
	
	
	if (!(group_file=fopen(GROUP_NAME,"r"))) {
		return GROUP_FAILURE;
	}

	/*Die Gruppen werden eingetragen*/
	
	do{
		/*Einlesen einer Zeile, entspricht einer Gruppe*/
		fgets(buf,MAXLINE,group_file);

		if (!feof(group_file) && (strlen(buf)!=1)){
			/*Allocieren von Speicher fuer die Gruppendaten*/
			akt = (struct structGroup *) malloc(sizeof(struct structGroup));

			getword(akt->groupname,buf,':');
			getword(dummy_str,buf,':');
			getword(gid_str,buf,':');
			akt->gid=atoi(gid_str);
			getword(akt->users,buf,'\n');

			/*Jetzt wird die neue Gruppe in die Liste eingehngt*/
			if (*base==NULL) {
				/* Wenn die Liste noch leer ist*/
				*base=akt;
				akt->next=akt;
				akt->prev=akt;
			} else {
				prev=(*base)->prev;
				next=*base;
				prev->next=akt;
				next->prev=akt;
				akt->prev=prev;
				akt->next=next;
			}

		}		
			
	}while (!feof(group_file));

	/*Zu guter Letzt wird noch das group-file geschlossen*/
	fclose(group_file);
	
	return 0;
}



/*UserExists() gibt FALSE zurueck, wenn der als Parameter angegebene User
  unbekannt ist, sonst TRUE*/
/*--------------------------------------------------------------------------*/

int UserExists(struct structUser *base, char *name) {

	struct structUser *akt=base; /* Variable fuer aktuellen 
	                               User, am Anfang auf den ersten 
	                               gesetzt. */

	/*Wenn die Liste leer ist existiert kein User*/
	if (base==NULL) return FALSE;
	
	/*Jetzt wird die Liste durchsucht, wenn der User gefunden wird
	  wird die Funktion verlassen*/
	do{
		if (0==strcmp(akt->username,name)) return TRUE;
		akt=akt->next;	
	}while (akt!=base);

	/*Wenn der User in der Liste nicht gefunden wurde existiert er nicht*/
	return FALSE;

} 


/*GnameExists() gibt FALSE zurueck, wenn der als Parameter angegebene 
  Gruppenname unbekannt ist, sonst TRUE*/
/*--------------------------------------------------------------------------*/

int GnameExists(struct structGroup *base, char *name) {

	struct structGroup *akt=base; /* Variable fuer aktuellen 
	                               User, am Anfang auf den ersten 
	                               gesetzt. */

	/*Wenn die Liste leer ist existiert kein User*/
	if (base==NULL) return FALSE;
	
	/*Jetzt wird die Liste durchsucht, wenn der User gefunden wird
	  wird die Funktion verlassen*/
	do{
		if (0==strcmp(akt->groupname,name)) return TRUE;
		akt=akt->next;	
	}while (akt!=base);

	/*Wenn der User in der Liste nicht gefunden wurde existiert er nicht*/
	return FALSE;

} 


/*UidExists() gibt FALSE zurueck, wenn die als Parameter angegebene UserId
  unbekannt ist, sonst TRUE*/
/*--------------------------------------------------------------------------*/

int UidExists(struct structUser *base, int uid) {

	struct structUser *akt=base; /* Variable fuer aktuellen 
	                               User, am Anfang auf den ersten 
	                               gesetzt. */

	/*Wenn die Liste leer ist existiert keine Uid*/
	if (base==NULL) return FALSE;
	
	/*Jetzt wird die Liste durchsucht, wenn die Uid gefunden wird
	  wird die Funktion verlassen*/
	do{
		if (akt->uid==uid) return TRUE;
		akt=akt->next;	
	}while (akt!=base);

	/*Wenn die Uid in der Liste nicht gefunden wurde existiert sie nicht*/
	return FALSE;

} 


/*GidExists() gibt FALSE zurueck, wenn die als Parameter angegebene Gid
  unbekannt ist, sonst TRUE*/
/*--------------------------------------------------------------------------*/

int GidExists(struct structGroup *base, int gid) {

	struct structGroup *akt=base; /* Variable fuer aktuellen 
	                               User, am Anfang auf den ersten 
	                               gesetzt. */

	/*Wenn die Liste leer ist existieren keine Gruppen*/
	if (base==NULL) return FALSE;
	
	/*Jetzt wird die Liste durchsucht, wenn der User gefunden wird
	  wird die Funktion verlassen*/
	do{
		if (akt->gid==gid) return TRUE;
		akt=akt->next;	
	}while (akt!=base);

	/*Wenn die Gruppe in der Liste nicht gefunden wurde existiert sie nicht*/
	return FALSE;

} 


/*header() gibt den bei jedem cgi-skript gleichen Anfang der HTML-Ausgabe aus,
  dabei bedeutet pressed_button, welcher der Menu-Buttons gedrueckt sein soll,
  und header, welche Ueberschrift die Seite haben soll.*/
/*---------------------------------------------------------------------------*/

void header(int pressed_button, char* header) {

	/*Diese Zeile ist notwendig, damit die folgenden Ausgaben vom Web-Browser
	  erkannt und als html-code interpretiert werden*/
	printf("Content-type: text/html\n\n");
	/*Jetzt wird die Seite aufgebaut*/
	printf("<html>\n");
	printf("<head>\n");
	printf("<title>MiNT'98 / AdMiNTools</title>\n");
	printf("</head>\n");
	printf("<body background=\"/admin/img/background.gif\">\n");
	printf("<table align=left>\n");
	printf("<tr>\n");
	printf("<td width=90 align=center>\n");
	printf("<img src=\"/admin/img/mint-logo.gif\" alt=\"Logo MiNT'98\" height=64 width=88><br>\n");
	printf("</td>\n");
	printf("<td>\n");
	printf("<img src=\"/admin/img/platzn.gif\" alt=\" \" width=20 height=10>\n");
	printf("</td>\n");
	printf("<td valign=bottom align=center>\n");
	printf("<h2>%s</h2>\n",header);
	printf("<hr>\n");
	printf("</td>\n");
	printf("</tr>\n");
	printf("<tr>\n");
	printf("<td width=90 align=center valign=top>\n");

	if (pressed_button==BENUTZER)		
		printf("<a href=\"/admin-bin/show_users?%08lx\"><img src=\"/admin/img/users_pressed.gif\" alt=\"Benutzer\" height=64 width=88 border=0></a><br>\n",get_ticks());
	else
		printf("<a href=\"/admin-bin/show_users?%08lx\"><img src=\"/admin/img/users.gif\" alt=\"Benutzer\" height=64 width=88 border=0></a><br>\n",get_ticks());

	if (pressed_button==GRUPPEN)
		printf("<a href=\"/admin-bin/show_groups?%08lx\"><img src=\"/admin/img/group_pressed.gif\" alt=\"Gruppen\" height=64 width=88 border=0></a><br>\n",get_ticks());
	else
		printf("<a href=\"/admin-bin/show_groups?%08lx\"><img src=\"/admin/img/group.gif\" alt=\"Gruppen\" height=64 width=88 border=0></a><br>\n",get_ticks());

	if (pressed_button==DATEISYSTEME)		
		printf("<a href=\"/admin-bin/show_filesys?%08lx\"><img src=\"/admin/img/filesys_pressed.gif\" alt=\"Dateisysteme\" height=64 width=88 border=0></a><br>\n",get_ticks());
	else
		printf("<a href=\"/admin-bin/show_filesys?%08lx\"><img src=\"/admin/img/filesys.gif\" alt=\"Dateisysteme\" height=64 width=88 border=0></a><br>\n",get_ticks());

	if (pressed_button==DRUCKER)		
		printf("<a href=\"/admin-bin/show_printers?%08lx\"><img src=\"/admin/img/printer_pressed.gif\" alt=\"Drucker\" height=64 width=88 border=0></a><br>\n",get_ticks());
	else
		printf("<a href=\"/admin-bin/show_printers?%08lx\"><img src=\"/admin/img/printer.gif\" alt=\"Drucker\" height=64 width=88 border=0></a><br>\n",get_ticks());

	if (pressed_button==DIENSTE)		
		printf("<a href=\"/admin-bin/show_services?%08lx\"><img src=\"/admin/img/runlevel_pressed.gif\" alt=\"Dienste\" height=64 width=88 border=0></a><br>\n",get_ticks());
	else
		printf("<a href=\"/admin-bin/show_services?%08lx\"><img src=\"/admin/img/runlevel.gif\" alt=\"Dienste\" height=64 width=88 border=0></a><br>\n",get_ticks());

	if (pressed_button==NETZWERK)		
		printf("<a href=\"/admin-bin/show_netconfig?%08lx\"><img src=\"/admin/img/network_pressed.gif\" alt=\"Netzwerk\" height=64 width=88 border=0></a><br>\n",get_ticks());
	else
		printf("<a href=\"/admin-bin/show_netconfig?%08lx\"><img src=\"/admin/img/network.gif\" alt=\"Netzwerk\" height=64 width=88 border=0></a><br>\n",get_ticks());

	if (pressed_button==RECHNERLISTE)		
		printf("<a href=\"/admin-bin/show_hosts?%08lx\"><img src=\"/admin/img/hosts_pressed.gif\" alt=\"Rechnerliste\" height=64 width=88 border=0></a><br>\n",get_ticks());
	else
		printf("<a href=\"/admin-bin/show_hosts?%08lx\"><img src=\"/admin/img/hosts.gif\" alt=\"Rechnerliste\" height=64 width=88 border=0></a><br>\n",get_ticks());

	if (pressed_button==EXPORT)		
		printf("<a href=\"/admin-bin/show_exports?%08lx\"><img src=\"/admin/img/shares_pressed.gif\" alt=\"Freigabe\" height=64 width=88 border=0></a><br>\n",get_ticks());
	else
		printf("<a href=\"/admin-bin/show_exports?%08lx\"><img src=\"/admin/img/shares.gif\" alt=\"Freigabe\" height=64 width=88 border=0></a><br>\n",get_ticks());

	if (pressed_button==IMPORT)		
		printf("<a href=\"/admin-bin/show_imports?%08lx\"><img src=\"/admin/img/imports_pressed.gif\" alt=\"Import\" height=64 width=88 border=0></a><br>\n",get_ticks());
	else
		printf("<a href=\"/admin-bin/show_imports?%08lx\"><img src=\"/admin/img/imports.gif\" alt=\"Import\" height=64 width=88 border=0></a><br>\n",get_ticks());

	printf("<a href=\"/admin/index.html\"><img src=\"/admin/img/docu.gif\" alt=\"Dokumentation\" height=64 width=88 border=0></a><br>\n");
	printf("</td>\n");
	printf("<td>\n");
	printf("</td>\n");
	printf("<td valign=top>\n");
}



/*tail() gibt das bei jedem cgi-skript gleiche Ende der HTML-Ausgabe aus*/
/*---------------------------------------------------------------------------*/
void tail(void) {
	printf("</td>\n");
	printf("</tr>\n");
	printf("</table>\n");
	printf("</body>\n");
	printf("</html>\n");
}


/*isNumber() prueft, ob der als Parameter angegebene String eine Zahl ist*/
/*---------------------------------------------------------------------------*/

int isNumber(char *number_str){
	int i;
	
	if (!strlen(number_str)) return FALSE;
   for(i=0;(i < strlen(number_str));i++)
      if (!isdigit((int) number_str[i])) return FALSE;

	return TRUE;
}


/*get_unused_uid liefert die erste nicht benutzte Uid >= 200 zurueck*/
/*---------------------------------------------------------------------------*/

int get_unused_uid(struct structUser *base) {
	struct structUser *akt;
	long int	uid;
	
	akt=base;
	while ((akt->uid < 200) && (akt->next != base)) akt=akt->next;
	if (akt->uid!=200) uid=200;
	else {
		do{
			uid=akt->uid+1;
			akt=akt->next;
		}while (akt->uid == uid);
	}
	return uid;
}

/*get_unused_gid liefert die erste nicht benutzte Gid >= 100 zurueck*/
/*---------------------------------------------------------------------------*/

int get_unused_gid(struct structGroup *base) {
	struct structGroup *akt;
	long int	gid;
	
	akt=base;
	while ((akt->gid < 100) && (akt->next != base)) akt=akt->next;
	if (akt->gid!=100) gid=100;
	else {
		do{
			gid=akt->gid+1;
			akt=akt->next;
		}while (akt->gid == gid);
	}
	return gid;
}


/*new_group erzeugt eine neue Gruppe gemaess den Parametern. Keine 
  Fehlerchecks!*/
/*---------------------------------------------------------------------------*/

void new_group(struct structGroup *base,long int gid,char* gname){
	struct structGroup *new_group;
	struct structGroup *prev;
	struct structGroup *next;

	new_group = (struct structGroup *) malloc(sizeof(struct structGroup));
	new_group->gid = gid;
	strcpy(new_group->groupname,gname);
	strcpy(new_group->users,"");
	
	prev=base;
	next=base->next;
	while (next->gid <= new_group->gid){
		next=next->next;
		prev=prev->next;
	}
	prev->next=new_group;
	next->prev=new_group;
	new_group->next=next;
	new_group->prev=prev;	
}

/*UserInGroup() stellt fest, ob der Benutzer "name" in der Gruppe "group" 
  eingetragen ist*/
/*---------------------------------------------------------------------------*/
int UserInGroup(struct structGroup *group,char* name) {
	char	userlist[MAXLINE];
	char	buffer[MAXLINE];
	
	strcpy(userlist,group->users);
	while (strlen(userlist) > 0) {
		getword(buffer,userlist,',');
		if (!strcmp(buffer,name)) return TRUE;
	}
	return FALSE;
}

/*delUserFromGroup() loescht den User "name" aus der Gruppe "group"*/
/*---------------------------------------------------------------------------*/
void delUserFromGroup(struct structGroup *group,char* name) {
	char	userlist[MAXLINE];
	char	buffer[MAXLINE];
	char	*dummy_str;
	
	dummy_str=(char*) malloc(sizeof(char)*MAXLINE);
	strcpy(userlist,"");
	while (strlen(group->users) > 0) {
		getword(buffer,group->users,',');
		if (strcmp(buffer,name)) {
			if (strlen(userlist) > 0) dummy_str=strcat(userlist,",");
			dummy_str=strcat(userlist,buffer);
		}
	}
	strcpy(group->users,userlist);
	free(dummy_str);
}


/*GroupnameUsed() ist TRUE wenn der Groupname schon vorhanden ist, sonst false*/
/*----------------------------------------------------------------------------*/
int GroupnameUsed(struct structGroup *base,char *name) {
	struct structGroup *akt;
	
	akt=base;
	do{
		if (!strcmp(name,akt->groupname)) return TRUE;
		akt=akt->next;
	}while(akt != base);
	return FALSE;
}

/*getGroupId() liefert die Id einer group. Wenn die group nicht existiert ist
  der returnwert undefiniert!*/
/*----------------------------------------------------------------------------*/
int getGroupId(struct structGroup *base,char *name) {
	struct structGroup *akt;
	
	akt=base;
	do{
		if (!strcmp(name,akt->groupname)) return akt->gid;
		akt=akt->next;
	}while(akt != base);
}


/*getGroupName() liefert den Namen einer group. Wenn die group nicht existiert ist
  der returnwert undefiniert!*/
/*----------------------------------------------------------------------------*/
char *getGroupName(struct structGroup *base,long int id) {
	struct structGroup	*akt;
	char						*name;
	
	akt=base;
	do{
		if (id == akt->gid) {
			name=(char*) malloc(sizeof(char)*MAXLINE);
			strcpy(name,akt->groupname);
			return name;
		}
		akt=akt->next;
	}while(akt != base);
}


/*addUserToGroup() traegt einen User in einer Gruppe ein*/
/*----------------------------------------------------------------------------*/
void addUserToGroup(struct structGroup *group,char* username) {

	char	*buffer;

	buffer=(char*) malloc(sizeof(char)*MAXLINE);	
	
	/*Wenn schon Benutzer drin sind, mit Komma anhaengen, sonst als einzigen
	  eintragen*/
	if (strlen(group->users) > 0) { 
		sprintf(buffer,"%s,%s",group->users,username);
		if (DEBUG) printf("addUserToGroup: es sind schon benutzer vorhanden, neue Liste: %s<br>",buffer);
	}
	else {
		sprintf(buffer,"%s",username);
		if (DEBUG) printf("addUserToGroup: es sind keine Benutzer vorhanden, Liste: %s<br>",buffer);	
	}
	strcpy(group->users,buffer);
	free(buffer);
}

/*verbose_permissions() setzt die Zahlen die die Rechte einer Datei beschreiben
  in entsprechende Buchstabentripel um.*/
/*----------------------------------------------------------------------------*/
char *verbose_permissions(char *permissions) {
	char						*perm_string;
	char						*dummy_str;
	int						i;
	
	perm_string = (char *) malloc(MAXLINE);
	dummy_str = (char *) malloc(MAXLINE);
	strcpy(perm_string,"");
	for (i=0;i<=2;i++) {
		switch (permissions[i]) {
			case '0' : dummy_str=strcat(perm_string,"---&nbsp;");
				break;
			case '1' : dummy_str=strcat(perm_string,"--x&nbsp;");
				break;
			case '2' : dummy_str=strcat(perm_string,"-w-&nbsp;");
				break;
			case '3' : dummy_str=strcat(perm_string,"-wx&nbsp;");
				break;
			case '4' : dummy_str=strcat(perm_string,"r--&nbsp;");
				break;
			case '5' : dummy_str=strcat(perm_string,"r-x&nbsp;");
				break;
			case '6' : dummy_str=strcat(perm_string,"rw-&nbsp;");
				break;
			case '7' : dummy_str=strcat(perm_string,"rwx&nbsp;");
				break;
		}
	}
	if (strlen(perm_string) == 0) strcpy(perm_string,"Unbekannte Rechte");
	return perm_string;	
}

/*IsValidMountpoint() liefert TRUE wenn der als Parameter angegebene Pfad
  ein moeglicher Mountpoint ist, sonst FALSE*/
/*----------------------------------------------------------------------------*/
int IsValidMountpoint(struct structFilesys *filesys_base, struct structImport *import_base, char *path) {

	/*Diese Funktion ist zur Zeit ein Dummy, es muss noch passender Code
	  generiert werden*/
	
	if (DEBUG)
	printf("IsValidMountpoint: path: %s FilesysExistsByMount: %d ImportExists: %d",path,
				FilesysExistsByMount(filesys_base,path),ImportExists(import_base,path));
	
	if ( (FilesysExistsByMount(filesys_base,path) && strcmp(path,"/")) 
		|| (ImportExists(import_base,path)) ) return FALSE; 
	else return TRUE;
}  

/*read_filesys() liest die filesysteme ein und liefert einen passenden
  Pointer auf eine doppelt verkettete Ringliste*/
/*----------------------------------------------------------------------------*/
int read_filesys(struct structFilesys **base) {

	FILE 						*fstab_conv_file;	  /* file-handle fuer fstab */
	int  						dummy;           /* Wird verwendet wenn ein Funktions-
	                                         ergebnis uninteressant ist */
	char						buf[MAXLINE];	  /* Hier wird eine aus /etc/group
	                                         gelesene Zeile gespeichert */
	struct structFilesys	*akt;				  /* Drei Pointer fuer den Zugriff*/
	char						dummy_str[MAXLINE]; /* Wenn ein String-Ergebnis 
														  uninteressant ist */
	char					drive[MAXLINE];			/* zu mountendes Drive */
	char					mountpoint[MAXLINE];		/* Mountpoint */
	char					type[MAXLINE];			/* Typ des fs */
	char					owner[MAXLINE];		/* Name des Besitzers */
	char					group[MAXLINE];		/* Name der Gruppe */
	char					permissions[MAXLINE];	/* Name der Gruppe */

	/*Die Konvertierung der fstab wird von einem sh-skript erledigt*/
	system(CONV_FSTAB_CMD);
	
	if (!(fstab_conv_file=fopen(FSTAB_CONV_NAME,"r"))) {
		printf("<center><strong>Fehler beim oeffnen von /etc/fstab zum lesen der"
		        "Benutzerdaten</strong></center>\n");
		return FILESYS_FAILURE;
	}

	if (DEBUG) printf("read_filesys: /tmp/fstab.converted wurde gelesen<br>");

	do{

		/*Einlesen einer Zeile, entspricht einem User*/
		fgets(buf,MAXLINE,fstab_conv_file);

		if (!feof(fstab_conv_file)  && (strlen(buf) != 1)){
		
			getword(drive,buf,'%');
			/*Wenn drive leer ist handelt es sich um eine Leerzeile*/
			if (strcmp(drive,"")) { 
				getword(mountpoint,buf,'%');
				getword(type,buf,'%');
				getword(owner,buf,'%');
				getword(group,buf,'%');
				getword(permissions,buf,'.');
				if (DEBUG) printf("read_filesys: drive: %s, mountpoint:"
										" %s, type: %s, owner: %s, group: %s, perms: %s",
										drive,mountpoint,type,owner,group,permissions);
				if (strcmp(type,"nfs")) {
					if (DEBUG) printf("read_filesys: ->einfuegen!<br>");
					akt = (struct structFilesys *) malloc(sizeof(struct structFilesys));
					strcpy(akt->drive,drive);
					strcpy(akt->mountpoint,mountpoint);
					strcpy(akt->type,type);
					strcpy(akt->owner,owner);
					strcpy(akt->group,group);
					strcpy(akt->permissions,permissions);
					addFilesys(&(*base),akt);
				}
			}
		}

	}while (!feof(fstab_conv_file));
	
	fclose(fstab_conv_file);

	return 0;
}

/*read_imports() liest die importe ein und liefert einen passenden
  Pointer auf eine doppelt verkettete Ringliste*/
/*----------------------------------------------------------------------------*/
int read_imports(struct structImport **base) {

	FILE 						*fstab_conv_file;	  		/* file-handle fuer fstab */
	FILE 						*mtab_file;				  	/* file-handle fuer mtab */
	int  						dummy;           			/* Wird verwendet wenn ein Funktions-
	                                         		ergebnis uninteressant ist */
	char						buf[MAXLINE];	 			/* Hier wird eine aus /etc/group
	                                    	      gelesene Zeile gespeichert */
	char						buf_bak[MAXLINE];
	struct structImport	*akt;				  			/* Drei Pointer fuer den Zugriff*/
	char						dummy_str[MAXLINE]; 		/* Wenn ein String-Ergebnis 
														  		uninteressant ist */
	char						options[MAXLINE];
	char						option_name[MAXLINE];
	int						i;
	int						counter;
	char						server[MAXLINE];			/* zu mountendes Drive */
	char						serverpath[MAXLINE];
	char						mountpoint[MAXLINE];		/* Mountpoint */
	char						type[MAXLINE];				/* Typ des fs */
	int						blocksize=0;				/* Name des Besitzers */
	int						retries=0;					/* Name der Gruppe */

	/*Die Konvertierung der fstab wird von einem sh-skript erledigt*/
	system(CONV_FSTAB_CMD);
	
	if (!(fstab_conv_file=fopen(FSTAB_CONV_NAME,"r"))) {
		printf("<center><strong>Fehler beim oeffnen von /etc/fstab zum lesen der
		        Filesysteme</strong></center>\n");
		return FILESYS_FAILURE;
	}
	
	if (!(mtab_file=fopen(MTAB_NAME,"r"))) {
		printf("<center><strong>Fehler beim oeffnen von /etc/mtab zum lesen der
		        aktuellen mounts</strong></center>\n");
		return IMPORT_FAILURE;
	}

	do{

		/*Einlesen einer Zeile, entspricht einem FS*/
		fgets(buf,MAXLINE,fstab_conv_file);

		if (!feof(fstab_conv_file) && (strlen(buf) != 1)){
		
			getword(server,buf,':');
			/*Wenn drive leer ist handelt es sich um eine Leerzeile*/
			if (strcmp(server,"")) {
				getword(serverpath,buf,'%'); 
				getword(mountpoint,buf,'%');
				getword(type,buf,'%');
				getword(dummy_str,buf,'%');
				if (isNumber(dummy_str))
					blocksize = atoi(dummy_str);
				else
					blocksize = DEF_BLOCKSIZE;
				getword(dummy_str,buf,'%');
				if (isNumber(dummy_str))
					retries = atoi(dummy_str);
				else
					retries = DEF_RETRANS;
				if (!strcmp(type,"nfs")) {
					akt = (struct structImport *) malloc(sizeof(struct structImport));
					strcpy(akt->server,server);
					strcpy(akt->serverpath,serverpath);
					strcpy(akt->mountpoint,mountpoint);
					strcpy(akt->type,type);
					akt->blocksize=blocksize;
					akt->retries=retries;
					akt->mounted = FALSE;
					akt->bootloaded = TRUE;
					if (DEBUG) printf("read_imports: lesen von fstab, Parameter f&uuml;r addImport: %s %s %s %s %d %d %d %d<br>",
								akt->server,
								akt->serverpath,
								akt->mountpoint,
								akt->type,
								akt->blocksize,
								akt->retries,
								akt->mounted,
								akt->bootloaded);
					addImport(&(*base),akt);
				}
			}
		}

	}while (!feof(fstab_conv_file));
	
	fclose(fstab_conv_file);

	do{

		/*Einlesen einer Zeile, entspricht einem FS*/
		fgets(buf,MAXLINE,mtab_file);

		if (!feof(mtab_file) && (strlen(buf)!=1) && (buf[0]!='%')){
		
			getword(server,buf,':');
			getword(serverpath,buf,' ');
			getword(mountpoint,buf,' ');
			getword(type,buf,' ');
			strcpy(buf_bak,buf);
			getword(options,buf_bak,' ');
			
			/*Parsen der Mountoptionen*/
			if (!strcmp(options,"defaults")) {
				blocksize=DEF_BLOCKSIZE;
				retries=DEF_RETRANS;
			} else {
				i=0;
				counter=0;
				while (options[i] != '\0') {
					if (options[i] == '=') counter++;
					i++;
				}
				while (i>0) {
					getword(option_name,buf,'=');
					
					/* Wenn es der letzte Parameter ist, dann ist das 
					   nachfolgende Zeichen kein Komma, sondern ein Leerzeichen*/
					if (i>1) getword(dummy_str,buf,',');
					else getword(dummy_str,buf,' ');
					if (!strcmp(option_name,"wsize")) blocksize = atoi(dummy_str);
					if (!strcmp(option_name,"rsize")) blocksize = atoi(dummy_str);
					if (!strcmp(option_name,"retrans")) retries = atoi(dummy_str);
					i--;
				}
				if (blocksize == 0) blocksize=4096;
				if (retries == 0) retries=5;
			}
			
			backtoforward(mountpoint);
			if (!strcmp(type,"nfs")) {
				akt = (struct structImport *) malloc(sizeof(struct structImport));
				strcpy(akt->server,server);
				strcpy(akt->serverpath,serverpath);
				strcpy(akt->mountpoint,mountpoint);
				strcpy(akt->type,"nfs");
				akt->blocksize=blocksize;
				akt->retries=retries;
				akt->mounted = TRUE;
				akt->bootloaded = FALSE;
				if (DEBUG) printf("read_imports: mtab: Werte: %s %s %s %s %d %d %d %d<br>",
										 akt->server,
										 akt->serverpath,
										 akt->mountpoint,
										 akt->type,
										 akt->blocksize,
										 akt->retries,
										 akt->mounted,
										 akt->bootloaded);
				if (!ImportExists(*base,mountpoint)) {
					if (DEBUG) printf("read_imports: mtab: Import existiert noch nicht, rufe addImport auf<br>");
					addImport(&(*base),akt);
				}
				else {
					if (DEBUG) printf("read_imports: mtab: Import existiert, aendere mount-status<br>");
					akt = GetImport(*base,mountpoint);
					akt->mounted = 1;
				}
			}
		}

	}while (!feof(mtab_file));
	
	fclose(mtab_file);
	
	return 0;
}

/*GetImport() liefert einen Pointer auf einen durch seinen Mountpoint 
  definierten Import*/
/*----------------------------------------------------------------------------*/
struct structImport *GetImport(struct structImport *base,char *mountpoint_searched) {
	struct structImport *akt;
	
	akt = base;
	do {
		if (DEBUG) printf("GetImport: akt->mountpoint: %s, mountpoint_searched: %s<br>\n",
		                  akt->mountpoint,mountpoint_searched);
		if (!strcmp(akt->mountpoint,mountpoint_searched)) return akt;
		else akt = akt->next;
	} while (akt != base); 
}


/*GetFilesys() liefert einen Pointer auf ein durch seinen Partitionsnamen
  definiertes filesys*/
/*----------------------------------------------------------------------------*/

struct structFilesys *GetFilesys(struct structFilesys *base,char *drive_searched) {
	struct structFilesys *akt;
	
	akt = base;
	do {
		if (!strcmp(akt->drive,drive_searched)) return akt;
		else akt = akt->next;
	} while (akt != base); 
}

/*ImportExists liefert TRUE,  wenn der durch den Mountpoint spezifizierte
  Import bereits existiert, sonst FALSE*/
/*----------------------------------------------------------------------------*/
int ImportExists(struct structImport *base,char *mountpoint_searched) {
	struct structImport *akt;
	
	akt = base;
	
	if (akt == NULL) return FALSE;

	
	do { 
		if (DEBUG) printf("ImportExists: akt->server: %s akt->serverpath: %s akt->mountpoint: %s mountpoint: %s<br>",
								akt->server,akt->serverpath,akt->mountpoint,mountpoint_searched);
		if (!strcmp(akt->mountpoint,mountpoint_searched)) {
			return TRUE;
		}
		else {
			akt = akt->next;
		}
	} while (akt != base);
	return FALSE;
}


/*backtoforward() ersetzt backslashes in einem String durch vorwaertsslashes*/
/*----------------------------------------------------------------------------*/
void backtoforward(char *str) {
    register int x;

    for(x=0;str[x];x++) if(str[x] == '\\') str[x] = '/';
}

/*forwardtoback() ersetzt vorwaertsslashes in einem String durch backslashes*/
/*----------------------------------------------------------------------------*/
void forwardtoback(char *str) {
    register int x;

    for(x=0;str[x];x++) if(str[x] == '/') str[x] = '\\';
}

/*addFilesys() traegt ein Filesystem in der fs-liste ein*/
/*----------------------------------------------------------------------------*/
void addFilesys(struct structFilesys **base,struct structFilesys *filesys) {

	struct structFilesys *next;
	struct structFilesys *prev;

	prev = *base;
	
	if (*base == NULL) {
		*base = filesys;
		filesys->next = filesys;
		filesys->prev = filesys;
	}
	else {
		while ((strcmp(prev->drive,filesys->drive) < 0) && (prev->next != *base)) prev = prev->next;
		next = prev->next;
		prev->next = filesys;
		next->prev = filesys;
		filesys->next = next;
		filesys->prev = prev;
	}

}

/*addImport() traegt einen Import in der Importliste ein*/
/*----------------------------------------------------------------------------*/
void addImport(struct structImport **base,struct structImport *import) {

	struct structImport *next;
	struct structImport *prev;

	prev = *base;
	
	if (DEBUG) printf("addImport: Addiere: server: %s serverpath: %s mountpoint: %s type: %s"
	                  "blocksize: %d retries: %d mounted: %d bootloaded: %d<br>\n",
	                  import->server,
	                  import->serverpath,
	                  import->mountpoint,
	                  import->type,
	                  import->blocksize,
	                  import->retries,
	                  import->mounted,
	                  import->bootloaded);
	
	if (*base == NULL) {
		*base = import;
		import->next = import;
		import->prev = import;
	}
	else {
		while ((strcmp(prev->server,import->server) < 0) && (prev->next != *base)) prev = prev->next;
		next = prev->next;
		prev->next = import;
		next->prev = import;
		import->next = next;
		import->prev = prev;
	}

}

/*FilesysExistsByMount liefert TRUE,  wenn das durch den Mountpoint spezifizierte
  Filesystem bereits existiert, sonst FALSE*/
/*----------------------------------------------------------------------------*/
int FilesysExistsByMount(struct structFilesys *base,char *mountpoint_searched) {
	struct structFilesys *akt;
	
	akt = base;

	if (akt == NULL) return FALSE;

	do {
		if (!strcmp(akt->mountpoint,mountpoint_searched)) return TRUE;
		else akt = akt->next;
	} while (akt != base); 
	return FALSE;
}

/*FilesysExistsByPart liefert TRUE,  wenn das durch den Partitionsbuchstaben
  spezifizierte Filesystem bereits existiert, sonst FALSE*/
/*----------------------------------------------------------------------------*/
int FilesysExistsByPart(struct structFilesys *base,char *drive_searched) {
	struct structFilesys *akt;
	
	akt = base;

	if (akt == NULL) return FALSE;

	do {
		if (DEBUG) printf("FilesysExistsByPart: akt->drive: %s, drive_searched: %s<br>",akt->drive,drive_searched);
		if (!strcmp(akt->drive,drive_searched)) return TRUE;
		else akt = akt->next;
	} while (akt != base);
	return FALSE;
}

/*FlushFstab schreibt die Datei /etc/fstab*/
/*----------------------------------------------------------------------------*/
void FlushFstab(struct structFilesys *filesys_base,struct structImport *import_base) {
	struct structFilesys *akt_filesys;
	struct structImport	*akt_import;
	FILE						*fstab_file;
	char						*cmdstr;
	
	cmdstr=(char *) malloc(sizeof(char) * MAXLINE);
	
	system("cp " FSTAB_NAME " " FSTAB_BAK_NAME);	

	if (!(fstab_file=fopen(FSTAB_NAME,"wb"))) {
		printf("<center><strong>Fehler beim oeffnen von /etc/fstab zum schreiben
		der Eintraege</strong></center>\n");
	} else {

	
	
		akt_filesys = filesys_base;
		if (akt_filesys != NULL) {
			do {
				fprintf(fstab_file,"%s %s %s %s %s %s\n",akt_filesys->drive
																	,akt_filesys->mountpoint
																	,akt_filesys->type
																	,akt_filesys->owner
																	,akt_filesys->group
																	,akt_filesys->permissions);
				akt_filesys = akt_filesys->next;
			}while (akt_filesys != filesys_base);
		}
		
		akt_import = import_base;
		if (akt_import != NULL) {
			do {
				if (DEBUG) printf("FlushFstab: flushing %s",akt_import->mountpoint);
				if (akt_import->bootloaded)
					fprintf(fstab_file,"%s:%s %s %s %d %d -\n",akt_import->server
																	,akt_import->serverpath
																	,akt_import->mountpoint
																	,akt_import->type
																	,akt_import->blocksize
																	,akt_import->retries);
				akt_import = akt_import->next;
			} 	while (akt_import != import_base);
		}
	
		fclose(fstab_file);
	}
}

/*delFilesys loescht ein Filesystem aus der Liste*/
/*----------------------------------------------------------------------------*/
int delFilesys(struct structFilesys **base,char *drive_to_delete) {
	struct structFilesys *akt;
	struct structFilesys *akt_old;
	struct structFilesys *next;
	struct structFilesys *prev;	
	
	
	akt = *base;
	if (akt->next == *base) {
		*base=NULL;
		return TRUE;
	}
	do {
		if (DEBUG) printf("delFilesys: akt->drive: %s drive_to_delete %s<br>",
		                  akt->drive,drive_to_delete);
		if (!strcmp(akt->drive,drive_to_delete)) {
			if (DEBUG) printf("delFilesys: drive: %s wird entfernt<br>",
			                   akt->drive);
			next=akt->next;
			prev=akt->prev;
			prev->next=next;
			next->prev=prev;
			akt_old=akt;
			akt=next;
			if (akt_old == *base) *base=akt;
			free(akt_old);
		}
		else akt = akt->next;
	} 	while (akt != *base); 
	return FALSE;
}

/*delImport loescht einen Import aus der Liste*/
/*----------------------------------------------------------------------------*/
int delImport(struct structImport **base,char *mount_to_delete) {
	struct structImport *akt;
	struct structImport *akt_old;
	struct structImport *next;
	struct structImport *prev;	
	
	
	akt = *base;
	if (akt->next == *base) {
		*base=NULL;
		return TRUE;
	}
	do {
		if (DEBUG) printf("delImport: akt->mountpoint: %s mount_to_delete %s<br>",
		                  akt->mountpoint,mount_to_delete);
		if (!strcmp(akt->mountpoint,mount_to_delete)) {
			if (DEBUG) printf("delImport: Mountpoint: %s wird entfernt<br>",
			                   akt->mountpoint);
			next=akt->next;
			prev=akt->prev;
			prev->next=next;
			next->prev=prev;
			akt_old=akt;
			akt=next;
			if (akt_old == *base) *base=akt;
			free(akt_old);
		}
		else akt = akt->next;
	} 	while (akt != *base); 
	return FALSE;
}

/*ImportMounted liefert TRUE,  wenn der durch den Mountpoint spezifizierte
  Import aktiv ist, sonst FALSE*/
/*----------------------------------------------------------------------------*/
int ImportMounted(struct structImport *base,char *mountpoint_searched) {
	struct structImport *akt;
	
	akt = base;
	do { 
		if (DEBUG) printf("ImportMounted: akt->server: %s akt->serverpath: %s akt->mountpoint: %s mountpoint: %s<br>",
								akt->server,akt->serverpath,akt->mountpoint,mountpoint_searched);
		if (!strcmp(akt->mountpoint,mountpoint_searched)) return akt->mounted;
		else {
			akt = akt->next;
		}
	} while (akt != base);
	return FALSE;
}

/*DirExists liefert TRUE wenn das als Parameter uebergebene Dir existiert,
  sonst FALSE*/
/*----------------------------------------------------------------------------*/
int DirExists(char *path) {

	char akt_dir[MAXLINE];
	char *dummy_str;
	
	
	dummy_str = getcwd(akt_dir,MAXLINE);
	if (chdir(path) == 0) {
		chdir(akt_dir);
		return TRUE;
	} else {
		return FALSE;
	}
}

/*ContainsSlashes() prueft, ob der als Parameter angegebene String "/" oder "\"
  enthaelt*/
/*---------------------------------------------------------------------------*/

int containsSlashes(char *number_str){
	int i;
	
   for(i=0;(i < strlen(number_str));i++)
      if ((number_str[i] == '\\') || (number_str[i] == '/')) return TRUE;

	return FALSE;
}

/*read_services() liest die verfuegbaren und aktiven Dienste ein und liefert 
  einen passenden Pointer auf eine doppelt verkettete Ringliste*/
/*----------------------------------------------------------------------------*/
int read_services(struct structService **base) {

	FILE 						*avl_svc_file;	  			/* file-handle fuer avail.services */
	FILE 						*net_svc_file;				/* file-handle fuer net.services */
	FILE 						*add_svc_file;				/* file-handle fuer add.services */
	FILE 						*std_svc_file;				/* file-handle fuer std.services */
	int  						dummy;           			/* Wird verwendet wenn ein Funktions-
	                                         		ergebnis uninteressant ist */
	char						buf[MAXLINE];	 			/* Hier wird eine aus /etc/group
	                                    	      gelesene Zeile gespeichert */
	char						buf_bak[MAXLINE];
	struct structService	*akt;				  			/* Drei Pointer fuer den Zugriff*/
	char						dummy_str[MAXLINE]; 		/* Wenn ein String-Ergebnis 
														  		uninteressant ist */
	char						name[MAXLINE];
	char						path[MAXLINE];
	char						parameters[MAXLINE];		/* zu mountendes Drive */
	char						type[MAXLINE];
	char						comment[MAXLINE];			/* Mountpoint */
	char						active;						/* Typ des fs */
	int						i;

	if (!(avl_svc_file=fopen(AV_SERV_NAME,"r"))) {
		return AV_SERV_FAILURE;
	}
	
	if (!(net_svc_file=fopen(NET_SERV_NAME,"r"))) {
		return NET_SERV_FAILURE;
	}

	if (!(add_svc_file=fopen(ADD_SERV_NAME,"r"))) {
		return ADD_SERV_FAILURE;
	}

	if (!(std_svc_file=fopen(STD_SERV_NAME,"r"))) {
		return STD_SERV_FAILURE;
	}

	do{

		/*Einlesen einer Zeile, entspricht einem DIENST*/
		fgets(buf,MAXLINE,avl_svc_file);

		if (!feof(avl_svc_file) && (strlen(buf)!=1)){
			if (DEBUG) printf("read_services: Gelesene Zeile: %s<br>\n",buf);
			getword(name,buf,':');
			if (DEBUG) printf("read_services: Nach name (%s), buf: %s<br>\n",name,buf);
			getword(path,buf,':'); 
			forwardtoback(path);
			if (DEBUG) printf("read_services: Nach path (%s), buf: %s<br>\n",path,buf);
			if (buf[0] == ':') {
				strcpy(parameters,"");
				getword(dummy_str,buf,':');
			} else getword(parameters,buf,':');
			if (DEBUG) printf("read_services: Nach parameters (%s), buf: %s<br>\n",parameters,buf);
			getword(type,buf,':');
			if (DEBUG) printf("read_services: Nach type (%s), buf: %s<br>\n",type,buf);
			getword(comment,buf,':');
			if (DEBUG) printf("read_services: Nach comment (%s), buf: %s<br>\n",comment,buf);
			akt = (struct structService *) malloc(sizeof(struct structService));
			strcpy(akt->name,name);
			strcpy(akt->path,path);
			strcpy(akt->parameters,parameters);
			strcpy(akt->type,type);
			strcpy(akt->comment,comment);
			akt->active=FALSE;
			if (DEBUG) printf("read_services: lesen von avail.services, Parameter f&uuml;r addService: %s %s %s %s %s %d <br>",
						akt->name,
						akt->path,
						akt->parameters,
						akt->type,
						akt->comment,
						akt->active);
			addService(&(*base),akt);
	}

	}while (!feof(avl_svc_file));
	
	fclose(avl_svc_file);

	do{

		/*Einlesen einer Zeile, entspricht einem DIENST*/
		fgets(buf,MAXLINE,net_svc_file);

		if (!feof(net_svc_file)  && (strlen(buf)!=1)){
		
			getword(name,buf,' ');
			getword(path,buf,' ');
			getword(parameters,buf,' ');
			
			forwardtoback(path);
			if (DEBUG) printf("read_services: net.services: Werte: %s %s %s <br>",
									 akt->name,
									 akt->path,
									 akt->parameters);
			if (ServiceExists) {
				if (DEBUG) printf("read_services: net.services: Service gefunden<br>");
				akt = GetService(*base,name);
				akt->active = TRUE;
			} else return NET_SERV_FAILURE;
		
		}

	} while (!feof(net_svc_file));
	
	fclose(net_svc_file);

	do{

		/*Einlesen einer Zeile, entspricht einem Dienst*/
		fgets(buf,MAXLINE,add_svc_file);

		if (!feof(add_svc_file)  && (strlen(buf)!=1)){
		
			getword(name,buf,' ');
			getword(path,buf,' ');
			getword(parameters,buf,' ');
			
			forwardtoback(path);
			if (DEBUG) printf("read_services: add.services: Werte: %s %s %s <br>",
									 akt->name,
									 akt->path,
									 akt->parameters);
			if (ServiceExists) {
				if (DEBUG) printf("read_services: add.services: Service gefunden<br>");
				akt = GetService(*base,name);
				akt->active = TRUE;
			} else return ADD_SERV_FAILURE;
		}

	}while (!feof(add_svc_file));
	
	fclose(add_svc_file);

	do{

		/*Einlesen einer Zeile, entspricht einem FS*/
		fgets(buf,MAXLINE,std_svc_file);

		if (!feof(std_svc_file)  && (strlen(buf)!=1)){
		
			getword(name,buf,' ');
			getword(path,buf,' ');
			getword(parameters,buf,' ');
			
			forwardtoback(path);
			if (DEBUG) printf("read_services: std.services: Werte: %s %s %s <br>",
									 akt->name,
									 akt->path,
									 akt->parameters);
			if (ServiceExists) {
				if (DEBUG) printf("read_services: std.services: Service gefunden<br>");
				akt = GetService(*base,name);
				akt->active = TRUE;
			} else return STD_SERV_FAILURE;
		}

	}while (!feof(std_svc_file));
	
	fclose(std_svc_file);
	
	return 0;
}

/*ServiceExists liefert TRUE,  wenn der durch den Namen spezifizierter
  Dienst bereits existiert, sonst FALSE*/
/*----------------------------------------------------------------------------*/
int ServiceExists(struct structService *base,char *service_searched) {
	struct structService *akt;
	
	akt = base;
	
	if (akt == NULL) return FALSE;
	
	do { 
		if (DEBUG) printf("ServiceExists: akt->name: %s akt->path: %s akt->parameters: %s service_searched: %s<br>",
								akt->name,akt->path,akt->parameters,service_searched);
		if (!strcmp(akt->name,service_searched)) {
			return TRUE;
		}
		else {
			akt = akt->next;
		}
	} while (akt != base);
	return FALSE;
}

/*GetService() liefert einen Pointer auf einen durch seinen Namen 
  definierten Service*/
/*----------------------------------------------------------------------------*/
struct structService *GetService(struct structService *base,char *service_searched) {
	struct structService *akt;
	
	akt = base;
	do {
		if (DEBUG) printf("GetService: akt->name: %s, service_searched: %s<br>\n",
		                  akt->name,service_searched);
		if (!strcmp(akt->name,service_searched)) return akt;
		else akt = akt->next;
	} while (akt != base); 
}

/*addService() traegt einen Dienst in der Dienstliste ein*/
/*----------------------------------------------------------------------------*/
void addService(struct structService **base,struct structService *service) {

	struct structService *next;
	struct structService *prev;

	prev = *base;
	
	if (DEBUG) printf("addService: Addiere: name: %s path: %s parameters: %s type: %s"
	                  "comment: %s active: %d<br>\n",
	                  service->name,
	                  service->path,
	                  service->parameters,
	                  service->type,
	                  service->comment,
	                  service->active);
	
	if (*base == NULL) {
		*base = service;
		service->next = service;
		service->prev = service;
	}
	else	if (strcmp(service->name,"portmap")) {
				prev = (*base)->prev;
				next = (*base);
				prev->next = service;
				next->prev = service;
				service->next = next;
				service->prev = prev;
			} else {
				prev = (*base)->prev;
				next = *base;
				prev->next = service;
				next->prev = service;
				service->next = next;
				service->prev = prev;
				*base = service;
	}

}


/*FlushServices schreibt die Dateien /etc/*.services*/
/*----------------------------------------------------------------------------*/
int FlushServices(struct structService *service_base) {
	struct structService	*akt;
	FILE						*net_svc_file;
	FILE						*add_svc_file;
	FILE						*std_svc_file;
	
	
	system("cp " NET_SERV_NAME " " NET_SERV_BAK_NAME);	
	system("cp " ADD_SERV_NAME " " ADD_SERV_BAK_NAME);	
	system("cp " STD_SERV_NAME " " STD_SERV_BAK_NAME);	

	if (!(net_svc_file=fopen(NET_SERV_NAME,"wb"))) {
		return NET_SERV_FAILURE;
	} 

	if (!(add_svc_file=fopen(ADD_SERV_NAME,"wb"))) {
		return ADD_SERV_FAILURE;
	} 

	if (!(std_svc_file=fopen(STD_SERV_NAME,"wb"))) {
		return STD_SERV_FAILURE;
	} 
	
	akt = service_base;
	do {
		backtoforward(akt->path);
		if (akt->active) {
			if (!strcmp(akt->type,"net")) fprintf(net_svc_file,"%s %s %s\n",akt->name,akt->path,akt->parameters);
			else {
				if (!strcmp(akt->type,"std")) fprintf(std_svc_file,"%s %s %s\n",akt->name,akt->path,akt->parameters);
	         else fprintf(add_svc_file,"%s %s %s\n",akt->name,akt->path,akt->parameters);
			}
		}
		akt = akt->next;
	} while (akt != service_base);
	
	fclose(net_svc_file);
	fclose(add_svc_file);
	fclose(std_svc_file);

}

/*read_exports() liest die verfuegbaren und aktiven Dienste ein und liefert 
  einen passenden Pointer auf eine doppelt verkettete Ringliste*/
/*----------------------------------------------------------------------------*/
int read_exports(struct structExport **base) {

	FILE 						*nfs_ex_file;	  			/* file-handle fuer /etc/exports*/
	FILE 						*smb_ex_file;	  			/* file-handle fuer smb-exports.conf*/
	int  						dummy;           			/* Wird verwendet wenn ein Funktions-
	                                         		ergebnis uninteressant ist */
	char						buf[MAXLINE];	 			/* Hier wird eine aus /etc/group
	                                    	      gelesene Zeile gespeichert */
	char						buf_bak[MAXLINE];
	struct structExport	*akt;				  			/* Drei Pointer fuer den Zugriff*/
	char						dummy_str[MAXLINE]; 		/* Wenn ein String-Ergebnis 
														  		uninteressant ist */
	char						options_tmp[MAXLINE];
	char						nfs_common_options[MAXLINE];
	char						common_tmp[MAXLINE];
	char						common_options_tmp[MAXLINE];
	char						akt_option[MAXLINE];
	char						akt_option_tmp[MAXLINE];
	char						smb_name[MAXLINE];
	char						path[MAXLINE];
	char 						nfs_unknown_options[MAXLINE];
	char						nfs_common_unknown_options[MAXLINE];
	char 						smb_unknown_options[MAXLINE];
	char						akt_parameter[MAXLINE];
	int						smb_export=FALSE;
	int						nfs_export=FALSE;
	int						nfs_root_access=FALSE;
	int						read_only=FALSE;
	int						printable=FALSE;
	int						public=FALSE;
	int						i;
	int						j;
	int						k;
	int						invalid;
	

	/*Die Konvertierung der fstab wird von einem sh-skript erledigt*/
	system(CONV_EXPORTS_CMD);

	if (!(nfs_ex_file=fopen(NFS_EXPORTS_CONV_NAME,"r"))) {
		return NFS_EXPORTS_FAILURE;
	}

	if (!(smb_ex_file=fopen(SMB_EXPORTS_NAME,"r"))) {
		return SMB_EXPORTS_FAILURE;
	}



	/*Bearbeiten von exports*/
	do{
		/*Init diverser Variablen*/
		strcpy(options_tmp,"");
		strcpy(nfs_common_options,"");
		strcpy(common_tmp,"");
		strcpy(akt_option,"");
		strcpy(akt_option_tmp,"");
		strcpy(smb_name,"");
		strcpy(path,"");	
		strcpy(nfs_unknown_options,"");
		strcpy(nfs_common_unknown_options,"");
		strcpy(smb_unknown_options,"");
		smb_export=FALSE;
		nfs_export=FALSE;
		nfs_root_access=FALSE;
		read_only=FALSE;
		strcpy(common_options_tmp,"");

		/*Einlesen einer Zeile, entspricht einem DIENST*/
		fgets(buf,MAXLINE,nfs_ex_file);
		if (DEBUG) printf("read_exports: parsen von exports: gelesene Zeile: %s<br>",buf);
		if (!feof(nfs_ex_file) && (strlen(buf)!=1) && (buf[0]!='%')){

			getword(path,buf,'%');
			if (DEBUG) printf("read_exports: parsen von exports: nach path: %s, buf: %s<br>",path,buf);
			getword(options_tmp,buf,' ');
			if (DEBUG) printf("read_exports: parsen von exports: nach options_tmp: %s, buf: %s<br>",options_tmp,buf);
			remove_whitespaces(options_tmp);
			if (DEBUG) printf("read_exports: parsen von exports: options_tmp: %s<br>",options_tmp);

						
			/*Herausfiltern der Optionen die fuer alle gelten, die
			  anderen Optionen werden gespeichert und wieder mit ausgegeben*/

			if (options_tmp[0] == '(') {
				getword(dummy_str,options_tmp,'(');
				getword(common_options_tmp,options_tmp,')');
				
			}
			
			if (DEBUG) printf("read_exports: common_options_tmp: %s<br>",common_options_tmp);
			strcpy(nfs_common_options,common_options_tmp);			
						
			strcpy(nfs_common_unknown_options,"");
			if (strlen(nfs_common_options) > 0) {
				strcpy(common_tmp,nfs_common_options);
				while (strlen(nfs_common_options) > 0) {
					getword(akt_option,nfs_common_options,',');
					if (!strcmp(akt_option,"ro")) {
						read_only=TRUE;
						if (DEBUG) printf("read_exports: Option ro wurde erkannt<br>\n");
						strcpy(akt_option,"");
					}
					if (!strcmp(akt_option,"no_root_squash")) {
						nfs_root_access=TRUE;
						if (DEBUG) printf("read_exports: Option no_root_squash wurde erkannt<br>\n");
						strcpy(akt_option,"");
					}
					
					strcat(nfs_common_unknown_options,akt_option);
				} 
			}
			
			akt = (struct structExport *) malloc(sizeof(struct structExport));
			strcpy(akt->smb_name,"");
			strcpy(akt->path,path);
			strcpy(akt->nfs_unknown_options,nfs_unknown_options);
			strcpy(akt->nfs_common_unknown_options,nfs_common_unknown_options);
			strcpy(akt->smb_unknown_options,"");
			akt->smb_export=FALSE;
			akt->nfs_export=TRUE;
			akt->nfs_root_access=nfs_root_access;
			akt->read_only=read_only;
			akt->printable=FALSE;
			akt->public=FALSE;
			addExport(&(*base),akt);
			if (DEBUG) printf("read_exports(): Export erfolgreich addiert<br>\n");
		}

	}while (!feof(nfs_ex_file));
	
	fclose(nfs_ex_file);

	if (DEBUG) printf("read_exports(): NFS-parsing beendet<br>\n");

	/*Bearbeiten von smb-exports.conf*/
	fgets(buf,MAXLINE,smb_ex_file);
	do{
		/*Parsen einer Zeile, entspricht ueblicherweise einem Parameter oder Namen*/
		
		if (DEBUG) printf("read_exports(): Smb-Parsing: Gelesene Zeile: %s<br>\n",buf);
		
		if (!feof(smb_ex_file)){
			do {
				
				invalid=FALSE;
				
				/*Wenn ein # vorne ist, oder die Zeile leer ist ueberspringen*/
				if ((strlen(buf) != 1) && (buf[0] != '\n') && (buf[0] != '#')) {
					
					/*Wenn es eine neue Freigabe ist, dann werden die eckigen Klammern entfernt*/
					if (buf[0] == '[') {
						getword(dummy_str,buf,'[');
						getword(smb_name,buf,']');
					} else {
						strcpy(akt_option_tmp,buf);
						getword(akt_option,buf,'=');
						getword(akt_parameter,buf,'\n');
						if (!strcmp(akt_option,"path")) {
							strcpy(path,akt_parameter);
						}
						if (!strcmp(akt_option,"read only")) {
							if (!strcmp(akt_parameter,"yes")) read_only=TRUE;
							else read_only=FALSE;
						}
						if (!strcmp(akt_option,"writable")) {
							if (!strcmp(akt_parameter,"yes")) read_only=FALSE;
							else read_only=TRUE;
						}
						if (!strcmp(akt_option,"public")) {
							if (!strcmp(akt_parameter,"yes")) public=TRUE;
							else public=FALSE;
						}
						if (!strcmp(akt_option,"printable")) {
							if (!strcmp(akt_parameter,"yes")) printable=TRUE;
							else printable=FALSE;
						}
						if (strcmp(akt_option,"path") 
							 && strcmp(akt_option,"read only") 
							 && strcmp(akt_option,"writable") 
							 && strcmp(akt_option,"public") 
							 && strcmp(akt_option,"printable")) {
						
							if (strlen(smb_unknown_options)>0) strcat(smb_unknown_options,", "); 
							getword(akt_option,akt_option_tmp,'\n');
							strcat(smb_unknown_options,akt_option);
						}
					}
				} else invalid = TRUE;
				
				fgets(buf,MAXLINE,smb_ex_file);
			} while((buf[0] != '[') && (!feof(smb_ex_file)));
			if (DEBUG) printf("read_exports: smb: smb_name: %s path: %s read_only: %d public: %d printable: %d"
			                  " smb_unknown_options: %s<br>\n",smb_name,path,read_only,public,printable,smb_unknown_options);				

			if (!invalid) {
				if (ExportExists(*base,path)) {
					if (DEBUG) printf("read_exports: smb: Export existiert, aendere Daten<br>\n");
					akt = GetExport(*base,path);
					strcpy(akt->smb_name,smb_name);
					akt->read_only=read_only;
					akt->public=public;
					akt->printable=printable;
					akt->smb_export=TRUE;
					strcpy(akt->smb_unknown_options,smb_unknown_options);
	
					/*smb_unknown_options fuer den naechsten Durchgang loeschen*/
					strcpy(smb_unknown_options,"");	
				} else {
					if (DEBUG) printf("read_exports: smb: Export existiert nicht<br>\n");
					akt = (struct structExport *) malloc(sizeof(struct structExport));
					strcpy(akt->path,path);
					strcpy(akt->nfs_unknown_options,nfs_unknown_options);
					strcpy(akt->nfs_common_unknown_options,nfs_common_unknown_options);
					strcpy(akt->smb_unknown_options,"");
					akt->smb_export=TRUE;
					akt->nfs_export=FALSE;
					akt->nfs_root_access=FALSE;
					akt->read_only=FALSE;
					strcpy(akt->smb_name,smb_name);
					akt->read_only=read_only;
					akt->public=public;
					akt->printable=printable;
					strcpy(akt->smb_unknown_options,smb_unknown_options);
					addExport(&(*base),akt);
	
					/*smb_unknown_options, fuer den naechsten Durchgang loeschen
					  public und printable initialisieren*/
					strcpy(smb_unknown_options,"");
					public=TRUE;	
					printable=FALSE;
				}
			}
		}
	
	}while (!feof(smb_ex_file));
	
	fclose(smb_ex_file);
	
	return 0;
}


/* remove_whitespaces loescht ueberfluessige leerzeichen aus einem string */
/*----------------------------------------------------------------------------*/
void remove_whitespaces(char *string) {
	int	i=0;
	int	j=0;
	char 	*buffer;
	
	buffer = (char *) malloc(sizeof(char) * MAXLINE);
	while (i <= strlen(string)) {
		if ((string[i] != ' ') && (string[i] != '	')) {
			buffer[j] = string[i];
			j++;
		}else if ((j > 0) && (buffer[j-1] != ' ')) {
			buffer[j] = ' ';
			j++;
		}
		i++;
	}
	j++;
	buffer[j]='\0';
	strcpy(string,buffer);
}


/*ExportExists liefert TRUE,  wenn der durch den Pfad spezifizierte
  Export bereits existiert, sonst FALSE*/
/*----------------------------------------------------------------------------*/
int ExportExists(struct structExport *base,char *path_searched) {
	struct structExport *akt;
	
	akt = base;
	
	if (akt == NULL) return FALSE;
	
	do { 
		if (DEBUG) printf("Export: akt->smb_name: %s akt->path: %s path_searched: %s<br>",
								akt->smb_name,akt->path,path_searched);
		if (!strcmp(akt->path,path_searched)) {
			return TRUE;
		}
		else {
			akt = akt->next;
		}
	} while (akt != base);
	return FALSE;
}

/*GetExport() liefert einen Pointer auf einen durch seinen Pfad 
  definierten Export*/
/*----------------------------------------------------------------------------*/
struct structExport *GetExport(struct structExport *base,char *path_searched) {
	struct structExport *akt;
	
	akt = base;
	do {
		if (DEBUG) printf("GetExport: akt->path: %s, path_searched: %s<br>\n",
		                  akt->path,path_searched);
		if (!strcmp(akt->path,path_searched)) return akt;
		else akt = akt->next;
	} while (akt != base); 
}

/*addExport() traegt einen Export in der Exportliste ein*/
/*----------------------------------------------------------------------------*/
void addExport(struct structExport **base,struct structExport *export) {

	struct structExport *next;
	struct structExport *prev;

	prev = *base;
	
	if (DEBUG) printf("addExport: Addiere: smb_name: %s path: %s nfs_opt: %s nfs_com_opt: %s"
	                  "smb_opt: %s <br>\n",
	                  export->smb_name,
	                  export->path,
	                  export->nfs_unknown_options,
	                  export->nfs_common_unknown_options,
	                  export->smb_unknown_options);
	
	if (*base == NULL) {
		if (DEBUG) printf("addExport: Export-Liste ist leer<br>\n");
		*base = export;
		export->next = export;
		export->prev = export;
	}
	else {
		if (DEBUG) printf("addExport: Export-Liste ist nicht leer<br>\n");
		prev = (*base)->prev;
		next = *base;
		prev->next = export;
		next->prev = export;
		export->next = next;
		export->prev = prev;
		*base = export;
	}
}

/*smbNameExists liefert TRUE,  wenn der smb_name bereits vergeben ist, 
  sonst FALSE*/
/*----------------------------------------------------------------------------*/
int smbNameExists(struct structExport *base,char *smb_name) {
	struct structExport *akt;
	
	akt = base;
	
	if (akt == NULL) return FALSE;
	
	do { 
		if (DEBUG) printf("Export: akt->smb_name: %s akt->path: %s smb_name: %s<br>",
								akt->smb_name,akt->path,smb_name);
		if (!strcmp(akt->smb_name,smb_name)) {
			return TRUE;
		}
		else {
			akt = akt->next;
		}
	} while (akt != base);
	return FALSE;
}

/*replaceChr() ersetzt char1 in einem String durch char2*/
/*----------------------------------------------------------------------------*/
void replaceChr(char *str,char char1,char char2) {
    register int x;

    for(x=0;str[x];x++) if(str[x] == char1) str[x] = char2;
}


/*delExport loescht einen Export aus der Liste*/
/*----------------------------------------------------------------------------*/
int delExport(struct structExport **base,char *export_to_delete) {
	struct structExport *akt;
	struct structExport *akt_old;
	struct structExport *next;
	struct structExport *prev;	
	
	
	akt = *base;
	if (akt->next == *base) {
		*base=NULL;
		return TRUE;
	}
	do {
		if (DEBUG) printf("delExport: akt->path: %s export_to_delete %s<br>",
		                  akt->path,export_to_delete);
		if (!strcmp(akt->path,export_to_delete)) {
			if (DEBUG) printf("delExport: Pfad: %s wird getrennt<br>",
			                   akt->path);
			next=akt->next;
			prev=akt->prev;
			prev->next=next;
			next->prev=prev;
			akt_old=akt;
			akt=next;
			if (akt_old == *base) *base=akt;
			free(akt_old);
		}
		else akt = akt->next;
	} 	while (akt != *base); 
	return FALSE;
}


/*FlushExports schreibt /etc/exports und /usr/local/samba/lib/smb-exports.conf*/
/*----------------------------------------------------------------------------*/
int FlushExports(struct structExport *export_base) {
	struct structExport	*akt;
	FILE						*nfs_ex_file;
	FILE						*smb_ex_file;
	
	
	system("cp " NFS_EXPORTS_NAME " " NFS_EXPORTS_BAK_NAME);	
	system("cp " SMB_EXPORTS_NAME " " SMB_EXPORTS_BAK_NAME);	

	if (!(nfs_ex_file=fopen(NFS_EXPORTS_NAME,"wb"))) {
		return NFS_EXPORTS_FAILURE;
	} 

	if (!(smb_ex_file=fopen(SMB_EXPORTS_NAME,"wb"))) {
		return SMB_EXPORTS_FAILURE;
	} 

	if (DEBUG) {
		printf("add_export(): Kontrollausgabe<br>\n");
		akt = export_base;
		if (export_base != NULL) do {
			printf("add_export():Pfad: %s NFS: %d SMB: %d <br>\n",akt->path,akt->nfs_export,akt->smb_export);
			akt = akt->next;
		} while (akt != export_base);
	}


	akt = export_base;
	if (export_base != NULL) {
		do {
			if (akt->nfs_export) {
				fprintf(nfs_ex_file,"%s ",akt->path);
				if (akt->read_only || akt->nfs_root_access || strlen(akt->nfs_common_unknown_options)) {
					fprintf(nfs_ex_file,"(");
					if (strlen(akt->nfs_common_unknown_options)){
						 fprintf(nfs_ex_file,"%s,",akt->nfs_common_unknown_options);
						 if (akt->read_only || akt->nfs_root_access) fprintf(nfs_ex_file,", ");
					}
					if (akt->read_only) {
						fprintf(nfs_ex_file,"ro");
						if (akt->nfs_root_access) fprintf(nfs_ex_file,",");
					}
					if (akt->nfs_root_access) fprintf(nfs_ex_file,"no_root_squash");
					fprintf(nfs_ex_file,") ");
				}
				replaceChr(akt->nfs_unknown_options, ',', ' ');
				fprintf(nfs_ex_file,"%s\n",akt->nfs_unknown_options);
		
			}

			if (akt->smb_export) {
				fprintf(smb_ex_file,"[%s]\n",akt->smb_name);
				fprintf(smb_ex_file,"path=%s\n",akt->path);
				if (akt->read_only) fprintf(smb_ex_file,"writable=no\nread only=yes\n");
				else fprintf(smb_ex_file,"writable=yes\nread only=no\n");
				if (akt->public) fprintf(smb_ex_file,"public=yes\n");
				else fprintf(smb_ex_file,"public=no\n");
				if (akt->printable) fprintf(smb_ex_file,"printable=yes\n");
				else fprintf(smb_ex_file,"printable=no\n");
				if(strlen(akt->smb_unknown_options)) {
					replaceChr(akt->smb_unknown_options,',','\n');
					fprintf(smb_ex_file,"%s\n",akt->smb_unknown_options);
				}
			}
	
			akt = akt->next;
		} while (akt != export_base);
	}
	fclose(nfs_ex_file);
	fclose(smb_ex_file);
	system("chgrp wheel " SMB_EXPORTS_NAME " " NFS_EXPORTS_NAME);
	system("chmod 600" SMB_EXPORTS_NAME " " NFS_EXPORTS_NAME);
	return 0;
}


/*ContainsChr() gibt TRUE zurueck, wenn searched_chr in str enthatlen ist,
  sonst FALSE*/
/*----------------------------------------------------------------------------*/
int ContainsChr(char *str,char searched_chr) {
    register int x;

    for(x=0;str[x];x++) if(str[x] == searched_chr) return TRUE;
    return FALSE;
}

/*read_printers() liest die Drucker ein und liefert einen passenden
  Pointer auf eine doppelt verkettete Ringliste*/
/*----------------------------------------------------------------------------*/
int read_printers(struct structPrinter **base) {

	FILE 						*printcap_file;	  /* file-handle fuer fstab */
	int  						dummy;           /* Wird verwendet wenn ein Funktions-
	                                         ergebnis uninteressant ist */
	char						buf[MAXLINE];	  /* Hier wird eine aus /etc/group	
	                                         gelesene Zeile gespeichert */
	char						*buf_conv;
	int						buf_len;
	struct structPrinter	*akt;				  /* Drei Pointer fuer den Zugriff*/
	char						dummy_str[MAXLINE]; /* Wenn ein String-Ergebnis 
														  uninteressant ist */
	char						printer_str[1024];
	char						akt_parameter[MAXLINE];
	char						akt_parameter_bak[MAXLINE];
	char						akt_switch[MAXLINE];
	char						akt_value[MAXLINE];
	char						name[MAXLINE];
	char						infilter[MAXLINE];
	char						sd[MAXLINE];
	char						lp[MAXLINE];
	char						rm[MAXLINE];
	char						rp[MAXLINE];
	int						mx;
	int						sf;
	int						sh;
	char  					unknown_options[1024];
	int						sd_len;
	FILE						*smbconf_file;
	char						smbconf_path[MAXLINE];

	
	if (!(printcap_file=fopen(PRINTCAP_NAME,"r"))) {
		return PRINTCAP_FAILURE;
	}

	if (DEBUG) printf("read_printers: /etc/printcap wurde ge&ouml;ffnet<br>");

	while (!feof(printcap_file)) {

		/*Einlesen einer Zeile*/
		fgets(buf,MAXLINE,printcap_file);
		if (DEBUG) if (feof(printcap_file)) printf("read_printers: EOF-Flag gesetzt<br>\n");
		if ((buf[0]!='#') && !feof(printcap_file) && (strlen(buf) != 1)) {

			getword(dummy_str,buf,'\n');
			getword(buf,dummy_str,'\\');
			buf_len=strlen(dummy_str);
			buf_conv=buf;
			while((buf_conv[0]==' ') && strlen(buf_conv)) buf_conv++;
			strcpy(printer_str,buf_conv);
			while (!feof(printcap_file) && (dummy_str[buf_len-1] == '\\')) {
				fgets(buf,MAXLINE,printcap_file);
				if (!feof(printcap_file)) {
					buf_len=strlen(buf);
					getword(dummy_str,buf,'\n');
					getword(buf,dummy_str,'\\');
					buf_len=strlen(dummy_str);
					buf_conv=buf;
					while((buf_conv[0]==' ') && strlen(buf_conv)) buf_conv++;
					strcat(printer_str,buf_conv);
				}
			}

			if (DEBUG) printf("read_printers: printer_str: %s<br>\n",printer_str);
			if (!feof(printcap_file)) {
				akt = (struct structPrinter *) malloc (sizeof(struct structPrinter));
				strcpy(akt->name,"");
				strcpy(akt->infilter,"");
				strcpy(akt->type,"local");
				strcpy(akt->sd,"");
				strcpy(akt->lp,"");
				strcpy(akt->rm,"");
				strcpy(akt->rp,"");
				strcpy(akt->unknown_options,"");
				akt->mx=-1;
				akt->sf=FALSE;
				akt->sh=FALSE;
			
				if (!feof(printcap_file)){
					getword(akt->name,printer_str,':');
					while (strlen(printer_str)) {
						getword(akt_parameter,printer_str,':');
						
						if (DEBUG) printf("read_printers(): Printer_str: %s, akt_parameter: %s<br>\n",printer_str,akt_parameter);
					
						strcpy(akt_parameter_bak,akt_parameter);
						if (ContainsChr(akt_parameter,'=')) {
							getword(akt_switch,akt_parameter,'=');
							strcpy(akt_value,akt_parameter);
						} else {
							if (ContainsChr(akt_parameter,'#')) {
								getword(akt_switch,akt_parameter,'#');
								strcpy(akt_value,akt_parameter);
							} else {
								strcpy(akt_switch,akt_parameter);
							}
						}
						
						if (DEBUG) printf("akt_switch: %s, akt_value: %s<br>\n",akt_switch,akt_value);
						
						if (!strcmp(akt_switch,"sd")) {
							strcpy(akt->sd,akt_value);
							sd_len=strlen(akt->sd);
							if (akt->sd[sd_len-1] != '/') strcat(akt->sd,"/"); 
						}
						if (!strcmp(akt_switch,"if")) {
							strcpy(akt->infilter,akt_value);
							if (!strcmp(akt->infilter,SMBPRINT_NAME)) {
								strcpy(akt->type,"smb");
							}
						}
						if (!strcmp(akt_switch,"lp")) {
							strcpy(akt->lp,akt_value);
						}
						if (!strcmp(akt_switch,"rm")) {
							strcpy(akt->rm,akt_value);
							strcpy(akt->type,"bsd");
						}
						if (!strcmp(akt_switch,"rp")) {
							strcpy(akt->rp,akt_value);
						}
						if (!strcmp(akt_switch,"mx")) {
							akt->mx=atoi(akt_value);
						}
						if (!strcmp(akt_switch,"sf")) {
							akt->sf=TRUE;
						}
						if (!strcmp(akt_switch,"sh")) {
							akt->sh=TRUE;
						}
						if (strcmp(akt_switch,"if") &&
							 strcmp(akt_switch,"sd") &&
							 strcmp(akt_switch,"lp") &&
							 strcmp(akt_switch,"rm") &&
							 strcmp(akt_switch,"rp") &&
							 strcmp(akt_switch,"mx") &&
							 strcmp(akt_switch,"sf") &&
							 strcmp(akt_switch,"lf") &&
							 strcmp(akt_switch,"sh")) 
						{
							 if (!strlen(akt->unknown_options)) strcat(akt->unknown_options,":");
							 strcat(akt->unknown_options,akt_parameter_bak);
						}
					
					}

					if (!strcmp(akt->sd,"")) strcpy(akt->sd,"/var/spool/lp/");

					if (!strcmp(akt->type,"smb")) {
						strcpy(smbconf_path,akt->sd);
						strcat(smbconf_path,".config");
						smbconf_file=fopen(smbconf_path,"r");
						fgets(buf,MAXLINE,smbconf_file);
						getword(dummy_str,buf,'=');
						getword(akt->rm,buf,'\n');
						fgets(buf,MAXLINE,smbconf_file);
						getword(dummy_str,buf,'=');
						getword(akt->rp,buf,'\n');
						fclose(smbconf_file);
					}

					if (DEBUG) printf("read_printers: Drucker wird hinzugef&uuml;gt<br>\n");				
					/*Der neue Drucker wird in die Liste eingetragen*/
					addPrinter(&(*base),akt);			 
				}
			}
		}
		
	}
	
	fclose(printcap_file);

	return 0;
}


/*delPrinter loescht einen Drucker aus der Liste*/
/*----------------------------------------------------------------------------*/
int delPrinter(struct structPrinter **base,char *printer_to_delete) {
	struct structPrinter *akt;
	struct structPrinter *akt_old;
	struct structPrinter *next;
	struct structPrinter *prev;	
	
	
	akt = *base;
	if (akt->next == *base) {
		*base=NULL;
		return TRUE;
	}
	do {
		if (DEBUG) printf("delPrinter: akt->name: %s printer_to_delete %s<br>",
		                  akt->name,printer_to_delete);
		if (!strcmp(akt->name,printer_to_delete)) {
			if (DEBUG) printf("delPrinter: Drucker: %s wird entfernt<br>",
			                   akt->name);
			next=akt->next;
			prev=akt->prev;
			prev->next=next;
			next->prev=prev;
			akt_old=akt;
			akt=next;
			if (akt_old == *base) *base=akt;
			free(akt_old);
			return TRUE;
		}
		else akt = akt->next;
	} 	while (akt != *base); 
	return FALSE;
}

/*PrinterExists liefert TRUE,  wenn der Druckername bereits vergeben ist, 
  sonst FALSE*/
/*----------------------------------------------------------------------------*/
int PrinterExists(struct structPrinter *base,char *printer_name) {
	struct structPrinter *akt;
	
	akt = base;
	
	if (akt == NULL) return FALSE;

	do { 
		if (DEBUG) printf("PrinterExists: akt->name: %s, printer_name: %s<br>",akt->name,printer_name);
		if (!strcmp(akt->name,printer_name)) {
			return TRUE;
		}
		else {
			akt = akt->next;
		}
	} while (akt != base);
	return FALSE;
}

/*addPrinter() traegt einen Drucker in der Druckerliste ein*/
/*----------------------------------------------------------------------------*/
void addPrinter(struct structPrinter **base,struct structPrinter *printer) {

	struct structPrinter *next;
	struct structPrinter *prev;

	prev = *base;
	
	if (DEBUG) printf("addPrinter: Addiere: name: %s<br>\n",
	                  printer->name);
	
	if (*base == NULL) {
		if (DEBUG) printf("addPrinter: Printer-Liste ist leer<br>\n");
		*base = printer;
		printer->next = printer;
		printer->prev = printer;
	}
	else {
		if (DEBUG) printf("addPrinter: Printer-Liste ist nicht leer<br>\n");
		prev = (*base)->prev;
		next = *base;
		prev->next = printer;
		next->prev = printer;
		printer->next = next;
		printer->prev = prev;
	}

}

/*FlushPrinters schreibt /etc/printcap */
/*----------------------------------------------------------------------------*/
int FlushPrinters(struct structPrinter *printer_base) {
	struct structPrinter	*akt;
	FILE						*printcap_file;
	
	
	system("cp " PRINTCAP_NAME " " PRINTCAP_BAK_NAME);	

	if (!(printcap_file=fopen(PRINTCAP_NAME,"wb"))) {
		return PRINTCAP_FAILURE;
	} 
	
	akt = printer_base;
	if (akt != NULL) { 
		do {
				fprintf(printcap_file,"%s:",akt->name);
				fprintf(printcap_file,"lf=%sprinter-log:",akt->sd);
				fprintf(printcap_file,"sd=%s:",akt->sd);
				fprintf(printcap_file,"lp=%s:",akt->lp);
				if (strcmp(akt->rm,"")) {
					fprintf(printcap_file,"rm=%s:",akt->rm);
					if (strcmp(akt->rp,"")) fprintf(printcap_file,"rp=%s:",akt->rp);
				}
				if (strcmp(akt->infilter,"")) fprintf(printcap_file,"if="SMBPRINT_NAME":"); 
				if (akt->mx != -1) fprintf(printcap_file,"mx#%d:",akt->mx);
				if (akt->sf) fprintf(printcap_file,"sf:");
				if (akt->sh) fprintf(printcap_file,"sh:");
				if (strlen(akt->unknown_options)) {
					fprintf(printcap_file,"\\\\\n");
					fprintf(printcap_file,"   %s\n",akt->unknown_options);
				} else {
					fprintf(printcap_file,"\n");
				}
			akt = akt->next;
		} while (akt != printer_base);
	}
	fclose(printcap_file);
	return 0;
}

/*GetPrinter() liefert einen Pointer auf einen durch seinen Namen 
  definierten Export*/
/*----------------------------------------------------------------------------*/
struct structPrinter *GetPrinter(struct structPrinter *base,char *name_searched) {
	struct structPrinter *akt;
	
	akt = base;
	do {
		if (DEBUG) printf("GetPrinter: akt->name: %s, name_searched: %s<br>\n",
		                  akt->name,name_searched);
		if (!strcmp(akt->name,name_searched)) return akt;
		else akt = akt->next;
	} while (akt != base); 
}

/*read_hosts() liest die hosts-table ein und liefert einen passenden
  Pointer auf eine doppelt verkettete Ringliste*/
/*----------------------------------------------------------------------------*/
int read_hosts(struct structHost **base) {

	FILE 						*hosts_conv_file;	  /* file-handle fuer fstab */
	int  						dummy;           /* Wird verwendet wenn ein Funktions-
	                                         ergebnis uninteressant ist */
	char						buf[MAXLINE];	  /* Hier wird eine aus /etc/group	
	                                         gelesene Zeile gespeichert */
	char						buf_conv[MAXLINE];
	int						buf_len;
	struct structHost	*akt;				  /* Drei Pointer fuer den Zugriff*/
	char						dummy_str[MAXLINE]; /* Wenn ein String-Ergebnis 
														  uninteressant ist */
	char						ip[MAXLINE];
	char						names[MAXLINE];

	/*Die Konvertierung der fstab wird von einem sh-skript erledigt*/
	system(CONV_HOSTS_CMD);

	
	if (!(hosts_conv_file=fopen(HOSTS_CONV_NAME,"r"))) {
		return HOSTS_FAILURE;
	}

	if (DEBUG) printf("read_hosts: /etc/hosts wurde ge&ouml;ffnet<br>");

	while (!feof(hosts_conv_file)) {

		/*Einlesen einer Zeile*/
		fgets(buf,MAXLINE,hosts_conv_file);
		if (DEBUG) if (feof(hosts_conv_file)) printf("read_hosts: EOF-Flag gesetzt<br>\n");
		if (!feof(hosts_conv_file)  && (strlen(buf)!=1) && (buf[0]!='%')) {
			if (buf[0] != '%') {
				akt = (struct structHost *) malloc(sizeof(struct structHost));
				getword(akt->ip,buf,'%');
				getword(akt->names,buf,'\n');
				if (DEBUG) printf("read_hosts: ip: %s, names: %s<br>\n",akt->ip,akt->names);
				addHost(&(*base),akt);
			}
		}
	}
	
	fclose(hosts_conv_file);

	return 0;
}

/*addHost() traegt einen Host in der Hostliste ein*/
/*----------------------------------------------------------------------------*/
void addHost(struct structHost **base,struct structHost *host) {

	struct structHost *next;
	struct structHost *prev;

	prev = *base;
	
	if (DEBUG) printf("addHost: Addiere: ip: %s<br>\n",
	                  host->ip);
	
	if (*base == NULL) {
		if (DEBUG) printf("addHost: Host-Liste ist leer<br>\n");
		*base = host;
		host->next = host;
		host->prev = host;
	}
	else {
		next=prev->next;
		if (DEBUG) printf("addHost: Host-Liste ist nicht leer<br>\n");
		if (DEBUG) printf("addHost: IP: %s, IPnum:%08lx<br>\n",host->ip,ipNumber(host->ip));

		while ((ipNumber(next->ip) < ipNumber(host->ip)) && (prev->next != *base)) {
			if (DEBUG) printf("addHost: IPnum:%08lx<br>\n",ipNumber(host->ip));
			prev = prev->next;
			next = prev->next;
			if (DEBUG) printf("addHost: prev: %s, %s<br>\n",prev->ip,prev->names);
		}

		next = prev->next;
		prev->next = host;
		next->prev = host;
		host->next = next;
		host->prev = prev;
	}

}

/*HostExists liefert TRUE,  wenn die IP bereits vergeben ist, 
  sonst FALSE*/
/*----------------------------------------------------------------------------*/
int HostExists(struct structHost *base,char *ip) {
	struct structHost *akt;
	
	akt = base;
	
	if (akt == NULL) return FALSE;

	do { 
		if (DEBUG) printf("IpExists: akt->ip: %s, ip: %s<br>",akt->ip,ip);
		if (!strcmp(akt->ip,ip)) {
			return TRUE;
		}
		else {
			akt = akt->next;
		}
	} while (akt != base);
	return FALSE;
}

/*GetHost() liefert einen Pointer auf eine IP*/
/*----------------------------------------------------------------------------*/
struct structHost *GetHost(struct structHost *base,char *ip_searched) {
	struct structHost *akt;
	
	akt = base;
	do {
		if (DEBUG) printf("GetIp: akt->ip: %s, ip_searched: %s<br>\n",
		                  akt->ip,ip_searched);
		if (!strcmp(akt->ip,ip_searched)) return akt;
		else akt = akt->next;
	} while (akt != base); 
}

/*delHost loescht einen Host aus der Liste*/
/*----------------------------------------------------------------------------*/
int delHost(struct structHost **base,char *ip_to_delete) {
	struct structHost *akt;
	struct structHost *akt_old;
	struct structHost *next;
	struct structHost *prev;	
	
	
	akt = *base;
	if (akt->next == *base) {
		*base=NULL;
		return TRUE;
	}
	do {
		if (DEBUG) printf("delHost: akt->ip: %s ip_to_delete %s<br>",
		                  akt->ip,ip_to_delete);
		if (!strcmp(akt->ip,ip_to_delete)) {
			if (DEBUG) printf("delHost: Host: %s wird entfernt<br>",
			                   akt->names);
			next=akt->next;
			prev=akt->prev;
			prev->next=next;
			next->prev=prev;
			akt_old=akt;
			akt=next;
			if (akt_old == *base) *base=akt;
			free(akt_old);
			return TRUE;
		}
		else akt = akt->next;
	} 	while (akt != *base); 
	return FALSE;
}

/*FlushHosts schreibt /etc/hosts */
/*----------------------------------------------------------------------------*/
int FlushHosts(struct structHost *host_base) {
	struct structHost	*akt;
	FILE						*hosts_file;
	
	
	system("cp " HOSTS_NAME " " HOSTS_BAK_NAME);	

	if (!(hosts_file=fopen(HOSTS_NAME,"wb"))) {
		return HOSTS_FAILURE;
	} 

	if (host_base != NULL) {
		akt = host_base;
		do {
				fprintf(hosts_file,"%s %s\n",akt->ip,akt->names);
				akt = akt->next;
		} while (akt != host_base);
	}
	
	fclose(hosts_file);

	system(ADDPRINT_CMD);

	return 0;
}

/*isValidHostname prueft, ob der Hostname gueltig ist*/
/*----------------------------------------------------------------------------*/
int isValidHostname(char *hostname) {
	int i;
	for (i=0;i<strlen(hostname);i++) {
		if (!(
				((hostname[i]<=57) && (hostname[i]>=48)) ||
				((hostname[i]<=90) && (hostname[i]>=65)) ||
				((hostname[i]<=122) && (hostname[i]>=97)) ||
				(hostname[i] == '.') ||
				(hostname[i] == '-') 
			)) return FALSE;
	}
	return TRUE;
}

/*isValidHoststring prueft, ob der String valide Hostnamen enthaelt ist*/
/*----------------------------------------------------------------------------*/
int isValidHoststring(char *hoststring) {
	int i;
	for (i=0;i<strlen(hoststring);i++) {
		if (!(
				((hoststring[i]<=57) && (hoststring[i]>=48)) ||
				((hoststring[i]<=90) && (hoststring[i]>=65)) ||
				((hoststring[i]<=122) && (hoststring[i]>=97)) ||
				(hoststring[i] == '.') ||
				(hoststring[i] == '-') ||
				(hoststring[i] == ' ')
			)) return FALSE;
	}
	return TRUE;
}

/*ipNumber gibt den 32wert einer ip als Long zurueck*/
/*----------------------------------------------------------------------------*/
unsigned long ipNumber(char *ip) {
	unsigned long	ipnum=0;
	char	ipbyteStr[4];
	char	ipStrtmp[32];
	int	i;
	
	strcpy(ipStrtmp,ip);
	getword(ipbyteStr,ipStrtmp,'.');
	ipnum=atoi(ipbyteStr) * 256 * 256 * 256;
	if (DEBUG) printf("ipNumber: ipnum: %08lx<br>\n",ipnum);
	getword(ipbyteStr,ipStrtmp,'.');
	ipnum=ipnum + atoi(ipbyteStr) * 256 * 256;
	if (DEBUG) printf("ipNumber: ipnum: %08lx<br>\n",ipnum);
	getword(ipbyteStr,ipStrtmp,'.');
	ipnum=ipnum + atoi(ipbyteStr) * 256;
	if (DEBUG) printf("ipNumber: ipnum: %08lx<br>\n",ipnum);
	getword(ipbyteStr,ipStrtmp,'.');
	ipnum=ipnum + atoi(ipbyteStr);
	if (DEBUG) printf("ipNumber: ipnum: %08lx<br>\n",ipnum);
	
	return ipnum; 
}

/*read_confif() liest die configurierten Interfaces ein und liefert einen passenden
  Pointer auf eine doppelt verkettete Ringliste*/
/*----------------------------------------------------------------------------*/
int read_confIf(struct structConfIf **base) {

	FILE 						*confif_file;	  /* file-handle fuer config.if */
	FILE 						*hwaddr_file;	  /* file-handle fuer if.hwaddr */
	int  						dummy;           /* Wird verwendet wenn ein Funktions-
	                                         ergebnis uninteressant ist */
	char						buf[MAXLINE];	  /* Hier wird eine aus /etc/group	
	                                         gelesene Zeile gespeichert */
	char						buf_conv[MAXLINE];
	int						buf_len;
	struct structConfIf	*akt;				  /* Drei Pointer fuer den Zugriff*/
	char						dummy_str[MAXLINE]; /* Wenn ein String-Ergebnis 
														  uninteressant ist */
	char						hwaddr_path[MAXLINE];
	char						hwaddr1[5];
	char						hwaddr2[5];
	char						hwaddr3[5];
	char						hwaddr4[5];
	char						hwaddr5[5];
	char						hwaddr6[5];

	if (!(confif_file=fopen(CONFIF_NAME,"r"))) {
		return CONFIF_FAILURE;
	}

	if (DEBUG) printf("read_confIf: /etc/config.if wurde ge&ouml;ffnet<br>");

	while (!feof(confif_file)) {

		/*Einlesen einer Zeile*/
		fgets(buf,MAXLINE,confif_file);
		if (DEBUG) if (feof(confif_file)) printf("read_confIf: EOF-Flag gesetzt<br>\n");
		if (!feof(confif_file) && (strlen(buf)!=1)) {
			if (buf[0] != '%') {
				akt = (struct structConfIf *) malloc(sizeof(struct structConfIf));
				getword(akt->intrfc,buf,' ');
				getword(akt->ip,buf,' ');
				getword(akt->network,buf,' ');
				getword(akt->netmask,buf,' ');
				getword(akt->broadcast,buf,'\n');
				strcpy(akt->hwaddr,"");
				if (!strncmp(akt->intrfc,"rle",3)) {
					strcpy(hwaddr_path,"/etc/");
					strcat(hwaddr_path,akt->intrfc);
					strcat(hwaddr_path,".hw");
					hwaddr_file=fopen(hwaddr_path,"r");
					fgets(buf,MAXLINE,hwaddr_file);
					if (!feof(hwaddr_file)  && (strlen(buf)!=1)) {
							getword(dummy_str,buf,' ');
							getword(dummy_str,buf,'x');
							getword(hwaddr1,buf,':');
							strcat(akt->hwaddr,hwaddr1);
							strcat(akt->hwaddr,":");
							getword(dummy_str,buf,'x');
							getword(hwaddr2,buf,':');
							strcat(akt->hwaddr,hwaddr2);
							strcat(akt->hwaddr,":");
							getword(dummy_str,buf,'x');
							getword(hwaddr3,buf,':');
							strcat(akt->hwaddr,hwaddr3);
							strcat(akt->hwaddr,":");
							getword(dummy_str,buf,'x');
							getword(hwaddr4,buf,':');
							strcat(akt->hwaddr,hwaddr4);
							strcat(akt->hwaddr,":");
							getword(dummy_str,buf,'x');
							getword(hwaddr5,buf,':');
							strcat(akt->hwaddr,hwaddr5);
							strcat(akt->hwaddr,":");
							getword(dummy_str,buf,'x');
							getword(hwaddr6,buf,':');
							strcat(akt->hwaddr,hwaddr6);
							strcat(akt->hwaddr,":");
					}
					fclose(hwaddr_file);
				}
				if (DEBUG) printf("read_confIf: intrfc: %s, ip: %s,"
				                  " network: %s, netmask: %s, broadcast: %s<br>\n"
				                  ,akt->intrfc,akt->ip,akt->network,akt->netmask,akt->broadcast);
				addconfIf(&(*base),akt);
			}
		}
	}
	
	fclose(confif_file);

	return 0;
}

/*addconfIf() traegt ein If in der If-liste ein*/
/*----------------------------------------------------------------------------*/
void addconfIf(struct structConfIf **base,struct structConfIf *confif) {

	struct structConfIf *next;
	struct structConfIf *prev;

	prev = *base;
	
	if (DEBUG) printf("addconfIf: Addiere: intrfc: %s<br>\n",
	                  confif->intrfc);
	
	if (*base == NULL) {
		if (DEBUG) printf("addconfIf: confIf-Liste ist leer<br>\n");
		*base = confif;
		confif->next = confif;
		confif->prev = confif;
	}
	else {
		next=prev->next;
		if (DEBUG) printf("addconfIf: confIf-Liste ist nicht leer<br>\n");

		while ((strcmp(next->intrfc,confif->intrfc) < 0) && (prev->next != *base)) {
			prev = prev->next;
			next = prev->next;
		}

		next = prev->next;
		prev->next = confif;
		next->prev = confif;
		confif->next = next;
		confif->prev = prev;
	}

}

/*GetconfIf() liefert einen Pointer auf eine IP*/
/*----------------------------------------------------------------------------*/
struct structConfIf *GetconfIf(struct structConfIf *base,char *intrfc_searched) {
	struct structConfIf *akt;
	
	akt = base;
	do {
		if (DEBUG) printf("GetconfIf: akt->intrfc: %s, intrfc_searched: %s<br>\n",
		                  akt->intrfc,intrfc_searched);
		if (!strcmp(akt->intrfc,intrfc_searched)) return akt;
		else akt = akt->next;
	} while (akt != base); 
}

/*delconfIf loescht einen confIf aus der Liste*/
/*----------------------------------------------------------------------------*/
int delconfIf(struct structConfIf **base,char *intrfc_to_delete) {
	struct structConfIf *akt;
	struct structConfIf *akt_old;
	struct structConfIf *next;
	struct structConfIf *prev;	
	
	
	akt = *base;
	if (akt->next == *base) {
		*base=NULL;
		return TRUE;
	}
	do {
		if (DEBUG) printf("delconfIf: akt->intrfc: %s intrfc_to_delete %s<br>",
		                  akt->intrfc,intrfc_to_delete);
		if (!strcmp(akt->intrfc,intrfc_to_delete)) {
			if (DEBUG) printf("delconfIf: If: %s wird entfernt<br>",
			                   akt->intrfc);
			next=akt->next;
			prev=akt->prev;
			prev->next=next;
			next->prev=prev;
			akt_old=akt;
			akt=next;
			if (akt_old == *base) *base=akt;
			if (DEBUG) printf("delconfIf: base->intrfc: %s<br>\n",(*base)->intrfc);
			free(akt_old);
			return TRUE;
		}
		else akt = akt->next;
	} 	while (akt != *base); 
	return FALSE;
}

/*FlushconfIfs schreibt /etc/config.if */
/*----------------------------------------------------------------------------*/
int FlushconfIfs(struct structConfIf *confif_base) {
	struct structConfIf	*akt;
	FILE						*confifs_file;
	
	
	system("cp " CONFIF_NAME " " CONFIF_BAK_NAME);	

	if (!(confifs_file=fopen(CONFIF_NAME,"wb"))) {
		return CONFIF_FAILURE;
	} 

	akt = confif_base;
	do {
			fprintf(confifs_file,"%s %s %s %s %s\n"
			        ,akt->intrfc,akt->ip,akt->network,akt->netmask,akt->broadcast);
			akt = akt->next;
	} while (akt != confif_base);
	
	fclose(confifs_file);
	return 0;
}

/*IntrfcIpExists liefert TRUE,  wenn die IP bereits vergeben ist, 
  sonst FALSE*/
/*----------------------------------------------------------------------------*/
int IntrfcIpExists(struct structConfIf *base,char *ip) {
	struct structConfIf *akt;
	
	akt = base;
	
	if (akt == NULL) return FALSE;

	do { 
		if (DEBUG) printf("IntrfcIpExists: akt->ip: %s, ip: %s<br>",akt->ip,ip);
		if (!strcmp(akt->ip,ip)) {
			return TRUE;
		}
		else {
			akt = akt->next;
		}
	} while (akt != base);
	return FALSE;
}

/*IntrfcExists liefert TRUE,  wenn das If existiert, 
  sonst FALSE*/
/*----------------------------------------------------------------------------*/
int IntrfcExists(struct structConfIf *base,char *intrfc) {
	struct structConfIf *akt;
	
	akt = base;

	if (akt == NULL) return FALSE;

	do { 
		if (DEBUG) printf("IntrfcExists: akt->intrfc: %s, intrfc: %s<br>",akt->intrfc,intrfc);
		if (!strcmp(akt->intrfc,intrfc)) {
			return TRUE;
		}
		else {
			akt = akt->next;
		}
	} while (akt != base);
	return FALSE;
}

/*ipString gibt eine als Number angebene IP als String zurueck*/
/*----------------------------------------------------------------------------*/
char *ipString(unsigned long ip) {
	static char	ip_str[20];

	sprintf(ip_str,"%d.%d.%d.%d",ip >> 24,(ip >> 16) & 255,(ip >> 8) & 255,ip & 255);
	return ip_str; 
}

/*createIp erzeugt aus vier Einzelstrings eine IP*/
/*----------------------------------------------------------------------------*/
int createIp(char* ip,char *ip1, char* ip2, char* ip3, char* ip4) {

	if (isNumber(ip1) && isNumber(ip2) && isNumber(ip3) && isNumber(ip4)) {
		if (((atoi(ip1) >=0) && (atoi(ip1) <=255)) 
			 && ((atoi(ip2) >=0) && (atoi(ip2) <=255)) 
			 && ((atoi(ip3) >=0) && (atoi(ip3) <=255)) 
			 && ((atoi(ip4) >=0) && (atoi(ip4) <=255))) {
			strcpy(ip,ip1);
			strcat(ip,".");
			strcat(ip,ip2);	
			strcat(ip,".");
			strcat(ip,ip3);	
			strcat(ip,".");
			strcat(ip,ip4);
			return 0;	
		} else return IP_RANGE_ERROR;
	} else return IP_NOT_NUMBER;

}

/*isValid prueft, ob ein String nur vorgegebene Zeichen enthaelt*/
/*----------------------------------------------------------------------------*/
int isValid(char* teststring, char* allowed) {
	int i;
	
	for (i=0;i<strlen(teststring);i++) 
		if (strchr(allowed,teststring[i]) == NULL) return FALSE;
	return TRUE;
}


/*get_ticks() liefert einen mehr oder weniger zufaelligen unsigned long*/
/*----------------------------------------------------------------------------*/
unsigned long get_ticks(void)
{
	unsigned long ticks;
	long old_stack = Super(0L);
	ticks = *(volatile unsigned long *)0x4BAL;
	Super((void *)old_stack);
	return ticks;
}

