/******************************************************************************
* Dieses Programm dient zum aendern der Benutzerdaten (/etc/passwd) auf einem *
* Unix-Rechner																						*
******************************************************************************/

/* Die Includes werden gemacht */
/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <support.h>
#include <string.h>
#include "util.h"



/*Lokale Defines */
/*---------------------------------------------------------------------------*/

/*in print-error wird eine Fehlerseite generiert und ausgegeben*/
/*---------------------------------------------------------------------------*/
void print_error(char* error){

	header(NONE,"Fehler");
	printf("%s<br>",error);
	tail();
}


/* In main wird die HTML-Ausgabe initialisiert und alles gesteuert */
/*---------------------------------------------------------------------------*/

void main()
{
	char						*env;						/*Parameterstring der vom Web-Server
	                                       	  kommt*/
	int						error=0;					/*Flag das eine Fehlernummer 
															  enthaelt*/
	char						dummy_str[MAXLINE]; 	/*Fuer String-Ergebnisse, die 
															  uninteressant sind*/
	char						password[PASSWORD_LEN];
	entry						entries[MAXENTRIES];
	int						cl;
	int						x,m;
	int						parameters;
	char						salt[2];					/*Fuer Passwort-Verschluesseln*/
   time_t					tm;						/*Time fuer Passwort*/
	FILE						*helpfile;

	error=0;

	/*debugging*/
	if (DEBUG) header(BENUTZER,"Debug");
   
   /*debugging*/	
   if (DEBUG) printf("Env-Variable lesen\n");
   
	/*Die Benutzereingaben einlesen*/
   env=getenv("CONTENT_LENGTH");
   cl = env?atoi(env):0;
	if (cl == 0) error=NO_INPUT_STRING;
	
	/*debugging*/
	if (DEBUG) printf("cl: %d, Error: %d<br>",cl,error);
	
	/*Hier werden die Daten eingelesen und in einem Feld des typs "entry" abgelegt*/

	if (!error){
    for(x=0;cl && (!feof(stdin));x++) {
        m=x;
        entries[x].val = fmakeword(stdin,'&',&cl);
        plustospace(entries[x].val);
        unescape_url(entries[x].val);
        entries[x].name = makeword(entries[x].val,'=');
    }
   }
   parameters=x;
   
   /*debugging*/
	if (DEBUG) printf("parameters: %d<br>",parameters);
	   
	if (!error) {
		/*Das Passwort wird ausgewertet und codiert*/
		if (!strcmp(entries[0].val,entries[1].val)) {
			time(&tm);
			salt[0] = (tm & 0x0f) +	'A';
			salt[1] = ((tm & 0xf0) >> 4) + 'a';
 			if (strlen(entries[0].val) > 0) strcpy(password,crypt(entries[0].val,salt));
			else strcpy(password,"");
			/*debugging*/
			if (DEBUG) printf("Password: %s<br>",password);
		}
		else error=PASSWORDS_DIFFERENT;
	}	
	
	/*debugging*/
	if (DEBUG) printf("Vor der Aktion: Error: %d<br>",error);
	if (!error) {
		helpfile=fopen(ACCESS_NAME,"wb");
		fprintf(helpfile,"admin:%s\n",password);		
		fclose(helpfile);
		system("chmod 644 " ACCESS_NAME);
   }

	/*debugging*/
	printf("Nach der Aktion: Error: %d<br>",error);
	if (DEBUG) tail();

	if (!DEBUG) {
		if (error == NO_ERROR) {
			header(NONE,"Erfolgreich");
			printf("Die Aktion wurde erfolgreich abgeschlossen");
			tail();
		}
		else
			{
				switch (error) {
					case QUERY_STRING_NOT_SET : print_error("Es wurden keine Parameter empfangen ($QUERY_STRING nicht gesetzt).");
					     break;
					case PASSWORDS_DIFFERENT : print_error("Die eingegebenen Passw&ouml;rter stimmen nicht &uuml;berein.");
					     break;
				}
			}
	}
}
