/******************************************************************************
* allgemeines konfigurieren																   *
* 																										*
******************************************************************************/

/* Die Includes werden gemacht */
/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <support.h>
#include <string.h>
#include <ctype.h>
#include "util.h"



/*Lokale Defines */
/*---------------------------------------------------------------------------*/

/*in print-error wird eine Fehlerseite generiert und ausgegeben*/
/*---------------------------------------------------------------------------*/
void print_error(char* error){

	header(NONE,"Fehler");
	printf("%s\n",error);
	tail();
}



/* In main wird die HTML-Ausgabe initialisiert und alles gesteuert */
/*---------------------------------------------------------------------------*/

void main()
{
	struct structUser		*user_list=NULL;
	struct structConfIf	*confIf_base=NULL;
	struct structConfIf	*akt_confif;
	char						*env;						/*Parameterstring der vom Web-Server
	                                       	  kommt*/
	int						error=0;					/*Flag das eine Fehlernummer 
															  enthaelt*/
	char						dummy_str[MAXLINE]; 	/*Fuer String-Ergebnisse, die 
															  uninteressant sind*/
	char						name[35];
	char						domain[MAXLINE];
	char						dns1[20];
	char						dns2[20];
	char						dns3[20];
	char						workgroup[MAXLINE];
	char						smbguest[MAXLINE];
	char						gw[MAXLINE];
	entry						entries[25];
	int						cl;
	int						x,m,y,i;
	int						parameters,test;
	char						dummy_chr;
	char						cmdstring[MAXLINE];
	FILE						*helpfile;
	FILE						*helpfile2;
	char						gw_if[5];
	char						buf[MAXLINE];
	char						buf_work[MAXLINE];
	char						*found_name;
	char						name_old[MAXLINE];
	char						name_to_search[MAXLINE];
	char						line_end[MAXLINE];



	/*debugging*/
	if (DEBUG) header(NONE,"Debug");
   
   /*debugging*/	
   if (DEBUG) printf("main: Env-Variable lesen<br>\n");
   
	/*Die Benutzereingaben einlesen*/
   env=getenv("CONTENT_LENGTH");
   cl = env?atoi(env):0;
	if (cl == 0) error=NO_INPUT_STRING;
	
	/*debugging*/
	if (DEBUG) printf("main: cl: %d, Error: %d<br>",cl,error);
	
	/*Hier werden die Daten eingelesen und in einem Feld des typs "entry" abgelegt*/

	if (!error){
    for(x=0;cl && (!feof(stdin));x++) {
        m=x;
        entries[x].val = fmakeword(stdin,'&',&cl);
        plustospace(entries[x].val);
        unescape_url(entries[x].val);
        entries[x].name = makeword(entries[x].val,'=');
		  if (DEBUG) printf("%d %s %s<br>",x,entries[x].name,entries[x].val);
    }
   }
   parameters=x;
   
   /*debugging*/
	if (DEBUG) printf("main: parameters: %d<br>",parameters);
	   
	/*Die einzelnen Parameter herausnehmen und ueberpruefen*/

	/*Parsen des Hostnames*/
   if (!error) {
		if (!strlen(entries[0].val)) {
			strcpy(name,"");
		} else {
			if (isValidHostname(entries[0].val)) {
				strcpy(name,entries[0].val);
			} else error=INVALID_HOSTNAME;
		}	
   }
	/*debugging*/
	if (DEBUG) printf("main: Error: %d name: %s<br>",error,name);

	/*Parsen der Domain*/
   if (!error) {
		if (!strlen(entries[1].val)) {
			strcpy(domain,"");
		} else {
			if (isValidHostname(entries[1].val)) {
				strcpy(domain,entries[1].val);
			} else error=INVALID_DOMAIN;
		}	
   }
	/*debugging*/
	if (DEBUG) printf("main: Error: %d domain: %s<br>",error,domain);

	/*Parsen des DNS1*/
   if (!error) {
		if (!strlen(entries[2].val) && !strlen(entries[3].val) && !strlen(entries[4].val) && !strlen(entries[5].val)) {
			strcpy(dns1,"");
		} else {
			error=createIp(dns1,entries[2].val,entries[3].val,entries[4].val,entries[5].val);
		}	
   }
	/*debugging*/
	if (DEBUG) printf("main: Error: %d dns1: %s<br>",error,dns1);

	/*Parsen des DNS2*/
   if (!error) {
		if (!strlen(entries[6].val) && !strlen(entries[7].val) && !strlen(entries[8].val) && !strlen(entries[9].val)) {
			strcpy(dns2,"");
		} else {
			error=createIp(dns2,entries[6].val,entries[7].val,entries[8].val,entries[9].val);
		}	
   }
	/*debugging*/
	if (DEBUG) printf("main: Error: %d dns2: %s<br>",error,dns2);

	/*Parsen des DNS3*/
   if (!error) {
		if (!strlen(entries[10].val) && !strlen(entries[11].val) && !strlen(entries[12].val) && !strlen(entries[13].val)) {
			strcpy(dns3,"");
		} else {
			error=createIp(dns3,entries[10].val,entries[11].val,entries[12].val,entries[13].val);
		}	
   }
	/*debugging*/
	if (DEBUG) printf("main: Error: %d dns3: %s<br>",error,dns3);


	/*Workgroup*/
   if (!error) {
		if (isValid(entries[14].val,"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_-"))
			strcpy(workgroup,entries[14].val);
		else
			error=INVALID_WORKGROUP;
   }
	/*debugging*/
	if (DEBUG) printf("main: Error: %d workgroup: %s<br>",error,workgroup);

   

	/*smbguest*/
   if (!error) {
   	if (strlen(entries[15].val)) {
			error=read_users(&user_list);
			if (UserExists(user_list,entries[15].val) && (user_list != NULL)) strcpy(smbguest,entries[15].val);
			else error=USER_UNKNOWN;
		}
   }
	/*debugging*/
	if (DEBUG) printf("main: Error: %d smbguest: %s<br>",error,smbguest);

 
   
	/*Parsen des Gateways*/
   if (!error) {
		if (!strlen(entries[16].val) && !strlen(entries[17].val) && !strlen(entries[18].val) && !strlen(entries[19].val)) {
			strcpy(gw,"");
			strcpy(gw_if,"");
		} else {
			error=createIp(gw,entries[16].val,entries[17].val,entries[18].val,entries[19].val);
			if (!error) {
				read_confIf(&confIf_base);
				akt_confif = confIf_base;
				strcpy(gw_if,"");
				if (confIf_base != NULL) {
					do {
						if ((ipNumber(gw) & ipNumber(akt_confif->netmask)) == (ipNumber(akt_confif->ip) & ipNumber(akt_confif->netmask))) strcpy(gw_if,akt_confif->intrfc);
						akt_confif = akt_confif->next;
					} while((akt_confif != confIf_base) && !strlen(gw_if));
					if (!strlen(gw_if)) error=INVALID_GATEWAY;
				} else error=INVALID_GATEWAY;
			}
		}	
   }
	/*debugging*/
	if (DEBUG) printf("main: Error: %d gw: %s<br>",error,gw);

	/*Aenderungen ausfuehren*/
	if (!error) {
		if (DEBUG) printf("main: hostname to set: %s<br>\n",name);

		/*Alten Hostname einlesen*/
		helpfile=fopen(HOST_NAME,"r");
		fgets(buf,MAXLINE,helpfile);
		fclose(helpfile);
		getword(name_old,buf,'\n');
		if (DEBUG) printf("main: Alter Hostname: %s<br>\n",name_old);

		/*Setzen des Hostnames*/
		if (strcmp(name,name_old)) {
			/* in /etc/host */
			helpfile=fopen(HOST_NAME,"wb");
			fprintf(helpfile,"%s\n",name);
			fclose(helpfile);
	      
	      /* in /etc/hostname */
			helpfile=fopen(HOSTNAME_NAME,"wb");
			fprintf(helpfile,"%s\n",name);
			fclose(helpfile);
			
			/* in /etc/hosts */
			helpfile=fopen(HOSTS_NAME,"r");
			helpfile2=fopen(HOSTS_NEW_NAME,"wb");
			do {
				if (!feof(helpfile)) {
					fgets(buf,MAXLINE,helpfile);
					if (DEBUG) printf("main: Aus hosts gelesene Zeile: %s<br>",buf);
					strcpy(buf_work,buf);
					remove_whitespaces(buf_work);
	
					/* Den Hostnamen einzeln finden und ersetzen */
					name_to_search[0]='\0';
					strcat(name_to_search," ");
					strcat(name_to_search,name_old);
					strcat(name_to_search," ");
					found_name = strstr(buf_work,name_to_search);
					if (found_name != NULL){
						if (DEBUG) printf("main: Name in Zeile gefunden, Zeile: %s<br>\n",buf_work);
						strcpy(line_end,found_name);
						getword(dummy_str,line_end,' ');
						getword(dummy_str,line_end,' ');
						found_name[0]='\0';
						strcat(buf_work," ");
						strcat(buf_work,name);
						strcat(buf_work," ");
						strcat(buf_work,line_end);
					}
					/*Das ganze nochmal fuer den Fall, dass der Hostname am Zeilenende sitzt*/
					name_to_search[0]='\0';
					strcat(name_to_search," ");
					strcat(name_to_search,name_old);
					strcat(name_to_search,"\n");
					found_name = strstr(buf_work,name_to_search);
					if (found_name != NULL){
						if (DEBUG) printf("main: Name am Zeilenende gefunden, Zeile: %s<br>\n",buf_work);
						found_name[0]='\0';
						strcat(buf_work," ");
						strcat(buf_work,name);
						strcat(buf_work,"\n");
					} 											
	
					/* Den fully qualified Name finden und ersetzen*/
					name_to_search[0]='\0';
					strcat(name_to_search," ");
					strcat(name_to_search,name_old);
					strcat(name_to_search,".");
					found_name = strstr(buf_work,name_to_search);
					if (DEBUG) printf("main: Fully qualified name: %s<br>\n",name_to_search);
					while (found_name != NULL){
						if (DEBUG) printf("main: fully qualified Name gefunden, Zeile: %s<br>\n",buf_work);
						strcpy(line_end,found_name);
						getword(dummy_str,line_end,' ');
						getword(dummy_str,line_end,'.');
						found_name[0]='\0';
						strcat(buf_work," ");
						strcat(buf_work,name);
						strcat(buf_work,".");
						strcat(buf_work,line_end);
						found_name = strstr(buf_work,name_to_search);
					}				

					/*Pruefen ob sich was geaendert hat, wenn ja, die geaenderte Zeile
					  schreiben, sonst die originale*/					
					strcpy(dummy_str,buf);
					remove_whitespaces(dummy_str);
					if (!strcmp(dummy_str,buf_work)) fprintf(helpfile2,"%s",buf);
					else fprintf(helpfile2,"%s",buf_work);
				}
			} while (!feof(helpfile));
			fclose(helpfile);
			fclose(helpfile2);
			system("mv "HOSTS_NEW_NAME" "HOSTS_NAME);
	
	
			/* in mint.cnf */
			helpfile=fopen(MINT_CNF_NAME,"r");
			helpfile2=fopen(MINT_CNF_NEW_NAME,"wb");
			do {
				fgets(buf,MAXLINE,helpfile);
				if (!feof(helpfile)){
					strcpy(buf_work,buf);
					remove_whitespaces(buf_work);
					if (!strncmp("setenv HOSTNAME",buf_work,15))
						fprintf(helpfile2,"setenv HOSTNAME %s\n",name); 
					else
						fprintf(helpfile2,"%s",buf);
				}
			} while(!feof(helpfile));
			fclose(helpfile);
			fclose(helpfile2);
			system("mv "MINT_CNF_NEW_NAME" "MINT_CNF_NAME);
			
		}/*Ende von Hostname setzen*/			

			
		/*Schreiben von /etc/domainname*/
		helpfile=fopen(DOMAINNAME_NAME,"wb");
		fprintf(helpfile,"%s\n",domain);
		fclose(helpfile);

		/*Schreiben von /etc/resolv.conf*/
		helpfile=fopen(RESOLV_CONF_NAME,"wb");
		fprintf(helpfile,"domain %s\n",domain);
		if (strlen(dns1)) fprintf(helpfile,"nameserver %s\n",dns1);
		if (strlen(dns2)) fprintf(helpfile,"nameserver %s\n",dns2);
		if (strlen(dns3)) fprintf(helpfile,"nameserver %s\n",dns3);
		fclose(helpfile);
		
		/*Setzen der Windows-Arbeitsgruppe*/
		helpfile=fopen(SMBWRK_NAME,"wb");
		fprintf(helpfile,"workgroup=%s\n",workgroup);
		fclose(helpfile);
		
		/*Setzen des Samba-Guest-Accounts*/
		helpfile=fopen(SMBGST_NAME,"wb");
		fprintf(helpfile,"guest account=%s\n",smbguest);
		fclose(helpfile);
		
		/*Setzen des defaultgateways*/
		helpfile=fopen(GW_NAME,"wb");
		fprintf(helpfile,"%s %s\n",gw_if,gw);
		fclose(helpfile);
	}


	/*debugging*/
	printf("Nach der Aktion: Error: %d<br>",error);
	if (DEBUG) tail();

	if (!DEBUG) {
		if (error == NO_ERROR) {
			header(NONE,"Erfolgreich!");
			printf("Die Aktion wurde erfolgreich abgeschlossen\n");
			tail();
		}
		else
			{
				switch (error) {
					case QUERY_STRING_NOT_SET : print_error("Es wurden keine Parameter empfangen ($QUERY_STRING nicht gesetzt).");
					     break;
					case USERID_NOT_NUMBER : print_error("Die Benutzernummer ist keine Zahl");
					     break;
					case GROUP_NOT_NUMBER : print_error("Die Gruppennummer ist keine Zahl");
					     break;
					case USER_EXISTS : print_error("Der Benutzer existiert bereits");
				   	  break;
					case USER_UNKNOWN : print_error("Der Benutzer ist unbekannt");
					     break;
					case USERID_EXISTS : print_error("Die Benutzernummer ist bereits vergeben");
					     break;
					case USERID_UNKNOWN : print_error("Die Benutzernummer ist unbekannt");
				   	  break;
					case GROUP_EXISTS : print_error("Die Gruppe existiert bereits");
					     break;
					case GROUP_UNKNOWN : print_error("Die Gruppe ist unbekannt");
					     break;
					case PASSWD_FAILURE : print_error("Die Datei /etc/passwd konnte nicht gelesen/geschrieben werden");
				   	  break;
					case GROUP_FAILURE : print_error("Die Datei /etc/group konnte nicht gelesen/geschrieben werden");
					     break;
					case NO_GROUPNAME_GIVEN : print_error("Sie m&uuml;ssen einen Gruppennamen angeben!");
					     break;
					case NO_ACTION_GIVEN : print_error("Sie m&uuml;ssen hinzuf&uuml;gen, l&ouml;schen oder &auml;ndern ausw&auml;hlen!");
				   	  break;
					case NO_INPUT_STRING : print_error("Es wurden keine Eingaben aus dem Browser empfangen!");
					     break;
					case PASSWORDS_DIFFERENT : print_error("Die eingegebenen Passw&ouml;rter stimmen nicht &uuml;berein.");
					     break;
					case GROUPID_EXISTS : print_error("Diese Gruppennummer existiert bereits.");
					     break;
					case GROUPID_UNKNOWN : print_error("Diese Gruppennummer ist unbekannt.");
					     break;
					case GROUP_IS_HOME : print_error("Die Gruppe ist die Heimatgruppe eines Benutzers, bitte &auml;ndern sie dessen Heimatgruppe bevor sie die Gruppe l&ouml;schen.");
					     break;
					case FILESYS_FAILURE : print_error("Die Filesystemtabelle konnte nicht geladen werden");
						  break;
					case IMPORT_FAILURE : print_error("Die Import-Tabelle konnte nicht geladen werden");
						  break;
					case NO_DRIVE_GIVEN : print_error("Sie haben vergessen einen Partitionsbuchstaben anzugeben");
						  break;
					case NO_VALID_MOUNTPOINT : print_error("Sie haben ein fehlerhaftes Ziel angegeben (ev. ist das Ziel schon vergeben)");
						  break;
					case DRIVE_ALREADY_MOUNTED : print_error("Dieses Laufwerk ist schon angemeldet");
						  break;
					case DRIVE_UNKNOWN : print_error("Dieses Laufwerk ist im System unbekannt");
						  break;
					case IMPORT_ALREADY_MOUNTED : print_error("Dieser Importname ist bereits vergeben und die betreffende Verbindung ist aktiv");
						  break;
					case IMPORT_UNKNOWN : print_error("Dieser Importname ist im System unbekannt");
						  break;
					case MOUNT_FAILED : print_error("Die Verbindung konnte nicht erstellt werden, &uuml;berpr&uuml;fen sie bitte die Parameter und &auml;ndern sie"
					                                " diese gegebenenfalls.");
						  break;
					case NO_SLASHES_ALLOWED : print_error("Der Name des Importes darf keine \" / \" oder \" \\ \" enthalten");
						  break;
					case PATH_UNKNOWN : print_error("Der Exportpfad konnte nicht gefunden werden.");
						  break;
					case SMB_NAME_EXISTS : print_error("Dieser Windows-Name ist bereits vergeben.");
						  break;
					case EXPORT_EXISTS : print_error("Dieser Pfad ist bereits exportiert.");
						  break;
					case EXPORT_UNKNOWN : print_error("Dieser Pfad ist nicht exportiert.");
						  break;
					case SMB_NAME_NOT_SET : print_error("Wenn ein Verzeichnis Windows-kompatibel exportiert werden soll, muss ein Windows-Name angegeben werden.");
						  break;
					case IP_EXISTS : print_error("Diese IP-Nummer ist schon in der Rechnerliste vorhanden.");
						  break;
					case HOSTNAME_MISSING : print_error("Der Rechnername fehlt.");
						  break;
					case HOST_UNKNOWN : print_error("Diese IP-Nummer konnte in der Rechnerliste nicht gefunden werden.");
						  break;
					case IP_RANGE_ERROR : print_error("Bei der IP-Nummer/Netmask sind nur Zahlen von 0-255 erlaubt.");
						  break;
					case IP_NOT_NUMBER : print_error("Die IP-Nummer/Netmask muss eine Zahl sein.");
						  break;
					case INVALID_HOSTNAME : print_error("Der Rechnername enth&auml;t ung&uuml;ltige Zeichen. G&uuml;ltig sind: \"a..z\", \"A..Z\", \".\", \"-\"");
						  break;
					case INVALID_HOSTSTRING : print_error("Die zus&auml;tzlichen Rechnernamen enthalten ung&uuml;ltige Zeichen. G&uuml;ltig sind: \"a..z\", \"A..Z\", \".\", \"-\", \" \"");
						  break;
					case INTRFC_CONFIGURED : print_error("Dieser Netzwerkanschlu&szlig; ist bereits konfiguriert");
						  break;
					case IP_ADDRESS_MISSING : print_error("Die IP-Nummer fehlt");
						  break;
					case HWADDR_MISSING : print_error("Bei Rieblkarten muss die Hardwareadresse der Karte angegeben werden!");
						  break;
					case INTRFC_NOT_CONFIGURED : print_error("Dieser Netzwerkanschlu&szlig; ist nicht konfiguriert");
						  break;
					case HWADDR_NOT_VALID : print_error("Diese Hardware-Adresse ist ung&uuml;ltig");
						  break;
					case INVALID_DOMAIN : print_error("Diese Domain ist nicht g&uuml;ltig (Nur Buchstaben, Zahlen, \".\" und\"-\")");
						  break;
					case INVALID_WORKGROUP : print_error("Diese Windows-Arbeitsgruppe/-Domain ist nicht g&uuml;ltig (Nur Buchstaben, Zahlen, \".\" und\"-\")");
						  break;
					case INVALID_GATEWAY : print_error("Dieses Gateway ist ung&uuml;ltig");
						  break;
				}
			}
	}
}
