/******************************************************************************
* IP-Liste bearbeiten																		   *
* 																										*
******************************************************************************/

/* Die Includes werden gemacht */
/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <support.h>
#include <string.h>
#include <ctype.h>
#include "util.h"



/*Lokale Defines */
/*---------------------------------------------------------------------------*/

/*in print-error wird eine Fehlerseite generiert und ausgegeben*/
/*---------------------------------------------------------------------------*/
void print_error(char* error){

	header(NONE,"Fehler");
	printf("%s\n",error);
	tail();
}


/*in add_host wird ein Host in hosts eingetragen*/
/*---------------------------------------------------------------------------*/
int add_host(struct structHost *host_base,
					char ip[MAXLINE],
             char	name[MAXLINE],
             char addnames[MAXLINE]) {


	/*Variablen*/
   /*-----------------------------------------------------------------------*/
	struct structHost *akt;
	char					*cmdstring;

   /*Prozedurkoerper*/
   /*-----------------------------------------------------------------------*/
   if (HostExists(host_base, ip)) return IP_EXISTS;
   if (!strlen(name)) return HOSTNAME_MISSING;
   
	akt = (struct structHost *) malloc(sizeof(struct structHost));
	strcpy(akt->ip,ip);
	strcpy(akt->names,name);
	strcat(akt->names," ");
	strcat(akt->names,addnames);
	addHost(&host_base,akt);
	return FlushHosts(host_base);
}


/*in delete_host wird ein Host aus hosts geloescht*/
/*---------------------------------------------------------------------------*/
int delete_host(struct structHost *host_base,
					char ip[MAXLINE],
             char	name[MAXLINE],
             char addnames[MAXLINE]) {


	/*Variablen*/
   /*-----------------------------------------------------------------------*/
	struct structHost *akt;
	char					*cmdstring;

   /*Prozedurkoerper*/
   /*-----------------------------------------------------------------------*/
   
   if (!HostExists(host_base,ip)) return HOST_UNKNOWN;
   akt=GetHost(host_base,ip);
   delHost(&host_base,ip); 
	return FlushHosts(host_base);
}




/* In main wird die HTML-Ausgabe initialisiert und alles gesteuert */
/*---------------------------------------------------------------------------*/

void main()
{
	struct structHost		*host_list=NULL;	/*Anker der Exportliste */
	char						*env;						/*Parameterstring der vom Web-Server
	                                       	  kommt*/
	int						error=0;					/*Flag das eine Fehlernummer 
															  enthaelt*/
	char						dummy_str[MAXLINE]; 	/*Fuer String-Ergebnisse, die 
															  uninteressant sind*/
	char						help_str[3];
	char						ip[20];
	char						ip1[4];
	char						ip2[4];
	char						ip3[4];
	char						ip4[4];
	char						name[MAXLINE];
	char						addnames[MAXLINE];
	char						action[32];
	entry						entries[20];
	int						cl;
	int						x,m,y,i;
	int						parameters,test;
	char						dummy_chr;



	/*debugging*/
	if (DEBUG) header(NONE,"Debug");
   
   /*debugging*/	
   if (DEBUG) printf("main: Env-Variable lesen<br>\n");
   
	/*Die Benutzereingaben einlesen*/
   env=getenv("CONTENT_LENGTH");
   cl = env?atoi(env):0;
	if (cl == 0) error=NO_INPUT_STRING;
	
	/*debugging*/
	if (DEBUG) printf("main: cl: %d, Error: %d<br>",cl,error);
	
	/*Hier werden die Daten eingelesen und in einem Feld des typs "entry" abgelegt*/

	if (!error){
    for(x=0;cl && (!feof(stdin));x++) {
        m=x;
        entries[x].val = fmakeword(stdin,'&',&cl);
        plustospace(entries[x].val);
        unescape_url(entries[x].val);
        entries[x].name = makeword(entries[x].val,'=');
		  if (DEBUG) printf("%d %s %s<br>",x,entries[x].name,entries[x].val);
    }
   }
   parameters=x;
   
   /*debugging*/
	if (DEBUG) printf("main: parameters: %d<br>",parameters);
	   
   /*Die Exporte einlesen*/
 	if (!error) error=read_hosts(&host_list);
 
	/*Die einzelnen Parameter herausnehmen und ueberpruefen*/
   /*action wird als erstes ausgewertet, da bei action=aktualisieren
     keine Defaultwerte ermittelt werden duerfen*/
   if (!error) {  
   	if (strcmp(entries[parameters-1].val,"")) strcpy(action,entries[parameters-1].val);
   	else error=NO_ACTION_GIVEN;
   }
	/*debugging*/
	if (DEBUG) printf("main: Error: %d Action: %s<br>",error,action);


	/*Parsen der IP*/
   if (!error) {
		strcpy(ip1,entries[0].val);
		strcpy(ip2,entries[1].val);
		strcpy(ip3,entries[2].val);
		strcpy(ip4,entries[3].val);
		if (isNumber(ip1) && isNumber(ip2) && isNumber(ip3) && isNumber(ip4)) {
				if (((atoi(ip1) >=0) && (atoi(ip1) <=255)) 
				 && ((atoi(ip2) >=0) && (atoi(ip2) <=255)) 
				 && ((atoi(ip3) >=0) && (atoi(ip3) <=255)) 
				 && ((atoi(ip4) >=0) && (atoi(ip4) <=255))) {
					strcpy(ip,ip1);
					strcat(ip,".");
					strcat(ip,ip2);	
					strcat(ip,".");
					strcat(ip,ip3);	
					strcat(ip,".");
					strcat(ip,ip4);	
				} else error=IP_RANGE_ERROR;
		} else error=IP_NOT_NUMBER;
				
   }
	/*debugging*/
	if (DEBUG) printf("main: Error: %d ip: %s<br>",error,ip);

	/*Parsen des Hostnames*/
   if (!error) {
		strcpy(name,entries[4].val);
		if (!isValidHostname(name)) error=INVALID_HOSTNAME;
   }
	/*debugging*/
	if (DEBUG) printf("main: Error: %d name: %s<br>",error,name);

	/*Parsen der zusaetzlichen Hostnames*/
   if (!error) {
		strcpy(addnames,entries[5].val);
		if (!isValidHoststring(addnames)) error=INVALID_HOSTSTRING;
   }
	/*debugging*/
	if (DEBUG) printf("main: Error: %d addnames: %s<br>",error,addnames);


	
	/*debugging*/
	if (DEBUG) printf("Vor der Aktion: Error: %d<br>",error);
	
   		
   /*Hier wird ausgewaehlt, was der User will*/
	
   if (!error){
		if (!strcmp(action,"eintragen")) { 
			if (DEBUG) printf("main: add_host aufrufen<br>");
			error=add_host(host_list, 
			                  ip, name, addnames);
		}
		else { 
			if (!strcmp(action,"entfernen") && !error) {
				if (DEBUG) printf("main: delete_host aufrufen<br>");
					error=delete_host(host_list, 
			                  ip, name, addnames);
			}
		}				
   }
   

	/*debugging*/
	printf("Nach der Aktion: Error: %d<br>",error);
	if (DEBUG) tail();

	if (!DEBUG) {
		if (error == NO_ERROR) {
			header(NONE,"Erfolgreich!");
			printf("Die Aktion wurde erfolgreich abgeschlossen\n");
			tail();
		}
		else
			{
				switch (error) {
					case QUERY_STRING_NOT_SET : print_error("Es wurden keine Parameter empfangen ($QUERY_STRING nicht gesetzt).");
					     break;
					case USERID_NOT_NUMBER : print_error("Die Benutzernummer ist keine Zahl");
					     break;
					case GROUP_NOT_NUMBER : print_error("Die Gruppennummer ist keine Zahl");
					     break;
					case USER_EXISTS : print_error("Der Benutzer existiert bereits");
				   	  break;
					case USER_UNKNOWN : print_error("Der Benutzer ist unbekannt");
					     break;
					case USERID_EXISTS : print_error("Die Benutzernummer ist bereits vergeben");
					     break;
					case USERID_UNKNOWN : print_error("Die Benutzernummer ist unbekannt");
				   	  break;
					case GROUP_EXISTS : print_error("Die Gruppe existiert bereits");
					     break;
					case GROUP_UNKNOWN : print_error("Die Gruppe ist unbekannt");
					     break;
					case PASSWD_FAILURE : print_error("Die Datei /etc/passwd konnte nicht gelesen/geschrieben werden");
				   	  break;
					case GROUP_FAILURE : print_error("Die Datei /etc/group konnte nicht gelesen/geschrieben werden");
					     break;
					case NO_GROUPNAME_GIVEN : print_error("Sie m&uuml;ssen einen Gruppennamen angeben!");
					     break;
					case NO_ACTION_GIVEN : print_error("Sie m&uuml;ssen hinzuf&uuml;gen, l&ouml;schen oder &auml;ndern ausw&auml;hlen!");
				   	  break;
					case NO_INPUT_STRING : print_error("Es wurden keine Eingaben aus dem Browser empfangen!");
					     break;
					case PASSWORDS_DIFFERENT : print_error("Die eingegebenen Passw&ouml;rter stimmen nicht &uuml;berein.");
					     break;
					case GROUPID_EXISTS : print_error("Diese Gruppennummer existiert bereits.");
					     break;
					case GROUPID_UNKNOWN : print_error("Diese Gruppennummer ist unbekannt.");
					     break;
					case GROUP_IS_HOME : print_error("Die Gruppe ist die Heimatgruppe eines Benutzers, bitte &auml;ndern sie dessen Heimatgruppe bevor sie die Gruppe l&ouml;schen.");
					     break;
					case FILESYS_FAILURE : print_error("Die Filesystemtabelle konnte nicht geladen werden");
						  break;
					case IMPORT_FAILURE : print_error("Die Import-Tabelle konnte nicht geladen werden");
						  break;
					case NO_DRIVE_GIVEN : print_error("Sie haben vergessen einen Partitionsbuchstaben anzugeben");
						  break;
					case NO_VALID_MOUNTPOINT : print_error("Sie haben ein fehlerhaftes Ziel angegeben (ev. ist das Ziel schon vergeben)");
						  break;
					case DRIVE_ALREADY_MOUNTED : print_error("Dieses Laufwerk ist schon angemeldet");
						  break;
					case DRIVE_UNKNOWN : print_error("Dieses Laufwerk ist im System unbekannt");
						  break;
					case IMPORT_ALREADY_MOUNTED : print_error("Dieser Importname ist bereits vergeben und die betreffende Verbindung ist aktiv");
						  break;
					case IMPORT_UNKNOWN : print_error("Dieser Importname ist im System unbekannt");
						  break;
					case MOUNT_FAILED : print_error("Die Verbindung konnte nicht erstellt werden, &uuml;berpr&uuml;fen sie bitte die Parameter und &auml;ndern sie"
					                                " diese gegebenenfalls.");
						  break;
					case NO_SLASHES_ALLOWED : print_error("Der Name des Importes darf keine \" / \" oder \" \\ \" enthalten");
						  break;
					case PATH_UNKNOWN : print_error("Der Exportpfad konnte nicht gefunden werden.");
						  break;
					case SMB_NAME_EXISTS : print_error("Dieser Windows-Name ist bereits vergeben.");
						  break;
					case EXPORT_EXISTS : print_error("Dieser Pfad ist bereits exportiert.");
						  break;
					case EXPORT_UNKNOWN : print_error("Dieser Pfad ist nicht exportiert.");
						  break;
					case SMB_NAME_NOT_SET : print_error("Wenn ein Verzeichnis Windows-kompatibel exportiert werden soll, muss ein Windows-Name angegeben werden.");
						  break;
					case IP_EXISTS : print_error("Diese IP-Nummer ist schon in der Rechnerliste vorhanden.");
						  break;
					case HOSTNAME_MISSING : print_error("Der Rechnername fehlt.");
						  break;
					case HOST_UNKNOWN : print_error("Diese IP-Nummer konnte in der Rechnerliste nicht gefunden werden.");
						  break;
					case IP_RANGE_ERROR : print_error("Bei der IP-Nummer sind nur Zahlen von 0-255 erlaubt.");
						  break;
					case IP_NOT_NUMBER : print_error("Die IP-Nummer muss eine Zahl sein.");
						  break;
					case INVALID_HOSTNAME : print_error("Der Rechnername enth&auml;t ung&uuml;ltige Zeichen. G&uuml;ltig sind: \"a..z\", \"A..Z\", \".\", \"-\"");
						  break;
					case INVALID_HOSTSTRING : print_error("Die zus&auml;tzlichen Rechnernamen enthalten ung&uuml;ltige Zeichen. G&uuml;ltig sind: \"a..z\", \"A..Z\", \".\", \"-\", \" \"");
						  break;
				}
			}
	}
}
