/******************************************************************************
* Interfaces konfigurieren																	   *
* 																										*
******************************************************************************/

/* Die Includes werden gemacht */
/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <support.h>
#include <string.h>
#include <ctype.h>
#include "util.h"



/*Lokale Defines */
/*---------------------------------------------------------------------------*/

/*in print-error wird eine Fehlerseite generiert und ausgegeben*/
/*---------------------------------------------------------------------------*/
void print_error(char* error){

	header(NONE,"Fehler");
	printf("%s\n",error);
	tail();
}


/*---------------------------------------------------------------------------*/
int add_intrfc(struct structConfIf *confif_base,
					char intrfc[MAXLINE],
             char	ip[MAXLINE],
             char netmask[MAXLINE],
             char hwaddr[MAXLINE]) {


	/*Variablen*/
   /*-----------------------------------------------------------------------*/
	struct structConfIf *akt;
	char					*cmdstring;
	char					network[MAXLINE];
	char					broadcast[MAXLINE];
	char					iptmp[MAXLINE];
	char					ipbyte_str[5];
	int					ipbyte;
	unsigned long		network_number,broadcast_number,netmask_number;
	FILE					*helpfile;
	char					path[MAXLINE];
	char					hwaddrbyte[5];

   /*Prozedurkoerper*/
   /*-----------------------------------------------------------------------*/

	if (IntrfcExists(confif_base,intrfc)) return INTRFC_CONFIGURED;

	akt = (struct structConfIf *) malloc(sizeof(struct structConfIf));

	strcpy(iptmp,ip);
	if (!strlen(netmask)) {
		getword(ipbyte_str,iptmp,'.');
		ipbyte=atoi(ipbyte_str);
		if (ipbyte >= 192) strcpy(netmask,"255.255.255.0");
		else if (ipbyte >=128) strcpy(netmask,"255.255.0.0");
			else strcpy(netmask,"255.0.0.0");
	}

	strcpy(akt->intrfc,intrfc);
	strcpy(akt->ip,ip);
	strcpy(akt->netmask,netmask);

	network_number = ipNumber(ip) & ipNumber(netmask);
	strcpy(akt->network,ipString(network_number));
	broadcast_number = network_number | ~ipNumber(netmask);
	strcpy(akt->broadcast,ipString(broadcast_number));

	if (DEBUG) printf("add_intrfc: %s<br>\n", akt->intrfc);

	intrfc[3]='\0';
	if (!strcmp(intrfc,"rle")) {
		if (!strlen(hwaddr)) return HWADDR_MISSING;
		sprintf(path,"/etc/%s.hw",akt->intrfc);
		helpfile=fopen(path,"wb");
		fprintf(helpfile,"hwaddr ");
		while (strlen(hwaddr)) {
			getword(hwaddrbyte,hwaddr,':');
			fprintf(helpfile,"0x%s",hwaddrbyte);
			if (strlen(hwaddr)) fprintf(helpfile,":");
			else fprintf(helpfile,"\n");
		}
		fclose(helpfile);
	} else strcpy(akt->hwaddr,"");

	addconfIf(&confif_base,akt);
	return FlushconfIfs(confif_base);
}


/*---------------------------------------------------------------------------*/
int delete_intrfc(struct structConfIf *confif_base,
					char intrfc[MAXLINE],
             char	ip[MAXLINE],
             char netmask[MAXLINE],
             char hwaddr[MAXLINE]) {


	/*Variablen*/
   /*-----------------------------------------------------------------------*/
	struct structConfIf *akt;
	char					cmdstring[MAXLINE];

   /*Prozedurkoerper*/
   /*-----------------------------------------------------------------------*/
   
   if (!IntrfcExists(confif_base,intrfc)) return INTRFC_NOT_CONFIGURED;
	akt=GetconfIf(confif_base,intrfc);
   if (!strncmp(akt->intrfc,"rle",3)) {
   	sprintf(cmdstring,"rm /etc/%s.hw",akt->intrfc);
   	system(cmdstring);
   }
	delconfIf(&confif_base,akt->intrfc);
	return FlushconfIfs(confif_base);
}


/* In main wird die HTML-Ausgabe initialisiert und alles gesteuert */
/*---------------------------------------------------------------------------*/

void main()
{
	struct structConfIf	*intrfc_list=NULL;	/*Anker der Exportliste */
	char						*env;						/*Parameterstring der vom Web-Server
	                                       	  kommt*/
	int						error=0;					/*Flag das eine Fehlernummer 
															  enthaelt*/
	char						dummy_str[MAXLINE]; 	/*Fuer String-Ergebnisse, die 
															  uninteressant sind*/
	entry						entries[20];
	int						cl;
	int						x,m,y,i;
	int						parameters,test;
	char						dummy_chr;
	char						cmdstring[MAXLINE];
	char						action[MAXLINE];
	char						intrfc[MAXLINE];
	char						ip[MAXLINE];
	char						netmask[MAXLINE];
	char						hwaddr[MAXLINE];


	/*debugging*/
	if (DEBUG) header(NONE,"Debug");
   
   /*debugging*/	
   if (DEBUG) printf("main: Env-Variable lesen<br>\n");
   
	/*Die Benutzereingaben einlesen*/
   env=getenv("CONTENT_LENGTH");
   cl = env?atoi(env):0;
	if (cl == 0) error=NO_INPUT_STRING;
	
	/*debugging*/
	if (DEBUG) printf("main: cl: %d, Error: %d<br>",cl,error);
	
	/*Hier werden die Daten eingelesen und in einem Feld des typs "entry" abgelegt*/

	if (!error){
    for(x=0;cl && (!feof(stdin));x++) {
        m=x;
        entries[x].val = fmakeword(stdin,'&',&cl);
        plustospace(entries[x].val);
        unescape_url(entries[x].val);
        entries[x].name = makeword(entries[x].val,'=');
		  if (DEBUG) printf("%d %s %s<br>",x,entries[x].name,entries[x].val);
    }
   }
   parameters=x;
   
   /*debugging*/
	if (DEBUG) printf("main: parameters: %d<br>",parameters);
	   
   /*Die ifs einlesen*/
 	if (!error) error=read_confIf(&intrfc_list);

	/*Die einzelnen Parameter herausnehmen und ueberpruefen*/
   /*action wird als erstes ausgewertet, da bei action=aktualisieren
     keine Defaultwerte ermittelt werden duerfen*/
   if (!error) {  
   	if (strcmp(entries[parameters-1].val,"")) strcpy(action,entries[parameters-1].val);
   	else error=NO_ACTION_GIVEN;
   }
	/*debugging*/
	if (DEBUG) printf("main: Error: %d Action: %s<br>",error,action);

	/*Interface parsen*/
	if (!error) {
		getword(intrfc,entries[0].val,' ');
	}
	/*debugging*/
	if (DEBUG) printf("main: Error: %d intrfc: %s<br>",error,intrfc);

	/*IP-Adresse parsen*/
	if (!error) {
		if (strlen(entries[1].val)+strlen(entries[2].val)+strlen(entries[3].val)+strlen(entries[4].val)) 
			error=createIp(ip,entries[1].val,entries[2].val,entries[3].val,entries[4].val);
		else strcpy(ip,"");
	}
	/*debugging*/
	if (DEBUG) printf("main: Error: %d ip: %s<br>",error,ip);

	/*Netmask parsen*/
	if (!error) {
		if (strlen(entries[5].val)+strlen(entries[6].val)+strlen(entries[7].val)+strlen(entries[8].val))
			error=createIp(netmask,entries[5].val,entries[6].val,entries[7].val,entries[8].val);
		else strcpy(netmask,"");
	}
	/*debugging*/
	if (DEBUG) printf("main: Error: %d netmask: %s<br>",error,netmask);

	/*Hwaddr parsen*/
	if (!error) {
		if (isValid(entries[9].val,"abcdefABCDEF0123456789") &&
			 isValid(entries[10].val,"abcdefABCDEF0123456789") &&
			 isValid(entries[11].val,"abcdefABCDEF0123456789") &&
			 isValid(entries[12].val,"abcdefABCDEF0123456789") &&
			 isValid(entries[13].val,"abcdefABCDEF0123456789") &&
			 isValid(entries[14].val,"abcdefABCDEF0123456789")
		   ) {
		   	if (strlen(entries[9].val) 
		   	    && strlen(entries[10].val) 
		   	    && strlen(entries[11].val) 
		   	    && strlen(entries[12].val) 
		   	    && strlen(entries[13].val) 
		   	    && strlen(entries[14].val))
		   		sprintf(hwaddr,"%s:%s:%s:%s:%s:%s",entries[9].val,entries[10].val,entries[11].val,entries[12].val,entries[13].val,entries[14].val);
				else strcpy(hwaddr,"");
		} else strcpy(hwaddr,"");
	}
	/*debugging*/
	if (DEBUG) printf("main: Error: %d hwaddr: %s<br>",error,hwaddr);


	/*debugging*/
	if (DEBUG) printf("Vor der Aktion: Error: %d<br>",error);

  /*Hier wird ausgewaehlt, was der User will*/
	
   if (!error){
		if (!strcmp(action,"konfigurieren")) { 
			if (DEBUG) printf("main: add_intrfc aufrufen<br>");
			error=add_intrfc(intrfc_list, 
			                  intrfc, ip, netmask, hwaddr);
		}
		else { 
			if (!strcmp(action,"entfernen") && !error) {
				if (DEBUG) printf("main: delete_intrfc aufrufen<br>");
					error=delete_intrfc(intrfc_list, 
			                  intrfc, ip, netmask, hwaddr);
			}
		}				
   }
 

	/*debugging*/
	printf("Nach der Aktion: Error: %d<br>",error);
	if (DEBUG) tail();

	if (!DEBUG) {
		if (error == NO_ERROR) {
			header(NONE,"Erfolgreich!");
			printf("Die Aktion wurde erfolgreich abgeschlossen\n");
			tail();
		}
		else
			{
				switch (error) {
					case QUERY_STRING_NOT_SET : print_error("Es wurden keine Parameter empfangen ($QUERY_STRING nicht gesetzt).");
					     break;
					case USERID_NOT_NUMBER : print_error("Die Benutzernummer ist keine Zahl");
					     break;
					case GROUP_NOT_NUMBER : print_error("Die Gruppennummer ist keine Zahl");
					     break;
					case USER_EXISTS : print_error("Der Benutzer existiert bereits");
				   	  break;
					case USER_UNKNOWN : print_error("Der Benutzer ist unbekannt");
					     break;
					case USERID_EXISTS : print_error("Die Benutzernummer ist bereits vergeben");
					     break;
					case USERID_UNKNOWN : print_error("Die Benutzernummer ist unbekannt");
				   	  break;
					case GROUP_EXISTS : print_error("Die Gruppe existiert bereits");
					     break;
					case GROUP_UNKNOWN : print_error("Die Gruppe ist unbekannt");
					     break;
					case PASSWD_FAILURE : print_error("Die Datei /etc/passwd konnte nicht gelesen/geschrieben werden");
				   	  break;
					case GROUP_FAILURE : print_error("Die Datei /etc/group konnte nicht gelesen/geschrieben werden");
					     break;
					case NO_GROUPNAME_GIVEN : print_error("Sie m&uuml;ssen einen Gruppennamen angeben!");
					     break;
					case NO_ACTION_GIVEN : print_error("Sie m&uuml;ssen hinzuf&uuml;gen, l&ouml;schen oder &auml;ndern ausw&auml;hlen!");
				   	  break;
					case NO_INPUT_STRING : print_error("Es wurden keine Eingaben aus dem Browser empfangen!");
					     break;
					case PASSWORDS_DIFFERENT : print_error("Die eingegebenen Passw&ouml;rter stimmen nicht &uuml;berein.");
					     break;
					case GROUPID_EXISTS : print_error("Diese Gruppennummer existiert bereits.");
					     break;
					case GROUPID_UNKNOWN : print_error("Diese Gruppennummer ist unbekannt.");
					     break;
					case GROUP_IS_HOME : print_error("Die Gruppe ist die Heimatgruppe eines Benutzers, bitte &auml;ndern sie dessen Heimatgruppe bevor sie die Gruppe l&ouml;schen.");
					     break;
					case FILESYS_FAILURE : print_error("Die Filesystemtabelle konnte nicht geladen werden");
						  break;
					case IMPORT_FAILURE : print_error("Die Import-Tabelle konnte nicht geladen werden");
						  break;
					case NO_DRIVE_GIVEN : print_error("Sie haben vergessen einen Partitionsbuchstaben anzugeben");
						  break;
					case NO_VALID_MOUNTPOINT : print_error("Sie haben ein fehlerhaftes Ziel angegeben (ev. ist das Ziel schon vergeben)");
						  break;
					case DRIVE_ALREADY_MOUNTED : print_error("Dieses Laufwerk ist schon angemeldet");
						  break;
					case DRIVE_UNKNOWN : print_error("Dieses Laufwerk ist im System unbekannt");
						  break;
					case IMPORT_ALREADY_MOUNTED : print_error("Dieser Importname ist bereits vergeben und die betreffende Verbindung ist aktiv");
						  break;
					case IMPORT_UNKNOWN : print_error("Dieser Importname ist im System unbekannt");
						  break;
					case MOUNT_FAILED : print_error("Die Verbindung konnte nicht erstellt werden, &uuml;berpr&uuml;fen sie bitte die Parameter und &auml;ndern sie"
					                                " diese gegebenenfalls.");
						  break;
					case NO_SLASHES_ALLOWED : print_error("Der Name des Importes darf keine \" / \" oder \" \\ \" enthalten");
						  break;
					case PATH_UNKNOWN : print_error("Der Exportpfad konnte nicht gefunden werden.");
						  break;
					case SMB_NAME_EXISTS : print_error("Dieser Windows-Name ist bereits vergeben.");
						  break;
					case EXPORT_EXISTS : print_error("Dieser Pfad ist bereits exportiert.");
						  break;
					case EXPORT_UNKNOWN : print_error("Dieser Pfad ist nicht exportiert.");
						  break;
					case SMB_NAME_NOT_SET : print_error("Wenn ein Verzeichnis Windows-kompatibel exportiert werden soll, muss ein Windows-Name angegeben werden.");
						  break;
					case IP_EXISTS : print_error("Diese IP-Nummer ist schon in der Rechnerliste vorhanden.");
						  break;
					case HOSTNAME_MISSING : print_error("Der Rechnername fehlt.");
						  break;
					case HOST_UNKNOWN : print_error("Diese IP-Nummer konnte in der Rechnerliste nicht gefunden werden.");
						  break;
					case IP_RANGE_ERROR : print_error("Bei der IP-Nummer/Netmask sind nur Zahlen von 0-255 erlaubt.");
						  break;
					case IP_NOT_NUMBER : print_error("Die IP-Nummer/Netmask muss eine Zahl sein.");
						  break;
					case INVALID_HOSTNAME : print_error("Der Rechnername enth&auml;t ung&uuml;ltige Zeichen. G&uuml;ltig sind: \"a..z\", \"A..Z\", \".\", \"-\"");
						  break;
					case INVALID_HOSTSTRING : print_error("Die zus&auml;tzlichen Rechnernamen enthalten ung&uuml;ltige Zeichen. G&uuml;ltig sind: \"a..z\", \"A..Z\", \".\", \"-\", \" \"");
						  break;
					case INTRFC_CONFIGURED : print_error("Dieser Netzwerkanschlu&szlig; ist bereits konfiguriert");
						  break;
					case IP_ADDRESS_MISSING : print_error("Die IP-Nummer fehlt");
						  break;
					case HWADDR_MISSING : print_error("Bei Rieblkarten muss die Hardwareadresse der Karte angegeben werden!");
						  break;
					case INTRFC_NOT_CONFIGURED : print_error("Dieser Netzwerkanschlu&szlig; ist nicht konfiguriert");
						  break;
					case HWADDR_NOT_VALID : print_error("Diese Hardware-Adresse ist ung&uuml;ltig");
						  break;
				}
			}
	}
}
