/******************************************************************************
* Aendern von /etc/fstab																	   *
* 																										*
******************************************************************************/

/* Die Includes werden gemacht */
/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <support.h>
#include <string.h>
#include <ctype.h>
#include "util.h"



/*Lokale Defines */
/*---------------------------------------------------------------------------*/

/*in print-error wird eine Fehlerseite generiert und ausgegeben*/
/*---------------------------------------------------------------------------*/
void print_error(char* error){

	header(NONE,"Fehler");
	printf("%s\n",error);
	tail();
}


/*in add_import wird ein Import in fstab eingetragen*/
/*---------------------------------------------------------------------------*/
int update_service_list(struct structService *service_base, 
            	char	*services_to_start) {


	/*Variablen*/
   /*-----------------------------------------------------------------------*/
	struct structService *akt;
	char					akt_service[MAXLINE];

   /*Prozedurkoerper*/
   /*-----------------------------------------------------------------------*/
   
   akt=service_base;
	if (service_base != NULL) {
	   do {
	   	if (DEBUG) printf("update_service_list: Service: %s<br>\n",akt->name);
	   	if (strcmp(akt->name,"portmap")) akt->active=FALSE;
	   	akt = akt->next;
	   } while (akt != service_base);
	} else if (DEBUG) printf("update_service_list: Service_list ist leer?!<br>\n");

	if (DEBUG) printf("update_service_list: services_to_start: %s<br>\n",services_to_start);
	if (services_to_start[0]==',') getword(akt_service,services_to_start,',');	
	if (DEBUG) printf("update_service_list: services_to_start: %s<br>\n",services_to_start);
	
   while (strlen(services_to_start) > 0) {
		if (DEBUG) printf("update_service_list: services_to_start: %s<br>\n",services_to_start);
   	getword(akt_service,services_to_start,',');
		if (DEBUG) printf("update_service_list: akt_service: %s<br>\n",akt_service);
   	akt = GetService(service_base,akt_service);
   	akt->active = TRUE;
   }

	FlushServices(service_base);

}


/* In main wird die HTML-Ausgabe initialisiert und alles gesteuert */
/*---------------------------------------------------------------------------*/

void main()
{
	struct structService	*service_list=NULL;  /*Anker der Service-Liste */
	char						*env;						/*Parameterstring der vom Web-Server
	                                       	  kommt*/
	int						error=0;					/*Flag das eine Fehlernummer 
															  enthaelt*/
	char*						dummy_str;			 	/*Fuer String-Ergebnisse, die 
															  uninteressant sind*/
	char						help_str[3];
	char						services_to_start[MAXLINE];
	char*						name;
	int						cl;
	int						x,m,y;
	int						parameters,test;
	char						dummy_chr;



	/*debugging*/
	if (DEBUG) header(NONE,"Debug");
   
   /*debugging*/	
   if (DEBUG) printf("main: Env-Variable lesen<br>\n");
   
	/*Die Benutzereingaben einlesen*/
   env=getenv("CONTENT_LENGTH");
   cl = env?atoi(env):0;
	if (cl == 0) error=NO_INPUT_STRING;
	
	/*debugging*/
	if (DEBUG) printf("main: cl: %d, Error: %d<br>",cl,error);
	
	strcpy(services_to_start,"");
	dummy_str = (char *) malloc(sizeof(char) * MAXLINE);
	name = (char *) malloc(sizeof(char) * MAXLINE);

	/*Hier werden die Daten eingelesen und in einem Feld des typs "entry" abgelegt*/

	if (!error){
   	for(x=0;cl && (!feof(stdin));x++) {
      	m=x;
      	dummy_str = fmakeword(stdin,'&',&cl);
      	plustospace(dummy_str);
      	unescape_url(dummy_str);
      	name = makeword(dummy_str,'=');
      	strcat(services_to_start,",");
      	strcat(services_to_start,dummy_str);
			if (DEBUG) printf("main: Parameter auswerten: %s<br>",services_to_start);
    }
   }
   parameters=x;
   
   /*debugging*/
	if (DEBUG) printf("main: parameters: %d<br>",parameters);
	   
	/*Die services einlesen*/
	if (!error) error=read_services(&service_list);
  
   /*Die Liste der zu startenden Services wird aktualisiert und geschrieben*/   
	if (DEBUG) printf("main: update wird gestartet.<br>\n");
	if (!error) update_service_list(service_list,services_to_start);   

	/*debugging*/
	if (DEBUG) printf("Nach der Aktion: Error: %d<br>",error);
	if (DEBUG) tail();

	if (!DEBUG) {
		if (error == NO_ERROR) {
			header(NONE,"Erfolgreich!");
			printf("Die Aktion wurde erfolgreich abgeschlossen\n");
			tail();
		}
		else
			{
				switch (error) {
					case QUERY_STRING_NOT_SET : print_error("Es wurden keine Parameter empfangen ($QUERY_STRING nicht gesetzt).");
					     break;
					case USERID_NOT_NUMBER : print_error("Die Benutzernummer ist keine Zahl");
					     break;
					case GROUP_NOT_NUMBER : print_error("Die Gruppennummer ist keine Zahl");
					     break;
					case USER_EXISTS : print_error("Der Benutzer existiert bereits");
				   	  break;
					case USER_UNKNOWN : print_error("Der Benutzer ist unbekannt");
					     break;
					case USERID_EXISTS : print_error("Die Benutzernummer ist bereits vergeben");
					     break;
					case USERID_UNKNOWN : print_error("Die Benutzernummer ist unbekannt");
				   	  break;
					case GROUP_EXISTS : print_error("Die Gruppe existiert bereits");
					     break;
					case GROUP_UNKNOWN : print_error("Die Gruppe ist unbekannt");
					     break;
					case PASSWD_FAILURE : print_error("Die Datei /etc/passwd konnte nicht gelesen/geschrieben werden");
				   	  break;
					case GROUP_FAILURE : print_error("Die Datei /etc/group konnte nicht gelesen/geschrieben werden");
					     break;
					case NO_GROUPNAME_GIVEN : print_error("Sie m&uuml;ssen einen Gruppennamen angeben!");
					     break;
					case NO_ACTION_GIVEN : print_error("Sie m&uuml;ssen hinzuf&uuml;gen, l&ouml;schen oder &auml;ndern ausw&auml;hlen!");
				   	  break;
					case NO_INPUT_STRING : print_error("Es wurden keine Eingaben aus dem Browser empfangen!");
					     break;
					case PASSWORDS_DIFFERENT : print_error("Die eingegebenen Passw&ouml;rter stimmen nicht &uuml;berein.");
					     break;
					case GROUPID_EXISTS : print_error("Diese Gruppennummer existiert bereits.");
					     break;
					case GROUPID_UNKNOWN : print_error("Diese Gruppennummer ist unbekannt.");
					     break;
					case GROUP_IS_HOME : print_error("Die Gruppe ist die Heimatgruppe eines Benutzers, bitte &auml;ndern sie dessen Heimatgruppe bevor sie die Gruppe l&ouml;schen.");
					     break;
					case FILESYS_FAILURE : print_error("Die Filesystemtabelle konnte nicht geladen werden");
						  break;
					case IMPORT_FAILURE : print_error("Die Import-Tabelle konnte nicht geladen werden");
						  break;
					case NO_DRIVE_GIVEN : print_error("Sie haben vergessen einen Partitionsbuchstaben anzugeben");
						  break;
					case NO_VALID_MOUNTPOINT : print_error("Sie haben ein fehlerhaftes Ziel angegeben (ev. ist das Ziel schon vergeben)");
						  break;
					case DRIVE_ALREADY_MOUNTED : print_error("Dieses Laufwerk ist schon angemeldet");
						  break;
					case DRIVE_UNKNOWN : print_error("Dieses Laufwerk ist im System unbekannt");
						  break;
					case IMPORT_ALREADY_MOUNTED : print_error("Dieser Importname ist bereits vergeben und die betreffende Verbindung ist aktiv");
						  break;
					case IMPORT_UNKNOWN : print_error("Dieser Importname ist im System unbekannt");
						  break;
					case MOUNT_FAILED : print_error("Die Verbindung konnte nicht erstellt werden, &uuml;berpr&uuml;fen sie bitte die Parameter und &auml;ndern sie"
					                                " diese gegebenenfalls.");
						  break;
					case NO_SLASHES_ALLOWED : print_error("Dieser Importname ist im System unbekannt");
						  break;
					case AV_SERV_FAILURE : print_error("Fehler beim Bearbeiten von /etc/avail.services");
						  break;
					case NET_SERV_FAILURE : print_error("Fehler beim Bearbeiten von /etc/net.services");
						  break;
					case ADD_SERV_FAILURE : print_error("Fehler beim Bearbeiten von /etc/add.services");
						  break;
					case STD_SERV_FAILURE : print_error("Fehler beim Bearbeiten von /etc/std.services");
						  break;
				}
			}
	}
}
