/******************************************************************************
* Dieses Programm dient zum Auslesen  der Informationen in                    *
* /etc/passwd mithilfe eines cgi-faehigen web-servers und eines Web-Browsers  *
******************************************************************************/

/* Die Includes werden gemacht */
/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <support.h>
#include "util.h"

/* print_filesys() oeffnet /etc/fstab und gibt den Inhalt als HTML-Tabelle aus*/
/*---------------------------------------------------------------------------*/

void print_filesys(void) {
	FILE					*fstab_conv_file;	  /* file-handle fuer das konvertierte 
															fstab*/
	char					host[HOSTNAME_LEN]; /* Hier wird der mit gethostname()
	                                         ermittelte Hostname gespeichert */
	int  					dummy;              /* Wird verwendet wenn ein Funktions-
	                                         ergebnis uninteressant ist */
	char					buf[MAXLINE];		  /* Hier wird eine aus /etc/passwd
	                                         gelesene Zeile gespeichert */
	char					*buf_ptr;			  /* Pointer, der beim zerlegen von buf
	                                         benoetigt wird */
	char					drive[MAXLINE];			/* zu mountendes Drive */
	char					mountpoint[MAXLINE];		/* Mountpoint */
	char					type[MAXLINE];			/* Typ des fs */
	char					owner[MAXLINE];		/* Name des Besitzers */
	char					group[MAXLINE];		/* Name der Gruppe */
	char					permissions[MAXLINE];	/* Name der Gruppe */
	char					*perm_string;			/* Die Verbose-Ausgabe der Berechtigungen */
	char					dummy_str[MAXLINE];  /* unwichtige Strings */

	/*Die Konvertierung der fstab wird von einem sh-skript erledigt*/
	system(CONV_FSTAB_CMD);
	
	if (!(fstab_conv_file=fopen(FSTAB_CONV_NAME,"r"))) {
		printf("<center><strong>Fehler beim oeffnen von /etc/fstab zum lesen der
		        Dateisysteme</strong></center>\n");
		return;
	}
	dummy=gethostname(host,HOSTNAME_LEN);
	/*Die HTML-Tabelle wird erstellt*/
	printf("<center><h2>Lokale Dateisysteme auf %s</h2>\n",host);
	printf("<table border>\n");
	
	/*Tabellenberschriften*/
	printf("<tr>\n");
		printf("<td valign=top>\n");
			printf("<strong>Laufwerk</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Ziel</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Typ</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Besitzer</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Besitzergruppe</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Berechtigungen (Besitzer,&nbsp;Gruppe,&nbsp;Welt)</strong>\n");
		printf("</td>\n");
	printf("</tr>\n");
	
	/*Die Dateisysteme werden gelesen und ausgegeben*/
	
	do{

		/*Einlesen einer Zeile, entspricht einem User*/
		fgets(buf,MAXLINE,fstab_conv_file);

		if (!feof(fstab_conv_file)){
		
			getword(drive,buf,'%');
			/*Wenn drive leer ist handelt es sich um eine Leerzeile*/
			if (strcmp(drive,"")) { 
				strcpy(mountpoint,"");
				getword(mountpoint,buf,'%');
				strcpy(type,"");
				getword(type,buf,'%');
				strcpy(owner,"");
				getword(owner,buf,'%');
				if (!strcmp(owner,"-")) strcpy(owner,"nicht gesetzt");
				strcpy(group,"");
				getword(group,buf,'%');
				if (!strcmp(group,"-")) strcpy(group,"nicht gesetzt");
				strcpy(permissions,"");
				getword(permissions,buf,'.');

				/*Das FS nur ausgeben, wenn es lokal ist*/
				if (strcmp(type,"nfs")) {
					/*Neue Tabellenzeile einfuegen*/
					printf("<tr>");
					printf("<td valign=top>%s</td>",drive);
					printf("<td valign=top>%s</td>",mountpoint);
					printf("<td valign=top>%s</td>",type);
					printf("<td valign=top>%s</td>",owner);
					printf("<td valign=top>%s</td>",group);
					
					if (strcmp(permissions,"-")) {
						/*perm_string = verbose_permissions(permissions);*/
						perm_string=(char *) malloc(sizeof(char) * 254);
						strcpy(perm_string,"rechte");
					}
					else {
						perm_string=(char *) malloc(sizeof(char) * 254);
						strcpy(perm_string,"nicht gesetzt");
					}
					printf("<td valign=top><pre>%s</pre></td>",perm_string);
					printf("</tr>\n");
				}
			}
		}

	}while (!feof(fstab_conv_file));
	
	/*Die Tabelle wird beendet*/
	printf("</table></center>\n");
	fclose(fstab_conv_file);
}


/* In main wird die HTML-Ausgabe initialisiert und alles gesteuert */
/*---------------------------------------------------------------------------*/

void main()
{
	/*Die Menues etc, die ueberall gleich sind werden ausgegeben*/
	header(DATEISYSTEME,"Dateisysteme verwalten");
	
	/*Das Eingabeformular fuer neue Dateisysteme ausgeben*/
	printf("<center>\n"
			 "<form action=\"/admin-bin/filesys_man.html\" method=post>\n"
			 "<table border>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Laufwerk</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"drive\" type=text size=1 maxlength=1>\n"
					"</td>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Zielpfad</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"mountpoint\" type=text size=12 maxlength=128>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Besitzer:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"owner\" type=text size=12 maxlength=32>\n" 
					"</td>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Besitzergruppe:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"group\" type=text size=12 maxlength=32>\n" 
					"</td>\n"
				"</tr>\n"

				"<tr><td colspan=4><img src=\"/admin/img/platzn.gif\" height=5 width=5 alt=\"leer\"></td></tr>\n"

				"<tr>\n"
					"<td valign=top align=left rowspan=2>\n"
						"<strong><big>Berechtigungen:</big></strong>\n"
					"</td>\n"
					"<td valign=top align=center>\n"
						"<strong><big>Besitzer:</big></strong>\n"
					"</td>\n"
					"<td valign=top align=center>\n"
						"<strong><big>Gruppe:</big></strong>\n"
					"</td>\n"
					"<td valign=top align=center>\n"
						"<strong><big>Welt:</big></strong>\n"
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td valign=top>\n"
						"<input type=checkbox name=\"owner_r\" value=\"owner_r\">&nbsp;Lesen<br>\n"
						"<input type=checkbox name=\"owner_w\" value=\"owner_w\">&nbsp;Schreiben<br>\n"
						"<input type=checkbox name=\"owner_x\" value=\"owner_x\">&nbsp;Ausf&uuml;hren<br>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input type=checkbox name=\"group_r\" value=\"group_r\">&nbsp;Lesen<br>\n"
						"<input type=checkbox name=\"group_w\" value=\"group_w\">&nbsp;Schreiben<br>\n"
						"<input type=checkbox name=\"group_x\" value=\"group_x\">&nbsp;Ausf&uuml;hren<br>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input type=checkbox name=\"world_r\" value=\"world_r\">&nbsp;Lesen<br>\n"
						"<input type=checkbox name=\"world_w\" value=\"world_w\">&nbsp;Schreiben<br>\n"
						"<input type=checkbox name=\"world_x\" value=\"world_x\">&nbsp;Ausf&uuml;hren<br>\n"
					"</td>\n"
				"</tr>\n"

				"<tr><td colspan=4><img src=\"/admin/img/platzn.gif\" height=5 width=5 alt=\"leer\"></td></tr>\n"

				"<tr>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Typ:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<select name=\"filesys\" size=2>\n"
							"<option selected>dos\n"
							"<option>minix\n"
						"</select>\n"
					"</td>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Aktion:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<select name=\"action\" size=3>\n"
							"<option selected>eintragen\n"
							"<option>entfernen\n"
							"<option>aktualisieren\n"
						"</select>\n"
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td colspan=4>\n"
						"<ul>\n"
					   "<li><strong>Das Anmelden von Dateisystemen an das System (vgl. Tabelle unten) ist nur bei minix-filesystemen zwingend erforderlich, um beim booten nach einem "
					   "Absturz eine &Uuml;berpr&uuml;fung der Minix-Dateisysteme vornehmen zu k&ouml;nnen.</strong><br>\n"
						"<li><strong>Eintragen:</strong> Notwendig sind Laufwerksbuchstabe und der Typ des Dateisystems (minix / dos).<br>\n"
						"<li><strong>Entfernen:</strong> Es wird nur der Laufwerksbuchstabe beachtet.<br>\n"
						"<li><strong>Aktualisieren:</strong> Notwendig ist der Laufwerksbuchstabe, sonst bitte nur die zu &auml;ndernden Felder ausf&uuml;llen. " 
						"Wenn Berechtigungen ge&auml;ndert werden sollen, bitte alle Berechtigungen neu angeben.<br>\n"
						"</ul>\n"
					"</td>\n"
				"</tr>\n"
			"</table>\n"
			"<p>\n"
			"<input type=submit value=\"Aktion ausf&uuml;hren\">\n"
			"</form>\n");
   printf("<hr>\n");
								
	/*print_filesys erstellt aus /etc/fstab eine HTML-Tabelle
	  und zeigt die eingetragenen lokalen Dateisysteme an*/
	print_filesys();
	
	printf("</center>\n");
	
	/*Tail gibt das bei allen Seiten gleiche Ende der HTML-Anzeige aus*/
	tail();
}
