/******************************************************************************
* Dieses Programm dient zum Auslesen  der Informationen in                    *
* /etc/passwd mithilfe eines cgi-faehigen web-servers und eines Web-Browsers  *
******************************************************************************/

/* Die Includes werden gemacht */
/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <support.h>
#include "util.h"

/* print_printers() gibt die printer-liste aus*/
/*---------------------------------------------------------------------------*/

void print_printers(void) {
	char					host[HOSTNAME_LEN]; /* Hier wird der mit gethostname()
	                                         ermittelte Hostname gespeichert */
	int  					dummy;              /* Wird verwendet wenn ein Funktions-
	                                         ergebnis uninteressant ist */
	char					buf[MAXLINE];		  /* Hier wird eine aus /etc/passwd
	                                         gelesene Zeile gespeichert */
	char					*buf_ptr;			  /* Pointer, der beim zerlegen von buf
	                                         benoetigt wird */
	struct structPrinter	*printer_base=NULL;
	struct structPrinter  *akt;
	int					x;
	
	
	x=read_printers(&printer_base);
	if (DEBUG) printf("print_printers: Ergebnis von read_printers: %d<br>\n",x);

	dummy=gethostname(host,HOSTNAME_LEN);
	/*Die HTML-Tabelle wird erstellt*/
	printf("<center><h2>Angemeldete Drucker auf %s</h2>\n",host);
	printf("<table border>\n");
	
	/*Tabellen&uuml;berschriften*/
	printf("<tr>\n");
		printf("<td valign=top>\n");
			printf("<strong>Name</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Typ</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Druckserver bei Netzwerkdrucker</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Name des Druckers auf dem Druckserver</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>max. Gr&ouml;&szlig;e eines Druckjobs</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Formfeed nach Druckjob</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Leerseite vor Druckjob</strong>\n");
		printf("</td>\n");
	printf("</tr>\n");

	if (printer_base != NULL) {
		akt = printer_base;
		do {
			printf("<tr>\n");
			printf("<td valign=top>%s</td>\n",akt->name);
			if (!strcmp(akt->type,"local")) printf("<td valign=top>Lokaler Drucker</td>\n");
			if (!strcmp(akt->type,"bsd")) printf("<td valign=top>BSD-kompatibler Netzdrucker</td>\n");
			if (!strcmp(akt->type,"smb")) printf("<td valign=top>SMB-kompatibler Netzdrucker</td>\n");
			if (strcmp(akt->rm,"")) printf("<td valign=top>%s</td>\n",akt->rm);	
			else printf("<td valign=top>-</td>\n");
			if (strcmp(akt->rp,"")) printf("<td valign=top>%s</td>\n",akt->rp);	
			else	if (strcmp(akt->rm,"")) printf("<td valign=top>lp</td>\n");
					else printf("<td valign=top>-</td>\n");
			if (akt->mx != -1) 
				if (akt->mx == 0) printf("<td valign=top>kein Limit</td>\n");
				else printf("<td valign=top>%d</td>\n",akt->mx);
			else printf("<td valign=top>default (1000kb)</td>\n");

			if (akt->sf) printf("<td valign=top>nein</td>\n");
			else	printf("<td valign=top>ja</td>\n");

			if (akt->sh) printf("<td valign=top>nein</td>\n");
			else	printf("<td valign=top>ja</td>\n");

			printf("</tr>\n");
			akt = akt->next;			
		} while(akt != printer_base);
	}	
	
	/*Die Tabelle wird beendet*/
	printf("</table></center>\n");
}


/* In main wird die HTML-Ausgabe initialisiert und alles gesteuert */
/*---------------------------------------------------------------------------*/

void main()
{
	/*Die Menues etc, die ueberall gleich sind werden ausgegeben*/
	header(DRUCKER,"Druckerverwaltung");
	
	/*Das Eingabeformular fuer neue Drucker ausgeben*/
	printf("<center>\n"
			 "<form action=\"/admin-bin/printer_man.html\" method=post>\n"
			 "<table border>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Druckername:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"name\" type=text size=12 maxlength=32>\n" 
					"</td>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Druckertyp:</big></strong><sup>1,2</sup>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<select name=\"type\" size=3>\n"
							"<option selected>Default\n"
							"<option>Lokal\n"
							"<option>Netz (bsd)\n"
							"<option>Netz (smb)\n"
						"</select>\n"
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Formfeed nach Druckauftrag:</big></strong><sup>3</sup>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<select name=\"formfeed\" size=3>\n"
							"<option selected>Default\n"
							"<option>ja\n"
							"<option>nein\n"
						"</select>\n"
					"</td>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Leerseite vor Druckauftrag:</big></strong><sup>3</sup>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<select name=\"header\" size=3>\n"
							"<option selected>Default\n"
							"<option>ja\n"
							"<option>nein\n"
						"</select>\n"
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Druckerserver (bei Netzdruckern):</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"printserver\" type=text size=12 maxlength=32>\n" 
					"</td>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Name auf dem Druckserver: </big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"remote_name\" type=text size=12 maxlength=32>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Passwort:</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"password\" type=password size=10 maxlength=15>\n" 
					"</td>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Passwort (Wdh.)</big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"vpassword\" type=password size=10 maxlength=15>\n" 
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td align=right valign=top>\n"
						"<strong><big>Max. Gr&ouml;&szlig;e eines Druckauftrags (in KB): </big></strong>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<input name=\"max\" type=text size=5 maxlength=10>\n" 
					"</td>\n"
					"<td valign=top align=right>\n"
						"<strong><big>Aktion:</big></strong><sup>4,5,6</sup>\n"
					"</td>\n"
					"<td valign=top>\n"
						"<select name=\"action\" size=3>\n"
							"<option selected>eintragen\n"
							"<option>entfernen\n"
							"<option>aktualisieren\n"
						"</select>\n"
					"</td>\n"
				"</tr>\n"
				"<tr>\n"
					"<td colspan=6>\n"
						"<ol>\n"
						"<li><strong>BSD: BSD-Unix-kompatibles Drucksystem (auch f&uuml;r Atari)</strong><br>\n"
						"<li><strong>SMB: Windows-kompatibles Drucksystem.</strong><br>\n"
						"<li><strong>Standardm&auml;&szlig;ig wird der Drucker als Lokaler Drucker angemeldet, es wird keine f&uuml;hrende Leerseite und kein"
						" Formfeed ausgegeben.</strong><br>\n"
					   "<li><strong>Eintragen:</strong>Notwendig ist der Name.<br>\n"
						"<li><strong>Entfernen:</strong>Nur der Name wird beachtet.<br>\n"
						"<li><strong>Aktualisieren:</strong> Notwendig ist der Name, sonst bitte nur die zu &auml;ndernden Werte angeben.<br>\n"
						"</ol>\n"
					"</td>\n"
				"</tr>\n"
			"</table>\n"
			"<p>\n"
			"<input type=submit value=\"Aktion ausf&uuml;hren\">\n"
			"</form>\n");
   printf("<hr>\n");
	printf("</center>\n");
								
	print_printers();
	
	if (DEBUG) printf("Nach der Ausgabe der Tabelle<br>\n");
	
	/*Tail gibt das bei allen Seiten gleiche Ende der HTML-Anzeige aus*/
	tail();
}
