/******************************************************************************
* Dieses Programm dient zum anzeigen der auf einem Unix-Host verfuegbaren     *
* Server-Dienste, die in /etc/avail.services stehen muessen                   *
******************************************************************************/

/* Die Includes werden gemacht */
/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <support.h>
#include "util.h"

/* print_services() gibt die auf dem Host verfuegbaren Dienste als HTML-
   Tabelle aus*/
/*---------------------------------------------------------------------------*/

void print_services(void) {
	char					host[HOSTNAME_LEN]; /* Hier wird der mit gethostname()
	                                         ermittelte Hostname gespeichert */
	int  					dummy;              /* Wird verwendet wenn ein Funktions-
	                                         ergebnis uninteressant ist */
	char					buf[MAXLINE];		  /* Hier wird eine aus /etc/passwd
	                                         gelesene Zeile gespeichert */
	char					*buf_ptr;			  /* Pointer, der beim zerlegen von buf
	                                         benoetigt wird */
	struct structService	*service_base=NULL;
	struct structService *akt;
	int					x;
	
	
	if (read_services(&service_base)) {
		printf("Fehler beim einlesen der Dienste<br>");
	}

	dummy=gethostname(host,HOSTNAME_LEN);
	/*Die HTML-Tabelle wird erstellt*/
	printf("<center><h2>Verf&uuml;gbare Dienste auf %s</h2>\n",host);
	printf("<table border>\n");
	
	/*Tabellen&uuml;berschriften*/
	printf("<tr>\n");
		printf("<td valign=top>\n");
			printf("<strong>Dienst aktiv</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Dienst</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Pfad:</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Parameter</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Typ des Dienstes</strong>\n");
		printf("</td>\n");
		printf("<td valign=top>\n");
			printf("<strong>Beschreibung</strong>\n");
		printf("</td>\n");
	printf("</tr>\n");

	if (service_base != NULL) {
		akt = service_base;
		do {
			printf("<tr>\n");
			if (akt->active) printf("<td align=center><input type=checkbox name=\"%s\" value=\"%s\" checked></td>\n",akt->name,akt->name);
			else printf("<td align=center><input type=checkbox name=\"%s\" value=\"%s\"></td>\n",akt->name,akt->name);
			printf("<td>%s</td>\n",akt->name);
			printf("<td>u:%s</td>\n",akt->path);
			if (strcmp(akt->parameters,"")) printf("<td>%s</td>\n",akt->parameters);
			else printf("<td>keine</td>\n");
			printf("<td>%s</td>\n",akt->type);
			printf("<td>%s</td>\n",akt->comment);
			
			printf("</tr>\n");
			akt = akt->next;			
		} while(akt != service_base);
	}	
	
	/*Die Tabelle wird beendet*/
	printf("</table> <p>"
			"<input type=submit value=\"Dienstliste aktualisieren\">\n"
			"</center>\n");
}


/* In main wird die HTML-Ausgabe initialisiert und alles gesteuert */
/*---------------------------------------------------------------------------*/

void main()
{
	/*Die Menues etc, die ueberall gleich sind werden ausgegeben*/
	header(DIENSTE,"Dienst-Manager");
	
	/*Das Eingabeformular fuer neue Dateisysteme ausgeben*/
	printf("<form action=\"/admin-bin/services_man.html\" method=post>\n");
	print_services();
	printf("</form>\n");

	if (DEBUG) printf("Nach der Ausgabe der Tabelle<br>\n");
	
	/*Tail gibt das bei allen Seiten gleiche Ende der HTML-Anzeige aus*/
	tail();
}
