/*Einige Definitionen die in allen cgi-skripten notwendig sind*/

#include <unistd.h>
#include <osbind.h>
#include <mintbind.h>

#ifndef UTIL_H

#define UTIL_H

#define TRUE 1
#define FALSE 0


/*Bei Debug*/
/*---------------------------------------------------------------------------*/
#define	DEBUG FALSE 



/* Diverse Konstanten */
/*---------------------------------------------------------------------------*/
/*Dateinamen*/
#define	PASSWD_NAME					"/etc/passwd"
#define  GROUP_NAME					"/etc/group"
#define  FSTAB_CONV_NAME			"/tmp/fstab.converted"
#define  FSTAB_BAK_NAME				"/etc/fstab.old"
#define  FSTAB_NAME					"/etc/fstab"
#define  MTAB_NAME					"/etc/mtab"
#define  PRINTCAP_NAME				"/etc/printcap"
#define	HOSTS_NAME					"/etc/hosts"
#define	RCNET_NAME					"/etc/rc.net"
#define	RC_NAME						"/etc/rc"
#define	RCLOCAL_NAME				"/etc/rc.local"
#define	AV_SERV_NAME				"/etc/avail.services"
#define	NET_SERV_NAME				"/etc/net.services"
#define	ADD_SERV_NAME				"/etc/add.services"
#define	STD_SERV_NAME				"/etc/std.services"
#define	NET_SERV_BAK_NAME			"/etc/net.services.old"
#define	ADD_SERV_BAK_NAME			"/etc/add.services.old"
#define	STD_SERV_BAK_NAME			"/etc/std.services.old"
#define	SMB_EXPORTS_NAME			"/usr/local/samba/lib/smb-exports.conf"
#define	NFS_EXPORTS_NAME			"/etc/exports"
#define	NFS_EXPORTS_CONV_NAME	"/tmp/exports.converted"
#define	SMB_EXPORTS_BAK_NAME		"/usr/local/samba/lib/smb-exports.conf.old"
#define	NFS_EXPORTS_BAK_NAME		"/etc/exports.old"
#define	PRINTCAP_NAME				"/etc/printcap"
#define	PRINTCAP_BAK_NAME			"/etc/printcap.old"
#define	SMBPRINT_NAME				"/usr/local/samba/bin/smbprint"
#define	PRINTSPOOL_ROOT			"/var/spool/"
#define	HOSTS_NAME					"/etc/hosts"
#define	HOSTS_BAK_NAME				"/etc/hosts.old"
#define	HOSTS_NEW_NAME				"/etc/hosts.new"
#define	HOSTS_CONV_NAME			"/tmp/hosts.converted"
#define	CONFIF_NAME					"/etc/config.if"
#define	CONFIF_BAK_NAME			"/etc/config.old"
#define	SMBWRK_NAME					"/usr/local/samba/lib/smb-wrk.conf"
#define	SMBGST_NAME					"/usr/local/samba/lib/smb-gst.conf"
#define	SMBWRK_BAK_NAME			"/usr/local/samba/lib/smb-wrk.old"
#define	SMBGST_BAK_NAME			"/usr/local/samba/lib/smb-gst.old"
#define	IFAVAIL_FILE				"/tmp/interfaces"
#define	DOMAIN_FILE					"/tmp/domain"
#define	DNS_FILE						"/tmp/dns"
#define	GW_NAME						"/etc/defaultroute"
#define	ACCESS_NAME					"/etc/admin.access"
#define	HOST_NAME					"/etc/host"
#define	HOSTNAME_NAME				"/etc/hostname"
#define	RESOLV_CONF_NAME			"/etc/resolv.conf"
#define	DOMAINNAME_NAME			"/etc/domainname"
#define	MINT_CNF_NAME				"/c/multitos/mint.cnf"
#define	MINT_CNF_NEW_NAME			"/c/multitos/mintcnf.new"

/*Diverses*/
#define  MAXENTRIES			10
#define  DEFAULTSHELL		"bash"
#define	MAXLINE				255
#define  HOSTNAME_LEN		32
#define	UNAME_LEN			32
#define	LF 					10
#define	CR 					13
#define	ADMIN_CGI			"/usr/local/etc/httpd/htdocs/admin/cgi-bin/"
#define	CONV_FSTAB_CMD		"sh /var/httpd/htdocs/admin/cgi-bin/convert_fstab.sh"
#define	CONV_EXPORTS_CMD	"sh /var/httpd/htdocs/admin/cgi-bin/convert_exports.sh"
#define	CONV_HOSTS_CMD		"sh /var/httpd/htdocs/admin/cgi-bin/convert_hosts.sh"
#define	GETIF_CMD			"sh /usr/etc/getif"
#define	GETDOMAIN_CMD		"sh /usr/etc/domain > /tmp/domain"
#define	GETDNS_CMD			"sh /usr/etc/nameserver > /tmp/dns"
#define	SETDNS_CMD			"sh /usr/etc/nameserver"
#define	SETHNAME_CMD		"sh /usr/etc/sethname"
#define	ADDPRINT_CMD		"sh /var/httpd/htdocs/admin/cgi-bin/add_print_access.sh"
#define  NFS_RESTART_CMD	"sh -c \"/usr/etc/nfs restart\" > /dev/console &"
#define  SMB_RESTART_CMD	"sh -c \"/usr/etc/smb restart\" > /dev/console &"
#define  LPSPOOL_RESTART_CMD	"sh -c \"/usr/etc/nvdispool restart\" > /dev/console &"
#define	DEF_BLOCKSIZE		4096
#define	DEF_RETRANS			5


/*Fehlernummern*/
#define NO_ERROR						0
#define QUERY_STRING_NOT_SET		1
#define USERID_NOT_NUMBER			2
#define GROUP_NOT_NUMBER			3
#define USER_EXISTS					4
#define USER_UNKNOWN					5
#define USERID_EXISTS				6
#define USERID_UNKNOWN				7
#define GROUP_EXISTS					8
#define GROUP_UNKNOWN				9
#define PASSWD_FAILURE				10
#define GROUP_FAILURE				11
#define NO_USERNAME_GIVEN			12
#define NO_ACTION_GIVEN				13
#define NO_INPUT_STRING				14
#define PASSWORDS_DIFFERENT		15
#define GROUPID_EXISTS				16
#define GROUPID_UNKNOWN				17
#define GROUP_IS_HOME				18
#define NO_GROUPNAME_GIVEN			19
#define FILESYS_FAILURE				20
#define IMPORT_FAILURE				21
#define NO_DRIVE_GIVEN				22
#define NO_VALID_MOUNTPOINT		23
#define DRIVE_ALREADY_MOUNTED		24
#define DRIVE_UNKNOWN				25
#define IMPORT_ALREADY_MOUNTED	26
#define IMPORT_UNKNOWN				27
#define MOUNT_FAILED					28
#define NO_SLASHES_ALLOWED			29
#define AV_SERV_FAILURE				30
#define NET_SERV_FAILURE			31
#define ADD_SERV_FAILURE			32
#define STD_SERV_FAILURE			33
#define SMB_EXPORTS_FAILURE		34
#define NFS_EXPORTS_FAILURE		35
#define PATH_UNKNOWN					36
#define SMB_NAME_EXISTS				37
#define EXPORT_EXISTS				38
#define EXPORT_UNKNOWN				39
#define SMB_NAME_NOT_SET			40
#define PRINTCAP_FAILURE			41
#define INVALID_PRINTER_NAME		42
#define INVALID_PRINTSERVER_NAME	43
#define INVALID_REMOTE_PRINTER_NAME	44
#define PRINTER_ALREADY_EXISTS	45
#define SMBCONF_FAILURE				46
#define PRINTER_UNKNOWN				47
#define PRINTSERVER_MISSING		48
#define REMOTENAME_MISSING			49
#define MAX_NOT_NUMBER				50
#define HOSTS_FAILURE				51
#define IP_EXISTS						52
#define HOSTNAME_MISSING			53
#define HOST_UNKNOWN					54
#define IP_RANGE_ERROR				55
#define IP_NOT_NUMBER				56
#define INVALID_HOSTNAME			57
#define INVALID_HOSTSTRING			58
#define CONFIF_FAILURE				59
#define INTRFC_CONFIGURED			60
#define IP_ADDRESS_MISSING			61
#define HWADDR_MISSING				62
#define INTRFC_NOT_CONFIGURED		63
#define HWADDR_NOT_VALID			64
#define INVALID_DOMAIN				65
#define INVALID_WORKGROUP			66
#define INVALID_GATEWAY				67

/*Selektion des eingdrueckten Buttons*/
#define NONE				0
#define BENUTZER			1
#define GRUPPEN			2
#define DATEISYSTEME		3
#define DRUCKER			4
#define DIENSTE			5
#define NETZWERK			6
#define RECHNERLISTE		7
#define EXPORT				8
#define IMPORT				9
#define DOKUMENTATION	10

#define PASSWORD_LEN		14
/* Verschiedene types */
/*---------------------------------------------------------------------------*/

/*Diese Struktur dient dazu, die Daten die vom Web-Browser kommen zu puffern*/
typedef struct {
    char *name;
    char *val;
} entry;

/* Diese Struktur dient dazu die Daten eines Benutzers zu speichern */
typedef struct structUser{
	char	username[UNAME_LEN];
	char	password[MAXLINE];
	long int	uid;
	long int	gid;
	char	gecos[MAXLINE];
	char  homedir[MAXLINE];
	char  shell[MAXLINE];
	struct structUser	*next;
	struct structUser	*prev;
} User;

/* Diese Struktur dient dazu die Daten einer Gruppe zu speichern */
typedef struct structGroup{
	char	groupname[MAXLINE];
	long int   gid;
	char	users[MAXLINE];
	struct structGroup	*next;
	struct structGroup	*prev;
} Group;

/* Diese Struktur dient dazu die Daten eines lokalen Filesystems 
   zu speichern */
typedef struct structFilesys{
	char	drive[MAXLINE];
	char	mountpoint[MAXLINE];
	char	type[MAXLINE];
	char	owner[MAXLINE];
	char	group[MAXLINE];
	char	permissions[MAXLINE];
	struct structFilesys	*next;
	struct structFilesys	*prev;
} Filesys;

/* Diese Struktur dient dazu die Daten eines importierten Filesystems 
   zu speichern */
typedef struct structImport{
	char	server[MAXLINE];
	char	serverpath[MAXLINE];
	char	mountpoint[MAXLINE];
	char	type[MAXLINE];
	int	blocksize;
	int	retries;
	int	mounted;
	int	bootloaded;
	struct structImport	*next;
	struct structImport	*prev;
} Import;

/* Diese Struktur speichert die Daten eines verfuegbaren Dienstes */
typedef struct structService{
	char	name[MAXLINE];
	char	path[MAXLINE];
	char	parameters[MAXLINE];
	char	type[MAXLINE];
	char	comment[MAXLINE];
	int	active;
	struct structService	*next;
	struct structService	*prev;
} Service;

/* Diese Struktur speichert die Daten eines exportierten FS */
typedef struct structExport{
	char smb_name[MAXLINE];
	char path[MAXLINE];
	char nfs_unknown_options[MAXLINE];
	char nfs_common_unknown_options[MAXLINE];
	char smb_unknown_options[MAXLINE];
	int	smb_export;
	int	nfs_export;
	int	nfs_root_access;
	int	read_only;
	int	public;
	int	printable;
	struct structExport	*next;
	struct structExport	*prev;
} Export;

/* Diese Struktur speichert die Daten eines Druckers */
typedef struct structPrinter{
	char	name[MAXLINE];
	char	infilter[MAXLINE];
	char	sd[MAXLINE];
	char	lp[MAXLINE];
	char	rm[MAXLINE];
	char	rp[MAXLINE];
	int	mx;
	int	sf;
	int	sh;
	char	type[10];
	char  unknown_options[1024];
	
	struct structPrinter	*next;
	struct structPrinter	*prev;
} Printer;

/* Diese Struktur speichert die Daten eines Hosts */
typedef struct structHost{
	char	ip[MAXLINE];
	char	names[MAXLINE];
	
	struct structHost	*next;
	struct structHost	*prev;
} Host;


/* Diese Struktur speichert die Daten eines Interfaces */
typedef struct structConfIf{
	char	intrfc[MAXLINE];
	char	ip[MAXLINE];
	char	network[MAXLINE];
	char	netmask[MAXLINE];
	char	broadcast[MAXLINE];
	char	hwaddr[20];
	
	struct structConfIf	*next;
	struct structConfIf	*prev;
} ConfIf;

/*Prototypen*/
/*---------------------------------------------------------------------------*/
void getword(char *word, char *line, char stop);

char *makeword(char *line, char stop);

char *fmakeword(FILE *f, char stop, int *cl);

char x2c(char *what);

void unescape_url(char *url);

void plustospace(char *str);

int rind(char *s, char c);

int getline(char *s, int n, FILE *f);

void send_fd(FILE *f, FILE *fd);

int ind(char *s, char c);

void escape_shell_cmd(char *cmd);

int read_users(struct structUser **base);

int read_groups(struct structGroup **base);

int UserExists(struct structUser *base, char *name);

int GnameExists(struct structGroup *base, char *name);

int UidExists(struct structUser *base, int uid);

int GidExists(struct structGroup *base, int gid);

void header(int pressed_button, char* header);

void tail(void);

int isNumber(char *number_str);

int get_unused_uid(struct structUser *base);

int get_unused_gid(struct structGroup *base);

void new_group(struct structGroup *base,long int gid,char* gname);

int UserInGroup(struct structGroup *group,char* name);

void delUserFromGroup(struct structGroup *group,char* name);

int GroupnameUsed(struct structGroup *base,char *name);

int getGroupId(struct structGroup *base,char *name);

char *getGroupName(struct structGroup *base,long int id);

void addUserToGroup(struct structGroup *group,char* username);

char *verbose_permissions(char *permissions);

int IsValidMountpoint(struct structFilesys *filesys_base, struct structImport *import_base, char *path);

int read_filesys(struct structFilesys **base);

int read_imports(struct structImport **base);

struct structImport *GetImport(struct structImport *base,char *mountpoint_searched);

void backtoforward(char *str);

void addFilesys(struct structFilesys **base,struct structFilesys *filesys);

void addImport(struct structImport **base,struct structImport *import);

char *crypt(const char *key, const char *salt);

int FilesysExistsByMount(struct structFilesys *base,char *mountpoint_searched);

int FilesysExistsByPart(struct structFilesys *base,char *drive_searched);

void FlushFstab(struct structFilesys *filesys_base,struct structImport *import_base);

struct structFilesys *GetFilesys(struct structFilesys *base,char *drive_searched);

int delFilesys(struct structFilesys **base,char *drive_to_delete);

void forwardtoback(char *str);

int delImport(struct structImport **base,char *mount_to_delete);

int ImportMounted(struct structImport *base,char *mountpoint_searched);

int DirExists(char *path);

int read_services(struct structService **base);

int ServiceExists(struct structService *base,char *service_searched);

struct structService *GetService(struct structService *base,char *service_searched);

void addService(struct structService **base,struct structService *service);

int FlushServices(struct structService *service_base);

int read_exports(struct structExport **base);

void remove_whitespaces(char *string);

int ExportExists(struct structExport *base,char *path_searched);

struct structExport *GetExport(struct structExport *base,char *path_searched);

void addExport(struct structExport **base,struct structExport *export);

int smbNameExists(struct structExport *base,char *smb_name);

void replaceChr(char *str,char char1,char char2);

int delExport(struct structExport **base,char *export_to_delete);

int FlushExports(struct structExport *export_base);

int ContainsChr(char *str,char searched_chr);

int read_printers(struct structPrinter **base);

int delPrinter(struct structPrinter **base,char *printer_to_delete);

int PrinterExists(struct structPrinter *base,char *printer_name);

void addPrinter(struct structPrinter **base,struct structPrinter *printer);

int FlushPrinters(struct structPrinter *printer_base);

struct structPrinter *GetPrinter(struct structPrinter *base,char *name_searched);

int read_hosts(struct structHost **base);

void addHost(struct structHost **base,struct structHost *host);

int HostExists(struct structHost *base,char *ip);

struct structHost *GetHost(struct structHost *base,char *ip_searched);

int delHost(struct structHost **base,char *ip_to_delete);

int FlushHosts(struct structHost *host_base);

int isValidHostname(char *hostname);

int isValidHoststring(char *hoststring);

unsigned long ipNumber(char *ip);

int read_confIf(struct structConfIf **base);

void addconfIf(struct structConfIf **base,struct structConfIf *confif);

struct structConfIf *GetconfIf(struct structConfIf *base,char *intrfc_searched);

int delconfIf(struct structConfIf **base,char *intrfc_to_delete);

int FlushconfIfs(struct structConfIf *confif_base);

int IntrfcIpExists(struct structConfIf *base,char *ip);

int IntrfcExists(struct structConfIf *base,char *intrfc);

char *ipString(unsigned long ip);

int createIp(char* ip,char *ip1, char* ip2, char* ip3, char* ip4);

int isValid(char* teststring, char* allowed);

unsigned long get_ticks(void);

#endif
