/*
 * lpspool.c: installs "/dev/<printername>" devices. It is a device you can use
 * to do remote printing with NVDI. All data you copy into /dev/<printername> is piped
 * to the corresponding printer of the lpr system. This is copyrighted software; see the
 * file "COPYING" for details.
 * lpspool.c is based on the lpdev written by Thierry Bousch.
 *
 * This file must be compiled with 16-bit integers.
 *
 * Author: Torsten Lang, Entw.-Bro f. Hard- u. Software
 * Version: 0.1 (September 1997)
 *
 * Revision history:
 *  0.1: First attempt.
 */

#include "test.h"
#define  LP_VERSION	"0.1"

struct kerinfo *kernel;
struct printerinfo printer[MAX_PRINTERS];
int printers = 0;

int main()
{
	FILE *file;
	char *buffer = "U:\\dev\\                                                                 ";
	int j;
	
	Cconws("Trying to open file...\r\n");
	/* open the /etc/printcap file for reading */
	if (!(file = fopen("C:\\etc\\printcap", "r"))) {
		Cconws("lpspool: no /etc/printcap file, device not installed\r\n\r\n");
		return EACCDN;
	}
	Cconws("File opened...\r\n");
	while (printers < MAX_PRINTERS) {
		/* extract a printer's name from /etc/printcap */
		buffer[70] = 0;
	
		for (j = 7; j < 70; j++) {
			if ((buffer[j] = fgetc(file)) == EOF)
				break;
			if ((buffer[j] == 0x20) || (buffer[j] == 0x09)) {
				j--;
				continue;
			}
			if ((buffer[j] == 0x3A) || (buffer[j] == 0x7C)) {
				again:
				while((buffer[j+2] = fgetc(file)) != 0x0A) {
					if (buffer[j+2] == EOF)
						break;
					if ((buffer[j+2] == 0x20) || (buffer[j+2] == 0x09))
						continue;
					buffer[j] = buffer[j+1];
					buffer[j+1] = buffer[j+2];
				}
				if ((buffer[j+1] != 0x3A) || (buffer[j+2] != 0x0A))
					goto again;
				buffer[j] = 0;
				break;
			}
		}
		if (buffer[7] == EOF) break;
       	
		printer[printers].our_lock.l_type   = F_WRLCK;
		printer[printers].our_lock.l_whence =  0;
		printer[printers].our_lock.l_start  =  0L;
		printer[printers].our_lock.l_len    =  0L;
		printer[printers].our_lock.l_pid    = -1;
		printer[printers].open = 0;
		printer[printers].devinfo.driver = &printer[printers].lpspool_device;
		printer[printers].selector = 0L;
       	
			Cconws("lpspool: device /dev/");
			Cconws(&buffer[7]);
			Cconws(" installed\r\n");
		
		printers++;
		if ((buffer[j] == EOF) || (buffer[j+2] == EOF))
			break;
	}
		
	fclose(file);

	return 0;
}

