/*
 * lpspool.h: definitions for lpspool.c
 */

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <osbind.h>
#include <basepage.h>
#include <mintbind.h>
#include "filesys.h"
#include "atarierr.h"

/*
 * We eventually install more than one device depending on the /etc/printcap
 * file, so we need an array for the printers...
 */

#define MAX_PRINTERS 128

struct printerinfo {
	DEVDRV lpspool_device;    /* devinfo            */
	struct dev_descr devinfo;
	struct flock our_lock;
	unsigned short open;      /* flag: file opened? */
	long selector;
};
	
/*
 * kernel functions
 */

#define TGETTIME	(*kernel->dos_tab[0x2c])
#define TGETDATE	(*kernel->dos_tab[0x2a])

#define NAP		(*kernel->nap)
#define SLEEP		(*kernel->sleep)
#define WAKE		(*kernel->wake)
#define WAKESELECT	(*kernel->wakeselect)

/* use the mint functions under ALL circumstances! */
/* #undef Mfpint  uncomment if there kernel handles this */
/* #undef Jenabint  uncomment if the kernel handles this */

/* 
 * Debugging stuff; it can be removed if you want to spare a few bytes
 */

#define DEBUG(x)	(*kernel->debug)x
#define ALERT(x)	(*kernel->alert)x
#define TRACE(x)	(*kernel->trace)x
#define FATAL(x)	(*kernel->fatal)x

/* 
 * different process queues 
 */

#define CURPROC_Q	0
#define READY_Q		1
#define WAIT_Q		2
#define IO_Q		3
#define ZOMBIE_Q	4
#define TSR_Q		5
#define STOP_Q		6
#define SELECT_Q	7

#define spl7()			\
({  register short retvalue;	\
    __asm__ volatile("		\
	movew sr,%0; 		\
	oriw  #0x0700,sr " 	\
    : "=d"(retvalue) 		\
    ); retvalue; })

#define spl(N)			\
({  				\
    __asm__ volatile("		\
	movew %0,sr " 		\
    :				\
    : "d"(N) ); })

