/*******************************************************************/
/* progind (C) 1998 T. Lang                                        */
/* Fortschrittsbalken anzeigen. Gelesen wird von stdin, geschrie-  */
/* ben nach stdout, die Ausgabe erfolgt nach stderr. Als Argument  */
/* wird die Lnge der Datei erwartet.                              */
/* Compilieren mit "gcc -o progind progind.c"                      */
/*******************************************************************/
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

#define nBufferSize 131072

char *progind = "\r0% ]....:....:....:....:....|....:....:....:....:....[ 100%";
char *clrind  = "\r                                                           \r";
size_t tprogind_size;
size_t tclrind_size;
char *buffer;

void ShowPos(unsigned long dwLength, unsigned long dwPos)
{
	unsigned short i;
	unsigned short wActVal = (50*dwPos/dwLength)*2;
	static unsigned short wLastVal = 0;
	
	if (wActVal != wLastVal) {
		for (i = 2; i < 100; i+=2)
			if (wActVal >= i)
				progind[(i>>1)+4] = '#';
			else
				break;
		wLastVal = wActVal;
		fwrite(progind, tprogind_size, 1, stderr);
	}
}

int main(int argc, const char *argv[])
{
        unsigned long dwLength, dwPos, dwCount;
        int iRetVal;
        
        tprogind_size = strlen(progind);
        tclrind_size  = strlen(clrind);
	buffer = malloc(nBufferSize);
        
	if (!buffer)
		return ENOMEM;

        if (argc != 2) {
                iRetVal = E_OK;
                printuseage:
		if (buffer)
			free(buffer);
        	printf("useage: progind <Length>\r\n"
        	       "progind reads input from stdin and passes it to stdout until <Length> bytes\r\n"
        	       "have been read. It outputs a simple progress indicator on stderr.\r\n");
        	return iRetVal;
        } else {
                dwLength = strtoul(argv[1], NULL, 10);
                if (!dwLength) {
                	iRetVal = EERROR;
                	goto printuseage;
                }
                dwPos = 0;
		fwrite(progind, tprogind_size, 1, stderr);
                while (dwLength-dwPos) {
                        dwCount = ((dwLength-dwPos) > nBufferSize) ? nBufferSize : dwLength;
                	if (!(dwCount = fread(buffer, 1, dwCount, stdin)))
                		return EREAD;
                	dwPos += dwCount;
                	if (dwPos > dwLength)
                		dwPos = dwLength;
                	if (dwCount != fwrite(buffer, 1, dwCount, stdout))
                		return EWRITE;
                	ShowPos(dwLength, dwPos);
                }
               	fwrite(clrind, tclrind_size, 1, stderr);
		free(buffer);
		return E_OK;
	}
}
