mkisofs 1.05 written by Eric Youngdale
             ported to MiNT by T. Lang in July 1996

This MiNT port of mkisofs version 1.05 is brought to you by
Torsten Lang (Torsten.Lang@limes.de).

Installing the package is quite easy if you have a Un*x-like MiNT package
installed (e. g. KGMD): Just change to the root directory and do a
tar -xvzf <filename>
where <filename> is the complete path and filename where the archive resides.
If you're using another package (such as MultiTOS or N.AES) you're on your
own...

So what is mkisofs? mkisofs is a ISO9660 formatter, in other words you can
generate ISO9660 images with this piece of software (you need some other
software for burning a CD!). mkisofs supports some nice features like ISO
level 2 and Rockridge extensions. These allow you to use longer filenames
(up to 32 characters for ISO level 2) and to save protection bits to the
CD (Rockridge).

At the moment this does not seem to be too useful for the Atari platform since
the cdrom drivers I know of are as old-fashioned as MS-DOS. You won't be able to
access the data on a cd if ISO level 2 is used! The only driver
allowing at least ISO Level 2 on a normal (MEGA) ST(E) is the cdrom.xfs from
ICD for MiNT - but it needs ICDBOOT which has too many serious bugs to be used
with MiNT and minix.xfs :-/

So if you want to be sure that you can use the CD on your ST even when having
long filenames you should use the ISO level 1 format PLUS Rockridge PLUS
translation tables. This will guarantee that your CD is readable even by a
brain-damaged driver like the original Atari drivers, CD-TOOL, EGON, ICD's
cdrom.xfs...

And - if there will be a METADOS or MiNT/MagiC driver available in the future
that supports things like ISO level 2 or Rockridge your CD will look like the
original file system again.

Using mkisofs: It's quite simple. Just read the man pages - there is all
information you need.

Some hints important for the MiNT version:
- As written above: Be careful using the special features of mkisofs. It's not
  sure that your cdrom software can read such a CD (it's an Atari, not an
  Amiga!).
- mkisofs keeps a lot of structures in memory, so you will need >16MB RAM when
  using features like Rockridge on big filesystems.
- Forget about multisession cds - your burning software has to read the data
  of previous sessions (directory structures) and include it into the next
  session. This does normally NOT work when using "foreign" images (images
  which are not generated by the burning software) or when using extensions
  to the basic ISO level 1 format.
  When appending an image to an existing session you will get a "multivolume"
  cd - that means that there is no connection between the sessions. You need
  a special driver to mount all sessions from such a cd (at the moment the
  Macintosh is the only machine I know of where such software exists).
- I haven't tested mkisofs very intensively but it seems to work. It should
  be used on Minix filesystems preferably but it even seems to work on TOS
  filesystems.

At the moment there is only this binary archive since it is *NOT* possible
to compile it with gcc <2.7.0 for MiNT. At least I was able to compile
it on my Linux68k gcc (2.7.0). Since the MiNT port of this compiler is not yet
available on the net I wasn't able to test if it works. 

The reason for these problems is a bug in gcc <2.7.0 giving back wrong
structure sizes when a structure has an odd length :-(
It would be quite a lot of work to write a workaround for mkisofs so just
forget about compiling it yourself.

Some ideas for the programmers and developers upon you:
- What about a "real" cdrom filesystem supporting all the nice features of
  ISO + RRIP? I didn't find a single working driver (at least NOT for the
  widely spreaded "older" machines like MEGA STs etc.
- Another fine thing would be a driver for mounting an image file as if it were
  a real cd. Why? What about TESTING the images you're generating before
  burning them to a cd? 
